(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[   3320023,      89017]
NotebookOptionsPosition[   3316826,      88949]
NotebookOutlinePosition[   3317223,      88965]
CellTagsIndexPosition[   3317180,      88962]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Definitions", "Section",
 CellChangeTimes->{{3.631785592207478*^9, 
  3.631785605336968*^9}},ExpressionUUID->"1c26d3f8-d1ac-4a1f-906e-\
5efac4bee200"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tprec", "=", "40"}], ";"}], 
  RowBox[{"(*", " ", 
   RowBox[{
   "target", " ", "precision", " ", "for", " ", "interpolated", " ", "Gm"}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tprecmax", "=", "16384"}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "max", " ", "internal", " ", "precision", " ", "used", " ", "to", " ", 
    "evaluate", " ", "Gm"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"prec", "=", 
    RowBox[{"10", "*", "tprec"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "precision", " ", "for", " ", "interpolation", " ", "should", " ", "be", 
    " ", "sufficient", " ", "to", " ", "get", " ", "at", " ", "least", " ", 
    "16", " ", "digits"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"order", "=", "15"}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"polynomial", " ", "order"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"mmax", "=", "36"}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"enough", " ", "to", " ", "use", " ", "9", "Z", " ", "basis"}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"testPrec", "=", "False"}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
     "set", " ", "this", " ", "to", " ", "True", " ", "to", " ", "estimate", 
      " ", "errors"}], " ", "..."}], " ", "slows", " ", "everything", " ", 
    "down", " ", "by", " ", "x5"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"printDebug", "=", "False"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TminLog2", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TmaxLog2", "=", "9"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UminLog10", "=", 
   RowBox[{"-", "7"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UmaxLog10", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<will compute Gm[T,U], m\[Element][-1,\>\"", ",", "mmax", ",", 
    "\"\<], on T\[Element][0,\>\"", ",", 
    RowBox[{"2", "^", 
     RowBox[{"(", 
      RowBox[{"TmaxLog2", "+", "1"}], ")"}]}], ",", "\"\<],U\[Element][\>\"", 
    ",", 
    RowBox[{"10", "^", "UminLog10"}], ",", "\"\<,\>\"", ",", 
    RowBox[{"10", "^", 
     RowBox[{"(", 
      RowBox[{"UmaxLog10", "+", "1"}], ")"}]}], ",", 
    "\"\<], precision will \>\"", ",", 
    RowBox[{"If", "[", 
     RowBox[{"testPrec", ",", "\"\<\>\"", ",", "\"\<NOT \>\""}], "]"}], ",", 
    "\"\<be estimated\>\""}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.742762814790414*^9, 3.74276285547929*^9}, {
   3.742762890002511*^9, 3.742762890539143*^9}, {3.7427629211671743`*^9, 
   3.7427629221444607`*^9}, {3.7427629933012953`*^9, 3.74276299340679*^9}, {
   3.742763024463047*^9, 3.742763024786479*^9}, {3.742763372023538*^9, 
   3.7427633721234627`*^9}, {3.7427636428774147`*^9, 3.742763643080106*^9}, {
   3.742764215418693*^9, 3.742764218150586*^9}, {3.742764313195992*^9, 
   3.742764313367366*^9}, {3.742764348104638*^9, 3.742764348200674*^9}, {
   3.742764414218543*^9, 3.742764416113223*^9}, 3.742765102960291*^9, {
   3.742765312787507*^9, 3.742765334349514*^9}, {3.742765745122888*^9, 
   3.7427657492189302`*^9}, {3.742765854386057*^9, 3.742765858391019*^9}, {
   3.742766122272573*^9, 3.74276612275801*^9}, {3.742766187537434*^9, 
   3.742766187900062*^9}, {3.742766291593989*^9, 3.7427663126188498`*^9}, {
   3.7427808530647163`*^9, 3.7427808532532043`*^9}, {3.7428073676525097`*^9, 
   3.742807448777418*^9}, {3.7428074851886*^9, 3.742807551761373*^9}, {
   3.742808021774563*^9, 3.742808022899118*^9}, {3.7428080581539097`*^9, 
   3.742808058264624*^9}, {3.742911902170772*^9, 3.742911922148844*^9}, {
   3.742913004277212*^9, 3.742913004453404*^9}, {3.7429130694361267`*^9, 
   3.742913090102882*^9}, {3.742913291644978*^9, 3.742913296678021*^9}, {
   3.743152181711075*^9, 3.743152290808125*^9}, 3.743152572076511*^9, {
   3.917362103984454*^9, 3.9173621690071487`*^9}, {3.917362212252632*^9, 
   3.917362219884931*^9}, {3.917362811452249*^9, 3.917362817167618*^9}, {
   3.917363498263295*^9, 3.91736349836481*^9}, {3.917363634364266*^9, 
   3.917363634464443*^9}, {3.917365284613358*^9, 3.91736546999413*^9}, {
   3.917394373608485*^9, 3.917394374131345*^9}, {3.917427086738965*^9, 
   3.917427163056547*^9}, {3.917427309649791*^9, 3.9174273485251904`*^9}, {
   3.917427990852419*^9, 3.917428016682291*^9}, {3.9174284530656137`*^9, 
   3.917428454201033*^9}, {3.9174284843587027`*^9, 3.917428484780007*^9}, 
   3.9174285414579268`*^9, {3.91742872337425*^9, 3.917428724485667*^9}, {
   3.917429244123803*^9, 3.917429249572494*^9}, {3.917429358728945*^9, 
   3.917429369518654*^9}, {3.917430302155798*^9, 3.9174303025254374`*^9}, {
   3.91743307070824*^9, 3.917433071041108*^9}, {3.917433270356542*^9, 
   3.917433273225874*^9}, {3.917433420840582*^9, 3.917433460010796*^9}, {
   3.9174337500654793`*^9, 3.917433750152114*^9}, {3.917433808240944*^9, 
   3.9174338176327553`*^9}, {3.917433942328967*^9, 3.917433943045968*^9}, {
   3.917434075771146*^9, 3.917434076236719*^9}, {3.9174344055640907`*^9, 
   3.917434420922584*^9}, {3.9174347550687923`*^9, 3.91743475555928*^9}},
 CellLabel->
  "In[1795]:=",ExpressionUUID->"ee7f37a3-85f1-43db-9747-eac52a120235"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"will compute Gm[T,U], m\[Element][-1,\"\>", 
   "\[InvisibleSpace]", "36", 
   "\[InvisibleSpace]", "\<\"], on T\[Element][0,\"\>", "\[InvisibleSpace]", 
   "1024", "\[InvisibleSpace]", "\<\"],U\[Element][\"\>", "\[InvisibleSpace]", 
   FractionBox["1", "10000000"], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", "1000", 
   "\[InvisibleSpace]", "\<\"], precision will \"\>", 
   "\[InvisibleSpace]", "\<\"NOT \"\>", 
   "\[InvisibleSpace]", "\<\"be estimated\"\>"}],
  SequenceForm[
  "will compute Gm[T,U], m\[Element][-1,", 36, "], on T\[Element][0,", 1024, 
   "],U\[Element][", 
   Rational[1, 10000000], ",", 1000, "], precision will ", "NOT ", 
   "be estimated"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.917365470825082*^9, 3.917392615572775*^9, 3.917394375247669*^9, 
   3.917423478537763*^9, 3.917427236493985*^9, 3.9174273508973913`*^9, {
   3.917427995985642*^9, 3.9174280170984287`*^9}, 3.917428486807629*^9, 
   3.917428542681705*^9, {3.917429348861228*^9, 3.9174293700754757`*^9}, 
   3.917430139055839*^9, 3.917430303660228*^9, 3.917433275795385*^9, 
   3.917433460762413*^9, 3.917433756655322*^9, 3.9174338989461946`*^9, 
   3.91743398527535*^9, 3.9174340818432302`*^9, 3.917434567670587*^9, {
   3.9174347374478273`*^9, 3.917434756468564*^9}},
 CellLabel->
  "During evaluation of \
In[1795]:=",ExpressionUUID->"e7651957-f40b-43e4-984f-292ec4dcac25"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Evaluate Ten-no function in analytic form to guarantee precision\
\>", "Section",
 CellChangeTimes->{{3.631785592207478*^9, 3.631785605336968*^9}, {
  3.7431522982904387`*^9, 3.743152349081682*^9}, {3.91736491478911*^9, 
  3.91736491624337*^9}},ExpressionUUID->"c24c55e6-e98c-4360-8866-\
08b05abecf3d"],

Cell[CellGroupData[{

Cell["Compute ...", "Subsection",
 CellChangeTimes->{{3.91736492188553*^9, 
  3.917364955562252*^9}},ExpressionUUID->"0ca13e56-c88e-4c72-8db3-\
4dacdac83282"],

Cell["\<\
This takes ~1000 seconds on a 2023 M2Max MBPro for mmax=40 ... grab a \
leisurely coffee\
\>", "Text",
 CellChangeTimes->{{3.743152374115336*^9, 3.743152426360208*^9}, {
   3.743152598504655*^9, 3.743152601398768*^9}, {3.7431527270104237`*^9, 
   3.7431527353163843`*^9}, {3.743152853404661*^9, 3.743152881985073*^9}, {
   3.9173635792730017`*^9, 3.917363608630962*^9}, {3.91736487061156*^9, 
   3.9173648840745363`*^9}, 
   3.917366303542631*^9},ExpressionUUID->"1d8afba0-24a3-4978-8aa7-\
b8bf306972e3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Gm", "[", 
    RowBox[{"m_", ",", "T_", ",", "U_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "t", "}"}], ",", 
     RowBox[{
      RowBox[{"Assert", "[", 
       RowBox[{"m", ">=", 
        RowBox[{"-", "1"}]}], "]"}], ";", 
      RowBox[{"Return", "[", 
       RowBox[{"Assuming", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"T", "\[Element]", "Reals"}], "&&", 
          RowBox[{"U", "\[Element]", "Reals"}], "&&", " ", 
          RowBox[{
           RowBox[{"Re", "[", "T", "]"}], "\[GreaterEqual]", "0"}], "&&", 
          RowBox[{
           RowBox[{"Re", "[", "U", "]"}], "\[GreaterEqual]", "0"}]}], ",", 
         RowBox[{"Integrate", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"t", "^", 
             RowBox[{"(", 
              RowBox[{"2", " ", "m"}], ")"}]}], " ", 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "T"}], " ", 
               RowBox[{"t", "^", "2"}]}], "+", 
              RowBox[{"U", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"1", "/", 
                  RowBox[{"t", "^", "2"}]}]}], ")"}]}]}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "]"}], 
       "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timer", "=", 
   RowBox[{"Timing", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Gm", "[", 
       RowBox[{"m", ",", "T", ",", "U"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", 
        RowBox[{"-", "1"}], ",", "mmax"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Tabulated Ten-no function for m=[-1,\>\"", ",", "mmax", ",", 
    "\"\<] in \>\"", ",", 
    RowBox[{"timer", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", "\"\< seconds\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GmTable", "=", 
   RowBox[{"timer", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.631724847966943*^9, 3.631724849282702*^9}, {
   3.631725025728188*^9, 3.631725082719846*^9}, {3.631725277124423*^9, 
   3.631725474937468*^9}, {3.631725519887945*^9, 3.631725520539823*^9}, {
   3.631725558869402*^9, 3.63172559377052*^9}, {3.631725631762908*^9, 
   3.631725679180015*^9}, {3.631726301325945*^9, 3.631726306768448*^9}, {
   3.631726511418322*^9, 3.6317265196294527`*^9}, {3.631727105386652*^9, 
   3.631727124427184*^9}, {3.631727160412551*^9, 3.63172716168251*^9}, {
   3.6317288643434467`*^9, 3.631728924278867*^9}, {3.742753354373749*^9, 
   3.7427533651021233`*^9}, {3.742753750440608*^9, 3.742753842082946*^9}, {
   3.7427543757100286`*^9, 3.742754380253879*^9}, {3.7427544314466133`*^9, 
   3.742754688102932*^9}, 3.742755432315812*^9, {3.742755625633939*^9, 
   3.742755645778689*^9}, {3.742755723585278*^9, 3.742755872417356*^9}, {
   3.742755903250635*^9, 3.742755908749509*^9}, {3.7427568524002542`*^9, 
   3.742756884816918*^9}, {3.7427570186889057`*^9, 3.7427571659762287`*^9}, {
   3.742757255063735*^9, 3.74275734442767*^9}, {3.742757383030265*^9, 
   3.742757387860334*^9}, {3.742757476000267*^9, 3.742757476439623*^9}, {
   3.742758285412916*^9, 3.742758306170966*^9}, {3.742758608299591*^9, 
   3.742758635220738*^9}, {3.742760771042169*^9, 3.7427607715568027`*^9}, {
   3.742761649666996*^9, 3.742761659645108*^9}, {3.742761717799102*^9, 
   3.742761718531191*^9}, {3.742761775564724*^9, 3.742761784131337*^9}, {
   3.7427638562939777`*^9, 3.742764185275682*^9}, {3.7427650007312183`*^9, 
   3.742765003922306*^9}, {3.7427650640987043`*^9, 3.7427650753786697`*^9}, {
   3.742765261380588*^9, 3.7427652618591623`*^9}, {3.742765429951522*^9, 
   3.742765490987946*^9}, {3.74276554488976*^9, 3.742765550462858*^9}, 
   3.742766185200663*^9, {3.7431523896591673`*^9, 3.7431523978010674`*^9}, {
   3.7431524540032263`*^9, 3.743152583102118*^9}, {3.917362648466151*^9, 
   3.9173626863366623`*^9}, {3.917362721168622*^9, 3.917362793359508*^9}, {
   3.9173634528202887`*^9, 3.917363456054699*^9}, 3.9173634941079283`*^9},
 CellLabel->"In[40]:=",ExpressionUUID->"96de454f-1630-43ee-b110-94612399b6a1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tabulated Ten-no function for m=[-1,\"\>", "\[InvisibleSpace]",
    "40", "\[InvisibleSpace]", "\<\"] in \"\>", "\[InvisibleSpace]", 
   "986.442035`", "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm[
  "Tabulated Ten-no function for m=[-1,", 40, "] in ", 986.442035, " seconds"],
  Editable->False]], "Print",
 CellChangeTimes->{3.9173635688504257`*^9, 3.9173646369092207`*^9},
 CellLabel->
  "During evaluation of \
In[40]:=",ExpressionUUID->"c03f6469-c662-48bb-8264-7cb61c64e9f9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["... or load pre-computed table", "Subsection",
 CellChangeTimes->{{3.917364941275711*^9, 
  3.917364969650084*^9}},ExpressionUUID->"f723cb5f-361a-4e4e-afc0-\
291ebcea0db5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GmTable", "=", 
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "-", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}], "+", 
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          RowBox[{"Erfc", "[", 
           RowBox[{
            SqrtBox["T"], "+", 
            SqrtBox["U"]}], "]"}]}]}], ")"}]}], 
      RowBox[{"4", " ", 
       SqrtBox["U"]}]], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          RowBox[{"Erfc", "[", 
           RowBox[{
            SqrtBox["T"], "-", 
            SqrtBox["U"]}], "]"}], "+", 
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]], " ", 
           RowBox[{"Erfc", "[", 
            RowBox[{
             SqrtBox["T"], "+", 
             SqrtBox["U"]}], "]"}]}]}], ")"}]}], 
       RowBox[{"4", " ", 
        SqrtBox["T"]}]]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"8", " ", 
        SuperscriptBox["T", 
         RowBox[{"3", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "+", 
                RowBox[{"2", " ", 
                 SqrtBox[
                  RowBox[{"T", " ", "U"}]]}]}], ")"}], " ", 
              RowBox[{"Erfc", "[", 
               RowBox[{
                SqrtBox["T"], "-", 
                SqrtBox["U"]}], "]"}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"4", " ", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}], " ", 
            RowBox[{"Erfc", "[", 
             RowBox[{
              SqrtBox["T"], "+", 
              SqrtBox["U"]}], "]"}]}]}], ")"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"16", " ", 
        SuperscriptBox["T", 
         RowBox[{"5", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"], " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{"2", " ", "T"}]}], ")"}]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{"4", " ", "T", " ", "U"}], "+", 
           RowBox[{"6", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"3", "+", 
                RowBox[{"4", " ", "T", " ", "U"}], "+", 
                RowBox[{"6", " ", 
                 SqrtBox[
                  RowBox[{"T", " ", "U"}]]}]}], ")"}], " ", 
              RowBox[{"Erfc", "[", 
               RowBox[{
                SqrtBox["T"], "-", 
                SqrtBox["U"]}], "]"}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"4", " ", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "-", 
              RowBox[{"4", " ", "T", " ", "U"}], "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}], " ", 
            RowBox[{"Erfc", "[", 
             RowBox[{
              SqrtBox["T"], "+", 
              SqrtBox["U"]}], "]"}]}]}], ")"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"32", " ", 
        SuperscriptBox["T", 
         RowBox[{"7", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"], " ", 
         RowBox[{"(", 
          RowBox[{"15", "+", 
           RowBox[{"2", " ", "T", " ", 
            RowBox[{"(", 
             RowBox[{"5", "+", 
              RowBox[{"2", " ", "T"}], "+", 
              RowBox[{"2", " ", "U"}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{"15", "+", 
           RowBox[{"30", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], "+", 
           RowBox[{"8", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"3", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"15", "+", 
                RowBox[{"30", " ", 
                 SqrtBox[
                  RowBox[{"T", " ", "U"}]]}], "+", 
                RowBox[{"8", " ", "T", " ", "U", " ", 
                 RowBox[{"(", 
                  RowBox[{"3", "+", 
                   SqrtBox[
                    RowBox[{"T", " ", "U"}]]}], ")"}]}]}], ")"}], " ", 
              RowBox[{"Erfc", "[", 
               RowBox[{
                SqrtBox["T"], "-", 
                SqrtBox["U"]}], "]"}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"4", " ", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "15"}], "+", 
              RowBox[{"30", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}], "+", 
              RowBox[{"8", " ", "T", " ", "U", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "3"}], "+", 
                 SqrtBox[
                  RowBox[{"T", " ", "U"}]]}], ")"}]}]}], ")"}], " ", 
            RowBox[{"Erfc", "[", 
             RowBox[{
              SqrtBox["T"], "+", 
              SqrtBox["U"]}], "]"}]}]}], ")"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"64", " ", 
        SuperscriptBox["T", 
         RowBox[{"9", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"105", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"105", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"420", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"112", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"32", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"180", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"180", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"32", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"16", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"210", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"210", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"80", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"80", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{"105", "+", 
           RowBox[{"180", " ", "T", " ", "U"}], "+", 
           RowBox[{"16", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"]}], "+", 
           RowBox[{"210", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], "+", 
           RowBox[{"80", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"T", " ", "U"}], ")"}], 
             RowBox[{"3", "/", "2"}]]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "105"}], "-", 
           RowBox[{"180", " ", "T", " ", "U"}], "-", 
           RowBox[{"16", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"]}], "+", 
           RowBox[{"210", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], "+", 
           RowBox[{"80", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"T", " ", "U"}], ")"}], 
             RowBox[{"3", "/", "2"}]]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"128", " ", 
        SuperscriptBox["T", 
         RowBox[{"11", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"945", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"945", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"3780", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"2520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"1008", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"64", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"1680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"1680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"1680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"448", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"64", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"64", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"1890", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1890", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"32", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"32", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"840", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"2", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"945", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"16", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"15", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"840", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"16", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "15"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"945", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"256", " ", 
        SuperscriptBox["T", 
         RowBox[{"13", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"10395", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"10395", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"41580", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"27720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"11088", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"3168", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"18900", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"18900", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"20160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"3360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1344", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"64", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"64", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"20790", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"20790", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"10080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"10080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"64", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"]}], "+", 
           RowBox[{"672", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"5", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"10395", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1260", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"15", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "64"}], " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"]}], "+", 
           RowBox[{"672", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "5"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"10395", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1260", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "15"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"15", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"135135", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"135135", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"540540", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"360360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"144144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"41184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"9152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"1664", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"249480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"249480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"277200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"88704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"19008", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2816", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"50400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"50400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"24192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"1792", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1792", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"270270", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"270270", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"138600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"138600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"12096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"12096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"128", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"14", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"135135", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"27720", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"9", "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2016", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"25", "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"128", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "14"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"135135", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"27720", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "9"}], "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2016", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "25"}], "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", 
         RowBox[{"17", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2027025", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"2027025", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"8108100", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"5405400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"2162160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"617760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"137280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"24960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"3840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"3783780", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"3783780", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"4324320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1441440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"329472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"54912", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"831600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"831600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"443520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"76032", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8448", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"40320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"40320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"9216", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"4054050", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"4054050", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"2162160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"2162160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"221760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"221760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"4608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"4608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"256", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"]}], "+", 
           RowBox[{"2027025", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"540540", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"7", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"55440", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"15", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1152", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"35", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "256"}], " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"]}], "+", 
           RowBox[{"2027025", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1152", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "35"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"55440", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "15"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"540540", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "7"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", 
         RowBox[{"19", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"34459425", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"34459425", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"137837700", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"91891800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"36756720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"10501920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"2333760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"424320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"65280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"8704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"1024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"64864800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"64864800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"75675600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"25945920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6177600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1098240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"149760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"15360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"15135120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"15135120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8648640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1647360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"219648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"19968", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"887040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"887040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"253440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"22528", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"11520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"11520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"68918850", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"68918850", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"37837800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"37837800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"4324320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"4324320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"126720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"126720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"126720", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"7", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"34459425", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2162160", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"7", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"256", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"45", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"5405400", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"12", "+", 
              RowBox[{"7", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"126720", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "7"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"256", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "45"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2162160", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "7"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"34459425", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"5405400", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "12"}], "+", 
              RowBox[{"7", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", 
         RowBox[{"21", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"654729075", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"654729075", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"2618916300", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"1745944200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"698377680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"199536480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"44341440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"8062080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"1240320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"165376", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"19456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"2048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"1240539300", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"1240539300", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"1470268800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"514594080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"126023040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"23337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3394560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"391680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"34816", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"302702400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"302702400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"181621440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"37065600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5491200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"599040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"46080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"20180160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"20180160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6589440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"732160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"53248", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"380160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"380160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"56320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"1024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"1309458150", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1309458150", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"735134400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"735134400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"90810720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"90810720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"3294720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"3294720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"28160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"28160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"1024", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"]}], "+", 
           RowBox[{"654729075", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"14080", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"27", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"30270240", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"10", "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"411840", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"49", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"45945900", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"27", "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "1024"}], " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"]}], "+", 
           RowBox[{"14080", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "27"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"654729075", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"30270240", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "10"}], "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"411840", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "49"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"45945900", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "27"}], "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", 
         RowBox[{"23", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"13749310575", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"13749310575", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"54997242300", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"36664828200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"14665931280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"4190266080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"931170240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"169303680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"26046720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"3472896", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"408576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"43008", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"4096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"26189163000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"26189163000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"31426995600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"11174042880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2793510720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"532097280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"80620800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9922560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"992256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"77824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"6616209600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6616209600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4116752640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"882161280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"140025600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"16972800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1566720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"104448", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"484323840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"484323840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"172972800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"21964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1996800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"122880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"11531520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"11531520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2196480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"133120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"67584", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"67584", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"27498621150", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"27498621150", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"15713497800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"15713497800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"2058376320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"2058376320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"86486400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"86486400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"1098240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"1098240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"2048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"2048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2048", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"33", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"13749310575", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"549120", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"21", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"5237832600", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"5", "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"17297280", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"28", "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"147026880", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"45", "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2048", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "33"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"549120", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "21"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"13749310575", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"5237832600", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "5"}], "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"17297280", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "28"}], "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"147026880", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "45"}], "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", 
         RowBox[{"25", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"316234143225", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"316234143225", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"1264936572900", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"843291048600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"337316419440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"96376119840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"21416915520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"3893984640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"599074560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"79876608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"9397248", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"989184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"94208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"8192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"604969665300", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"604969665300", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"733296564000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"263986763040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"67044257280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"13036383360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2031644160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"260467200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"27783168", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2451456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"172032", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"8192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"157134978000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"157134978000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"100566385920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"22348085760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3724680960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"483724800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"49612800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3969024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"233472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"12350257920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"12350257920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4704860160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"653452800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"67891200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5222400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"278528", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"345945600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"345945600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"76876800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5990400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"307200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"8192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"3075072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3075072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"319488", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"4096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"632468286450", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"632468286450", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"366648282000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"366648282000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"50283192960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"50283192960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"2352430080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"2352430080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"38438400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"38438400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"159744", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"159744", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4096", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"]}], "+", 
           RowBox[{"38438400", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"9", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"316234143225", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"588107520", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"21", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"39936", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"77", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"6285399120", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"25", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"18332414100", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"33", "+", 
              RowBox[{"20", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4096", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"]}], "-", 
           RowBox[{"38438400", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "9"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"316234143225", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"39936", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "77"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"588107520", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "21"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"6285399120", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "25"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"18332414100", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "33"}], "+", 
              RowBox[{"20", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"7905853580625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"7905853580625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"31623414322500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"21082276215000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"8432910486000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"2409402996000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"535422888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"97349616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"14976864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"1996915200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"234931200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"24729600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"2355200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"204800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"15179238874800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"15179238874800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"18552403069200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6746328388800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1734770157120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"342670648320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"54515784960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7188894720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"798766080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"75177984", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5935104", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"376832", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"4033131102000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4033131102000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2639867630400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"603398315520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"104291066880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"14221509120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1562803200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"138915840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"9805824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"516096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"335221286400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"335221286400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"134088514560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"19864965120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2257382400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"198451200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"13230080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"622592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"10585935360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"10585935360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2613811200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"237619200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"15667200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"696320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"123002880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"123002880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"16773120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"737280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"372736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"372736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"15811707161250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"15811707161250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"9276201534600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"9276201534600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"1319933815200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"1319933815200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"67044257280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"67044257280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"1306905600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"1306905600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"8386560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"8386560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"8192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"8192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"67044257280", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"5", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"7905853580625", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"4096", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"91", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2795520", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"44", "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"130690560", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"81", "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"843291048600", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"18", "+", 
              RowBox[{"11", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"73329656400", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"55", "+", 
              RowBox[{"18", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "67044257280"}], " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "5"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"4096", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "91"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"7905853580625", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"2795520", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "44"}], "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"130690560", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "81"}], "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"843291048600", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "18"}], "+", 
              RowBox[{"11", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"73329656400", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "55"}], "+", 
              RowBox[{"18", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"65536", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"213458046676875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"213458046676875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"853832186707500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"569221457805000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"227688583122000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"65053880892000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"14456417976000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"2628439632000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"404375328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"53916710400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"6343142400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"667699200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"63590400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"5529600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"442368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"411104386192500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"411104386192500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"505974629160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"185524030692000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"48188059920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9637611984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1557593856000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"209676096000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"23962982400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2349312000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"197836800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"14131200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"819200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"111314418415200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"111314418415200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"74209612276800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"17347701571200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3084035834880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"436126279680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"50322263040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4792596480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"375889920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"23740416", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1130496", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"9679514644800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"9679514644800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4022655436800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"625746401280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"75848048640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7293081600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"555663360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"32686080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1376256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"335221286400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"335221286400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"89392343040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9029529600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"694579200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"39690240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1556480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"4704860160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4704860160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"760381440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"43868160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1671168", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"22364160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"22364160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1720320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"16384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"426916093353750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"426916093353750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"252987314580000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"252987314580000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"37104806138400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"37104806138400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"2011327718400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"2011327718400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"44696171520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"44696171520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"380190720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"380190720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"860160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"860160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"16384", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"]}], "+", 
           RowBox[{"37104806138400", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"3", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"860160", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"26", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"213458046676875", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"22348085760", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"15", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"31623414322500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"13", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"47523840", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"99", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"125707982400", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"77", "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"16384", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"]}], "-", 
           RowBox[{"860160", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "26"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"37104806138400", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"22348085760", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "15"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"213458046676875", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"47523840", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "99"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"31623414322500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "13"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"125707982400", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "77"}], "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"6190283353629375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"6190283353629375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"24761133414517500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"16507422276345000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"6602968910538000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"1886562545868000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"419236121304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"76224749328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"11726884512000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"1563584601600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"183951129600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"19363276800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"1844121600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"160358400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"12828672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"950272", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"11953650613905000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"11953650613905000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"14799757902930000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5464525994928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1431185379624000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"289128359520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"47311913376000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6470005248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"754833945600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"76117708800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6676992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"508723200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"33177600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1769472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"3288835089540000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3288835089540000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2226288368304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"530068659120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"96376119840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"14018344704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1677408768000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"167740876800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"14095872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"989184000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"56524800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2457600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"296838449107200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"296838449107200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"127216478188800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"20560238899200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2616757678080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"268385402880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"22365450240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1503559680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"79134720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3014656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"11062302451200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"11062302451200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3128732006400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"341316218880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"29172326400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1944821760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"98058240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3440640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"178784686080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"178784686080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"32506306560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2222653440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"111132672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3735552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"1140572160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1140572160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"116981760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3899392", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"1966080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1966080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"12380566707258750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"12380566707258750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"7399878951465000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"7399878951465000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"1113144184152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"1113144184152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"63608239094400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"63608239094400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"1564366003200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"1564366003200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"16253153280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"16253153280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"58490880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"58490880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"32768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"16253153280", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"11", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"32768", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"60", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"6190283353629375", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"29245440", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"39", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"21202746364800", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"14", "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"569221457805000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"21", "+", 
              RowBox[{"13", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"111740428800", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"99", "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"50597462916000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"65", "+", 
              RowBox[{"22", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "32768"}], " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "60"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"16253153280", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "11"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"29245440", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "39"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"6190283353629375", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"21202746364800", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "14"}], "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"569221457805000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "21"}], "+", 
              RowBox[{"13", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"111740428800", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "99"}], "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"50597462916000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "65"}], "+", 
              RowBox[{"22", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"191898783962510625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"191898783962510625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"767595135850042500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"511730090566695000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"204692036226678000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"58483438921908000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"12996319760424000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"2362967229168000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"363533419872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"48471122649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"5702485017600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"600261580800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"57167769600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"4971110400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"397688832", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"29458432", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"2031616", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"371417001217762500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"371417001217762500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"462207823737660000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"171677191673988000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"45277501100832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9223194668688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1524494986560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"211083921216000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"25017353625600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2575315814400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"232359321600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"18441216000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1282867200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"76972032", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3801088", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"103598305320510000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"103598305320510000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"71038837934064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"17174224555488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3180411954720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"473119133760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"58230047232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6038671564800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"532823961600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"40061952000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2543616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"132710400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5308416", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"9647249595984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"9647249595984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4240549272960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"706758212160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"93455631360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"10064452608000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"894618009600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"65780736000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3956736000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"188416000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6553600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"381649434566400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"381649434566400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"113081313945600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"13083788390400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1207734312960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"89461800960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5262458880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"237404160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"7536640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"6883210414080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"6883210414080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1365264875520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"105020375040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"6223429632", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"274563072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8257536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"54177177600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"54177177600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"6667960320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"296353792", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8716288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"150405120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"150405120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"8912896", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"65536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"383797567925021250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"383797567925021250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"231103911868830000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"231103911868830000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"35519418967032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"35519418967032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"2120274636480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"2120274636480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"56540656972800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"56540656972800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"682632437760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"682632437760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"3333980160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"3333980160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"4456448", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"4456448", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"65536", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"]}], "+", 
           RowBox[{"191898783962510625", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"14135164243200", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"27", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"833495040", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"65", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1114112", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"135", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2959951580586000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"35", "+", 
              RowBox[{"12", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"56886036480", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"121", "+", 
              RowBox[{"12", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"106013731824000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"91", "+", 
              RowBox[{"20", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"8253711138172500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"45", "+", 
              RowBox[{"28", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"65536", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"]}], "-", 
           RowBox[{"191898783962510625", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"1114112", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "135"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"833495040", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "65"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"14135164243200", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "27"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"56886036480", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "121"}], "+", 
              RowBox[{"12", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"2959951580586000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "35"}], "+", 
              RowBox[{"12", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"106013731824000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "91"}], "+", 
              RowBox[{"20", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"8253711138172500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "45"}], "+", 
              RowBox[{"28", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"6332659870762850625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"6332659870762850625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"25330639483051402500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"16887092988700935000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"6754837195480374000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"1929953484422964000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"428878552093992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"77977918562544000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"11996602855776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"1599547047436800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"188182005580800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"19808632166400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"1886536396800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"164046643200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"13123731456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"972128256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"67043328", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"4325376", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"12281522173600680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"12281522173600680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"15351902717000850000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5731377014346984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1520569411969608000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"311911674250176000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"51985279041696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7270668397440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"872480207692800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"91239760281600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"8403662131200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"686013235200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"49711104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3181510656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"176750592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"8126464", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"3466558678032450000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3466558678032450000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2403480683435832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"588607514310816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"110678336024256000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"16769444852160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2110839212160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"225156182630400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"20602526515200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1626515251200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"110647296000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6414336000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"307888128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"11403264", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"331514577025632000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"331514577025632000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"148843279480896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"25443295637760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3469540314240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"388200314880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"36232029388800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2841727795200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"186955776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"10174464000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"442368000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"14155776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"13781785137120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"13781785137120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4240549272960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"514005972480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"50322263040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4025781043200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"263122944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"13848576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"565248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"16384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"271395153469440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"271395153469440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"57568668917760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4830937251840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"322062483456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"16839868416", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"664731648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"18087936", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"2502985605120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2502985605120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"350067916800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"18670288896", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"732168192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"19267584", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"9525657600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"9525657600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"762052608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"19922944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"10027008", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"10027008", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"12665319741525701250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"12665319741525701250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"7675951358500425000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"7675951358500425000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"1201740341717916000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"1201740341717916000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"74421639740448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"74421639740448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"2120274636480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"2120274636480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"28784334458880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"28784334458880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"175033958400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"175033958400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"381026304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"381026304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"131072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"381026304", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"25", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"6332659870762850625", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1060137318240000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"13", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"65536", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"153", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1535190271700085000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"8", "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"4112047779840", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"66", "+", 
              RowBox[{"7", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"17503395840", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"143", "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"6765603612768000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"49", "+", 
              RowBox[{"11", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"46220782373766000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"75", "+", 
              RowBox[{"26", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "381026304"}], " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "25"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"65536", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "153"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"1060137318240000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "13"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"6332659870762850625", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"1535190271700085000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "8"}], "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"4112047779840", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "66"}], "+", 
              RowBox[{"7", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"17503395840", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "143"}], "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"6765603612768000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "49"}], "+", 
              RowBox[{"11", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"46220782373766000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "75"}], "+", 
              RowBox[{"26", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"221643095476699771875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"221643095476699771875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"886572381906799087500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"591048254604532725000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"236419301841813090000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"67548371954803740000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"15010749323289720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"2729227149689040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"419881099952160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"55984146660288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"6586370195328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"693302125824000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"66028773888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"5741632512000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"459330600960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"34024488960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"2346516480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"151388160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"9175040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"430620871211873842500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"430620871211873842500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"540386975638429920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"202645115864411220000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"54038697563842992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"11150842354443792000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1871470045501056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"263925262827072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"31990940948736000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3387276100454400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"316938114662400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"26411509555200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1968559718400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"131237314560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7777026048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"402259968", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"17301504", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"122815221736006800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"122815221736006800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"85970655215204760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"21287971767574512000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4054851765252288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"623823348500352000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"79977352371840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8724802076928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"821157842534400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"67229297049600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4802092646400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"298266624000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"15907553280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"707002368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"24379392", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"12017403417179160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"12017403417179160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5493670133567616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"959212245543552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"134155558817280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"15479487555840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1501041217536000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"123615159091200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8674748006400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"516354048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"25657344000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1026293760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"30408704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"520951478183136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"520951478183136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"165381421645440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"20817241885440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2135101731840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"181160146944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"12787775078400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"747823104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"35610624000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1327104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"35389440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"11025428109696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"11025428109696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2467228667904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"221417957376000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"16103124172800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"947242598400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"44315443200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1582694400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"39321600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"115137337835520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"115137337835520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"17713436590080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1073541611520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"50519605248", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1772617728", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"42205184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"550106726400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"550106726400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"53343682560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1882718208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"44040192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"952565760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"952565760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"44826624", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"262144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"443286190953399543750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"443286190953399543750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"270193487819214960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"270193487819214960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"42985327607602380000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"42985327607602380000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"2746835066783808000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"2746835066783808000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"82690710822720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"82690710822720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"1233614333952000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"1233614333952000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"8856718295040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"8856718295040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"26671841280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"26671841280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"22413312", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"22413312", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"262144", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"]}], "+", 
           RowBox[{"8856718295040", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"13", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"221643095476699771875", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"11206656", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"85", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"6140761086800340000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"20", "+", 
              RowBox[{"7", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"343354383347976000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"35", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"3333980160", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"165", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"8269071082272000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"63", "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"77100895872000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"143", "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"8443546494350467500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"51", "+", 
              RowBox[{"32", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"262144", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"]}], "-", 
           RowBox[{"8856718295040", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "13"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"11206656", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "85"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"221643095476699771875", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"6140761086800340000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "20"}], "+", 
              RowBox[{"7", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"3333980160", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "165"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"343354383347976000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "35"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"8269071082272000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "63"}], "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"77100895872000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "143"}], "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"8443546494350467500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "51"}], "+", 
              RowBox[{"32", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"8200794532637891559375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"8200794532637891559375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"32803178130551566237500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"21868785420367710825000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"8747514168147084330000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"2499289762327738380000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"555397724961719640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"100981404538494480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"15535600698229920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"2071413426430656000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"243695697227136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"25652178655488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"2443064633856000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"212440402944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"16995232235520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"1258906091520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"86821109760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"5601361920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"339476480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"19398656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"15958302874322383575000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"15958302874322383575000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"20095640656554112650000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7565417658938018880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2026451158644112200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"420300981052112160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"70959905891915040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"10077146398851840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1231651226526336000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"131727403906560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"12479438264832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1056460382208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"80382855168000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5511967211520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"340244889600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"18772131840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"908328960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"36700160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"4593289292926654320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4593289292926654320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3242321853830579520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"810580463457644880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"156111792962213088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"24329110591513728000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3167103153924864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"351900350436096000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"33872761004544000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2852443031961600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"211292076441600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13779918028800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"787423887360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"38885130240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1609039872", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"51904512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"458510161147758720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"458510161147758720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"212879717675745120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"37845283142354688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5406469020336384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"639818818974720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"63981881897472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5474385616896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"403375782297600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"25611160780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1391910912000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"63630213120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2356674560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"65011712", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"20601263000878560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"20601263000878560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6714485718804864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"872011132312320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"92876925335040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"8255726696448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"618075795456000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"39036366028800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2065416192000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"89800704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3078881280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"76021760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"463067980607232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"463067980607232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"108249657804288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"10248488312832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"797104646553600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"51151100313600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2692163174400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"113953996800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3715891200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"84934656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"5345662113792000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"5345662113792000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"885671829504000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"59044788633600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3157475328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"132946329600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4220518400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"91750400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"30365891297280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"30365891297280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3373987921920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"144341729280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4558159872", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"96468992", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"73347563520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"73347563520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4706795520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"99090432", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"49807360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"49807360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"16401589065275783118750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"16401589065275783118750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"10047820328277056325000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"10047820328277056325000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"1621160926915289760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"1621160926915289760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"106439858837872560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"106439858837872560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"3357242859402432000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"3357242859402432000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"54124828902144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"54124828902144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"442835914752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"442835914752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"1686993960960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"1686993960960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"2353397760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"2353397760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"524288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"1686993960960", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"18", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"524288", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{"95", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"8200794532637891559375", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"270193487819214960000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"17", "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"392232960", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"187", "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"6013869878016000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"77", "+", 
              RowBox[{"9", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"8187681449067120000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"56", "+", 
              RowBox[{"13", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"31631136768000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"169", "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"591048254604532725000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"27", "+", 
              RowBox[{"17", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"152601948154656000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"135", "+", 
              RowBox[{"22", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "524288"}], " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "95"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"1686993960960", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "18"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"8200794532637891559375", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"392232960", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "187"}], "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"270193487819214960000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "17"}], "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"6013869878016000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "77"}], "+", 
              RowBox[{"9", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"8187681449067120000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "56"}], "+", 
              RowBox[{"13", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"31631136768000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "169"}], "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"591048254604532725000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "27"}], "+", 
              RowBox[{"17", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"152601948154656000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "135"}], "+", 
              RowBox[{"22", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"319830986772877770815625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"319830986772877770815625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"1279323947091511083262500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"852882631394340722175000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"341153052557736288870000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"97472300730781796820000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"21660511273507065960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"3938274777001284720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"605888427230966880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"80785123630795584000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"9504132191858304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"1000434967564032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"95279520720384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"8285175714816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"662814057185280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"49097337569280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"3386023280640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"218453114880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"13239582720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"756547584", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"40894464", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "+", 
        RowBox[{"623260384480479758512500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"623260384480479758512500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"787276275133237589700000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"297415481717000867220000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"79977272394487628160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"16661931748851589200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2827479327077845440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"403925618153977920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"49713922234335744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5361305338996992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"513043573109760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"43975163409408000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3399046447104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"237933251297280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"15106873098240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"868211097600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"44810895360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2036858880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"77594624", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"180860765908987013850000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"180860765908987013850000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"128612100201946320960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"32423218538305795200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6304514715781682400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"993438682486810560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"131002903185073920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"14779814718316032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1449001442972160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"124794382648320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"9508143439872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"643062841344000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"38583770480640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2041469337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"93860659200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3633315840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"110100480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"18373157171706617280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"18373157171706617280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8646191610214878720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1561117929622130880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"227071698854128128000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"27448227334015488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2815202803488768000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"248400247366656000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"19016286879744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1267752458649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"73492896153600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3674644807680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"155540520960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5363466240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"138412032", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"851518870702980480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"851518870702980480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"283839623567660160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"37845283142354688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4158822323335680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"383891291384832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"30109120892928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2016878911488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"115250223513600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5567643648000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"222705745920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"7070023680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"162529280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"20143457156414592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"20143457156414592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4883262340948992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"482960011742208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"39627488142950400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2719533500006400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"156145464115200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7435498291200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"287362252800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8620867584", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"182452224", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"252582534876672000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"252582534876672000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"44410116022272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3188418586214400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"187554034483200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8973877248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"341861990400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"9909043200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"198180864", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"1644819111936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1644819111936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"202439275315200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"9923493888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"379846656000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"10852761600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"209715200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"5060981882880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"5060981882880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"396939755520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"11395399680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"217055232", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"5752750080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"5752750080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"220200960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1048576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"639661973545755541631250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"639661973545755541631250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"393638137566618794850000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"393638137566618794850000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"64306050100973160480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"64306050100973160480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"4323095805107439360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"4323095805107439360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"141919811783830080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"141919811783830080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"2441631170474496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"2441631170474496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"22205058011136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"22205058011136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"101219637657600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"101219637657600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"198469877760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"198469877760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"110100480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"110100480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"1048576", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"]}], "+", 
           RowBox[{"141919811783830080000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"6", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"319830986772877770815625", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"99234938880", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"51", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1080773951276859840000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"17", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"610407792618624000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"33", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"25304909414400", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"65", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"27525120", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{"209", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2775632251392000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"91", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"32803178130551566237500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"19", "+", 
              RowBox[{"12", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"4019128131310822530000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"45", "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"1048576", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"]}], "-", 
           RowBox[{"141919811783830080000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "6"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"99234938880", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "51"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"319830986772877770815625", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"27525120", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "209"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"25304909414400", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "65"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"610407792618624000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "33"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"1080773951276859840000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "17"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"2775632251392000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "91"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"32803178130551566237500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "19"}], "+", 
              RowBox[{"12", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"4019128131310822530000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "45"}], "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"13113070457687988603440625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"13113070457687988603440625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"52452281830751954413762500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"34968187887167969609175000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"13987275154867187843670000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"3996364329962053669620000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"888080962213789704360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"161469265857052673520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"24841425516469642080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"3312190068862618944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"389669419866190464000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"41017833670125312000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"3906460349535744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"339692204307456000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"27175376344596480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"2012990840340480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"138826954506240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"8956577710080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"542822891520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"31018450944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"1676673024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"85983232", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "+", 
        RowBox[{"25586478941830221665250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"25586478941830221665250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"32409539992984947442650000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"12281509892078506399320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3314058224846581091880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"693136360752226110720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"118148243310038541600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"16964875962467072640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2100413214400685184000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"228099172604599296000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"22009569286408704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1905590414407680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"149133162866688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"10605024914964480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"687362725969920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"40632279367680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2184531148800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"105916661760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4539285504", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"163577856", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"7479124613765757102150000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"7479124613765757102150000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5353478670906015609960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1359613630706289678720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"266590907981625427200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"42412189906167681600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5654958654155690880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"646280989046364672000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"64335664067963904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5643479304207360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"439751634094080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"30591418023936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1903466010378240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"105748111687680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5209266585600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"224054476800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8147435520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"232783872", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"771672601211677925760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"771672601211677925760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"367463143434132345600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"67248156968337945600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"9934386824868105600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1222693763060689920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"128091727558738944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"11592011543777280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"915158806087680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"63387622932480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3858377048064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"205780109230080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"9526856908800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"375442636800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"12111052800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"293601280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"36746314343413234560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"36746314343413234560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"12488943436977047040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1703037741405960960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"192137591338108416000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"18298818222676992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1490401484199936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"104589577838592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6338762293248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"330718032691200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"14698579230720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"544391823360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"16090398720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"346030080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"908286795416512512000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"908286795416512512000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"227071698854128128000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"23289405010679808000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1996234715201126400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"144523780286054400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8874267210547200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"461000894054400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"20043517132800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"712658386944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"19796066304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"390070272", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"12208155852372480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"12208155852372480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2253813388130304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"171719115286118400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"10878134000025600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"572533368422400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"24784994304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"862086758400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"22988980224", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"425721856", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"88820232044544000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"88820232044544000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"11842697605939200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"643042403942400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"28203614208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"976748544000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"25480396800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"452984832", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"328963822387200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"328963822387200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"29770481664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1044578304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"27131904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"471859200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"529253007360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"529253007360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"27855421440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"482344960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"242221056", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"242221056", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"26226140915375977206881250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"26226140915375977206881250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"16204769996492473721325000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"16204769996492473721325000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"2676739335453007804980000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"2676739335453007804980000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"183731571717066172800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"183731571717066172800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"6244471718488523520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"6244471718488523520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"113535849427064064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"113535849427064064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"1126906694065152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"1126906694065152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"5921348802969600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"5921348802969600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"14885240832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"14885240832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"13927710720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"13927710720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"2097152", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"113535849427064064000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"8", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"5921348802969600", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"15", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"13927710720", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{"38", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"13113070457687988603440625", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1048576", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{"231", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"36746314343413234560000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"21", "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"187817782344192000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"65", "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1488524083200", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"221", "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"852882631394340722175000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"30", "+", 
              RowBox[{"19", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"240171989172635520000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"153", "+", 
              RowBox[{"26", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"78727627513323758970000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"95", "+", 
              RowBox[{"34", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "13927710720"}], " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "38"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"5921348802969600", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "15"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"113535849427064064000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "8"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"1048576", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "231"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"13113070457687988603440625", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"36746314343413234560000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "21"}], "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"187817782344192000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "65"}], "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"1488524083200", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "221"}], "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"852882631394340722175000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "30"}], "+", 
              RowBox[{"19", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"240171989172635520000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "153"}], "+", 
              RowBox[{"26", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"78727627513323758970000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "95"}], "+", 
              RowBox[{"34", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"563862029680583509947946875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"563862029680583509947946875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"2255448118722334039791787500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"1503632079148222693194525000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"601452831659289077277810000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"171843666188368307793660000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"38187481375192957287480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"6943178431853264961360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"1068181297208194609440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"142424172961092614592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"16755785054246189952000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"1763766847815388416000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"167977795030036992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"14606764785220608000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"1168541182817648640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"86558606134640640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"5969559043768320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"385132841533440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"23341384335360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"1333793390592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"72096940032", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"3697278976", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"180355072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "+", 
        RowBox[{"1101497918445791042689012500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"1101497918445791042689012500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"1398727515486718784367000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"531516455884953138059460000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"143869115878633932106320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"30194752715268849948240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5167016507425685552640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"745242765494089262400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"92741321928153330432000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"10131404916520952064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"984428008083007488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"85942127689786368000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6793844086149120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"489156774202736640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"32207853445447680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1943577363087360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"107478932520960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5428228915200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"248147607552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"10060038144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"343932928", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"324095399929849474426500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"324095399929849474426500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"233348687949491621587080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"59653048047238459653840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"11783318132787843882240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1890371892960616665600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"254473139437006089600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"29405785001609592576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2965289243859790848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"264114831436904448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"20961494558484480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1491331628666880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"95445224234680320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5498901807759360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"284425955573760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13107186892800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"529583308800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"18157142016", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"490733568", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"33905364915738098863080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"33905364915738098863080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"16315363568475476144640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3021363623791754841600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"452396692332455270400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"56549586541556908800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6031955897766070272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"557575755255687168000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"45147834433658880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3224845316689920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"203942786826240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"11420796062269440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"563989929000960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"24309910732800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"896217907200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"27158118400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"620756992", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"1653584145453595555200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1653584145453595555200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"571609334230872537600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"79475094598944844800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9170203222955174400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"896642092911172608000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"75348075034552320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5490952836526080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"348631926128640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"19291885240320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"926010491535360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"38107427635200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1314049228800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"36333158400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"734003200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"42462407685721959936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"42462407685721959936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"10899441544998150144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1152825548028650496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"102473382046991155200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7750087717839667200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"502029973625241600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"27890554090291200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1322872130764800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"52914885230592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1742053834752", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"45053116416", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"830472192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"605524530277675008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"605524530277675008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"116447025053399040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"9315762004271923200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"626269714572902400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"35497068842188800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1690336611532800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"66811723776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2137975160832", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"52789510144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"910163968", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"4829600117422080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4829600117422080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"686876461144473600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"40404497714380800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1962971548876800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"77895696384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2463105024000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"59114520576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"973078528", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"20724720810393600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"20724720810393600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2089887812812800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"84610842624000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2686058496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"63700992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1019215872", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"43001806848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"43001806848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2785542144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"66322432000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1048576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"33426505728", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"33426505728", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1061158912", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"8388608", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "T"}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"4194304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"1127724059361167019895893750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1127724059361167019895893750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"699363757743359392183500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"699363757743359392183500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"116674343974745810793540000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"116674343974745810793540000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"8157681784237738072320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"8157681784237738072320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"285804667115436268800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"285804667115436268800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"5449720772499075072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"5449720772499075072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"58223512526699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"58223512526699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"343438230572236800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"343438230572236800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"1044943906406400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"1044943906406400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"1392771072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"1392771072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"530579456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"530579456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"T", " ", "U"}], ")"}], 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "-", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4194304", " ", 
            SuperscriptBox["T", "11"], " ", 
            SuperscriptBox["U", "11"]}], "+", 
           RowBox[{"530579456", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{"63", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"563862029680583509947946875", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"11644702505339904000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"52", "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"174157317734400", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"119", "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"174096384000", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{"247", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"12963815997193978977060000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"25", "+", 
              RowBox[{"9", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"20414619079674019200000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"81", "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"21464889410764800", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"225", "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"227071698854128128000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"187", "+", 
              RowBox[{"24", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"254927555757429314760000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"133", "+", 
              RowBox[{"32", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"17484093943583984804587500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"63", "+", 
              RowBox[{"40", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4194304", " ", 
            SuperscriptBox["T", "11"], " ", 
            SuperscriptBox["U", "11"]}], "-", 
           RowBox[{"530579456", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "63"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"563862029680583509947946875", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"11644702505339904000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "52"}], "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"174157317734400", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "119"}], "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"174096384000", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "247"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"12963815997193978977060000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "25"}], "+", 
              RowBox[{"9", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"20414619079674019200000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "81"}], "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"21464889410764800", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "225"}], "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"227071698854128128000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "187"}], "+", 
              RowBox[{"24", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"254927555757429314760000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "133"}], "+", 
              RowBox[{"32", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"17484093943583984804587500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "63"}], "+", 
              RowBox[{"40", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox[
       RowBox[{"25373791335626257947657609375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"]}], 
       RowBox[{"33554432", " ", 
        SuperscriptBox["T", 
         RowBox[{"47", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"25373791335626257947657609375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"]}], 
       RowBox[{"33554432", " ", 
        SuperscriptBox["T", 
         RowBox[{"47", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"25373791335626257947657609375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"8457930445208752649219203125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"1691586089041750529843840625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"241655155577392932834834375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"26850572841932548092759375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"2440961167448413462978125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"187766243649877958690625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"12517749576658530579375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"65536", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"736338210391678269375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"38754642652193593125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1845459173913980625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"80237355387564375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"3209494215502575", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"118870156129725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"4098970901025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"132224867775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"4006814175", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"114480405", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"3094065", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"79335", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{"1935", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "3"]}]], "-", 
      FractionBox[
       RowBox[{"45", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "2"]}]], "-", 
      FractionBox[
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", "T"}]], 
       RowBox[{"2", " ", "T"}]], "+", 
      FractionBox[
       RowBox[{"25373791335626257947657609375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SqrtBox["U"]}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", "23"]}]], "+", 
      FractionBox[
       RowBox[{"25373791335626257947657609375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SqrtBox["U"]}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", "23"]}]], "+", 
      FractionBox[
       RowBox[{"6202482326486418609427415625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", "U"}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"6202482326486418609427415625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", "U"}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"3947034207764084569635628125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"187954009893527836649315625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"102032176799343682752485625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"5370114568386509618551875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"922140885480511752680625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"4172583192219510193125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"4172583192219510193125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"114541499394261064125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"11195785655078149125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"123030611594265375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"19613575761404625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"356610468389175", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"23774031225945", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"91088242245", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"20568312765", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"267120945", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"12720045", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"68757", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"5289", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{"43", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "3"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "2"]}]], "+", 
      FractionBox[
       RowBox[{"3947034207764084569635628125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"3", "/", "2"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "22"]}]], "+", 
      FractionBox[
       RowBox[{"3947034207764084569635628125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"3", "/", "2"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "22"]}]], "+", 
      FractionBox[
       RowBox[{"458957466019079601120421875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"458957466019079601120421875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"83049446232023927821790625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"21355571888234724297031875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"2123068550292341011985625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"21445136871639808201875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"1455552276355643090625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"679257728965966775625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"34628825398264972875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"781101324772894125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"31472947152021375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"2280648344349375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"74639400360525", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"552884447115", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"14828318505", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"1434998565", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"31060575", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"295815", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"4797", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"123", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "3"]}]], "+", 
      FractionBox[
       RowBox[{"83049446232023927821790625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"5", "/", "2"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "21"]}]], "+", 
      FractionBox[
       RowBox[{"83049446232023927821790625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"5", "/", "2"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "21"]}]], "+", 
      FractionBox[
       RowBox[{"6076788748684677645496875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"6076788748684677645496875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2951583106503986284955625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"17260719921075943186875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"2615260594102415634375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"82836308410483753125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"71791467289085919375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"844605497518657875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"69854590020340125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1279388095610625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"166876708123125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"606824393175", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"31464968535", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"361666305", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"58333275", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"252525", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"7215", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"39", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       SuperscriptBox["T", "5"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "4"]}]], "+", 
      FractionBox[
       RowBox[{"2951583106503986284955625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"7", "/", "2"}]]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "20"]}]], "+", 
      FractionBox[
       RowBox[{"2951583106503986284955625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"7", "/", "2"}]]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "20"]}]], "+", 
      FractionBox[
       RowBox[{"75681618115486827819375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"75681618115486827819375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"6638738431183055071875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"469405747659407934375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"27612102803494584375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"5522420560698916875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"238222063402698375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"8955716669274375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"295243406679375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"4278889951875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"108917198775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"2420382195", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"46367475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"1495725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"19425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"185", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "5"]}]], "+", 
      FractionBox[
       RowBox[{"6638738431183055071875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"9", "/", "2"}]]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "19"]}]], "+", 
      FractionBox[
       RowBox[{"6638738431183055071875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"9", "/", "2"}]]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "19"]}]], "+", 
      FractionBox[
       RowBox[{"251195508206926408125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"251195508206926408125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"32985268754444881875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"447763829245858125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"328360141446962625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"6438434146018875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"435683513640375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1595910306375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"161903944125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"1766224845", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"65415735", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"250635", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"24255", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"105", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "6"]}]], "+", 
      FractionBox[
       RowBox[{"32985268754444881875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"11", "/", "2"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "+", 
      FractionBox[
       RowBox[{"32985268754444881875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"11", "/", "2"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "+", 
      FractionBox[
       RowBox[{"942436250126996625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"942436250126996625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"46908591635280375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"15636197211760125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"551865783944475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"4149366796575", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"106394020425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"4625826975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"84105945", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"623007", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"7161", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"231", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "7"]}]], "+", 
      FractionBox[
       RowBox[{"46908591635280375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"13", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "17"]}]], "+", 
      FractionBox[
       RowBox[{"46908591635280375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"13", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "17"]}]], "+", 
      FractionBox[
       RowBox[{"1015337481283125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1015337481283125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"609202488769875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"2389029367725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"125738387775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1381740525", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"100126125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"364095", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"8091", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"62", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       SuperscriptBox["T", "9"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "8"]}]], "+", 
      FractionBox[
       RowBox[{"609202488769875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"15", "/", "2"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "16"]}]], "+", 
      FractionBox[
       RowBox[{"609202488769875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"15", "/", "2"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "16"]}]], "+", 
      FractionBox[
       RowBox[{"19651693186125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"19651693186125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"539458244325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"12168231075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"222861375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"3229875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"35235", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"261", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "+", 
      FractionBox[
       RowBox[{"539458244325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"17", "/", "2"}]]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "15"]}]], "+", 
      FractionBox[
       RowBox[{"539458244325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"17", "/", "2"}]]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "15"]}]], "+", 
      FractionBox[
       RowBox[{"6200669475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"6200669475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"233107875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"853875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"37125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"135", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "10"]}]], "+", 
      FractionBox[
       RowBox[{"233107875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"19", "/", "2"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "+", 
      FractionBox[
       RowBox[{"233107875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"19", "/", "2"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "+", 
      FractionBox[
       RowBox[{"1726725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1726725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"18975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"275", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "+", 
      FractionBox[
       RowBox[{"18975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"21", "/", "2"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "13"]}]], "+", 
      FractionBox[
       RowBox[{"18975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"21", "/", "2"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "13"]}]], "+", 
      FractionBox[
       RowBox[{"69", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", 
         RowBox[{"25", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"69", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", 
         RowBox[{"25", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "12"]}]], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"23", "/", "2"}]]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "12"]}]], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"23", "/", "2"}]]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "12"]}]], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"33554432", " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "-", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", "11"], " ", 
          SuperscriptBox["U", "11"], " ", 
          RowBox[{"(", 
           RowBox[{"138", "+", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
         RowBox[{"25373791335626257947657609375", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"39793459200", " ", 
          SuperscriptBox["T", "10"], " ", 
          SuperscriptBox["U", "10"], " ", 
          RowBox[{"(", 
           RowBox[{"91", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"6654115717337088000", " ", 
          SuperscriptBox["T", "7"], " ", 
          SuperscriptBox["U", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"40", "+", 
            RowBox[{"3", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"24443132313600", " ", 
          SuperscriptBox["T", "9"], " ", 
          SuperscriptBox["U", "9"], " ", 
          RowBox[{"(", 
           RowBox[{"133", "+", 
            RowBox[{"5", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"4510896237444668079583575000", " ", "T", " ", "U", " ", 
          RowBox[{"(", 
           RowBox[{"11", "+", 
            RowBox[{"7", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"1359613630706289678720000", " ", 
          SuperscriptBox["T", "4"], " ", 
          SuperscriptBox["U", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"57", "+", 
            RowBox[{"10", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"20785793972031728640000", " ", 
          SuperscriptBox["T", "5"], " ", 
          SuperscriptBox["U", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"99", "+", 
            RowBox[{"13", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"5050562214297600", " ", 
          SuperscriptBox["T", "8"], " ", 
          SuperscriptBox["U", "8"], " ", 
          RowBox[{"(", 
           RowBox[{"255", "+", 
            RowBox[{"14", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"22223684566618249674960000", " ", 
          SuperscriptBox["T", "3"], " ", 
          SuperscriptBox["U", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"70", "+", 
            RowBox[{"17", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"139736430064078848000", " ", 
          SuperscriptBox["T", "6"], " ", 
          SuperscriptBox["U", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"221", "+", 
            RowBox[{"22", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"139872751548671878436700000", " ", 
          SuperscriptBox["T", "2"], " ", 
          SuperscriptBox["U", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"105", "+", 
            RowBox[{"38", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"Erf", "[", 
        RowBox[{
         SqrtBox["T"], "-", 
         SqrtBox["U"]}], "]"}]}], "-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"33554432", " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "+", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", "11"], " ", 
          SuperscriptBox["U", "11"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "138"}], "+", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
         RowBox[{"39793459200", " ", 
          SuperscriptBox["T", "10"], " ", 
          SuperscriptBox["U", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "91"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"25373791335626257947657609375", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"6654115717337088000", " ", 
          SuperscriptBox["T", "7"], " ", 
          SuperscriptBox["U", "7"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "40"}], "+", 
            RowBox[{"3", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"24443132313600", " ", 
          SuperscriptBox["T", "9"], " ", 
          SuperscriptBox["U", "9"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "133"}], "+", 
            RowBox[{"5", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"4510896237444668079583575000", " ", "T", " ", "U", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "11"}], "+", 
            RowBox[{"7", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"1359613630706289678720000", " ", 
          SuperscriptBox["T", "4"], " ", 
          SuperscriptBox["U", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "57"}], "+", 
            RowBox[{"10", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"20785793972031728640000", " ", 
          SuperscriptBox["T", "5"], " ", 
          SuperscriptBox["U", "5"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "99"}], "+", 
            RowBox[{"13", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"5050562214297600", " ", 
          SuperscriptBox["T", "8"], " ", 
          SuperscriptBox["U", "8"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "255"}], "+", 
            RowBox[{"14", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"22223684566618249674960000", " ", 
          SuperscriptBox["T", "3"], " ", 
          SuperscriptBox["U", "3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "70"}], "+", 
            RowBox[{"17", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"139736430064078848000", " ", 
          SuperscriptBox["T", "6"], " ", 
          SuperscriptBox["U", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "221"}], "+", 
            RowBox[{"22", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"139872751548671878436700000", " ", 
          SuperscriptBox["T", "2"], " ", 
          SuperscriptBox["U", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "105"}], "+", 
            RowBox[{"38", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"Erf", "[", 
        RowBox[{
         SqrtBox["T"], "+", 
         SqrtBox["U"]}], "]"}]}]}], ",", 
     RowBox[{
      FractionBox[
       RowBox[{"1192568192774434123539907640625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"]}], 
       RowBox[{"67108864", " ", 
        SuperscriptBox["T", 
         RowBox[{"49", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1192568192774434123539907640625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"]}], 
       RowBox[{"67108864", " ", 
        SuperscriptBox["T", 
         RowBox[{"49", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1192568192774434123539907640625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", "24"]}]], "-", 
      FractionBox[
       RowBox[{"397522730924811374513302546875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"79504546184962274902660509375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"11357792312137467843237215625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"1261976923570829760359690625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"114725174870075432759971875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"8825013451544264058459375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"588334230102950937230625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"34607895888408878660625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"65536", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"1821468204653098876875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"86736581173957089375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"3771155703215525625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"150846228128621025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"5586897338097075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"192651632348175", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"6214568785425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"188320266225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"5380579035", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"145421055", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"3728745", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"90945", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{"2115", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "3"]}]], "-", 
      FractionBox[
       RowBox[{"47", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "2"]}]], "-", 
      FractionBox[
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", "T"}]], 
       RowBox[{"2", " ", "T"}]], "+", 
      FractionBox[
       RowBox[{"1192568192774434123539907640625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SqrtBox["U"]}], 
       RowBox[{"33554432", " ", 
        SuperscriptBox["T", "24"]}]], "+", 
      FractionBox[
       RowBox[{"1192568192774434123539907640625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SqrtBox["U"]}], 
       RowBox[{"33554432", " ", 
        SuperscriptBox["T", "24"]}]], "+", 
      FractionBox[
       RowBox[{"583597200719403932796125015625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", "U"}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", 
         RowBox[{"47", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"583597200719403932796125015625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", "U"}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", 
         RowBox[{"47", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"93037234897296279141411234375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"35523307869876761126720653125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"1208275777886964664174171875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"510160883996718413762428125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"21968650507035721166803125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"3192026142047925297740625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"12517749576658530579375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"11045073155875174040625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"271282498565355151875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"23990969260881748125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"240712066162693125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"35304436370528325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"594350780648625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"36890738109225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"132224867775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"28047699225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"343441215", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"15470325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"79335", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"5805", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{"45", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "3"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "2"]}]], "+", 
      FractionBox[
       RowBox[{"93037234897296279141411234375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"3", "/", "2"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "23"]}]], "+", 
      FractionBox[
       RowBox[{"93037234897296279141411234375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"3", "/", "2"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "23"]}]], "+", 
      FractionBox[
       RowBox[{"43417376285404930265991909375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"43417376285404930265991909375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"3947034207764084569635628125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"510160883996718413762428125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"102032176799343682752485625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"8299267969324605774125625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"70933914267731673283125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"4172583192219510193125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"1718122490913915961875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"78370499585547043875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"1599397950725449875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"58840727284213875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"3922715152280925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"118870156129725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"819794180205", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"20568312765", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"1869846615", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"38160135", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"343785", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"5289", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"129", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "3"]}]], "+", 
      FractionBox[
       RowBox[{"3947034207764084569635628125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"5", "/", "2"}]]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", "22"]}]], "+", 
      FractionBox[
       RowBox[{"3947034207764084569635628125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"5", "/", "2"}]]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", "22"]}]], "+", 
      FractionBox[
       RowBox[{"581346123624167494752534375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"581346123624167494752534375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"35592619813724540495053125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"65536", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"13446100818518159742575625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"64335410614919424605625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"8248129566015310846875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"226419242988655591875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"173144126991324864375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"1822569757803419625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"136382770992092625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"2280648344349375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"273677801321925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"921474078525", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"44484955515", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"478332855", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"72474675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"295815", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"7995", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"41", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       SuperscriptBox["T", "5"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "4"]}]], "+", 
      FractionBox[
       RowBox[{"35592619813724540495053125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"7", "/", "2"}]]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "21"]}]], "+", 
      FractionBox[
       RowBox[{"35592619813724540495053125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"7", "/", "2"}]]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "21"]}]], "+", 
      FractionBox[
       RowBox[{"14757915532519931424778125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"14757915532519931424778125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"327953678500442920550625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"23537345346921740709375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"1408217242978223803125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"71791467289085919375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"12669082462779868125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"488982130142380875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"16632045242938125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"500630124369375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"6675068324925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"157324842675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"3254996745", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"58333275", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"1767675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"21645", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"195", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "5"]}]], "+", 
      FractionBox[
       RowBox[{"327953678500442920550625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"9", "/", "2"}]]}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "20"]}]], "+", 
      FractionBox[
       RowBox[{"327953678500442920550625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"9", "/", "2"}]]}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "20"]}]], "+", 
      FractionBox[
       RowBox[{"25227206038495609273125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"25227206038495609273125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"844930345786934281875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"93881149531881586875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"1104484112139783375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"714666190208095125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"12538003336984125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"767632857366375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"2567333971125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"239617837305", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"2420382195", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"83461455", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"299145", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"27195", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"111", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "6"]}]], "+", 
      FractionBox[
       RowBox[{"844930345786934281875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"11", "/", "2"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "19"]}]], "+", 
      FractionBox[
       RowBox[{"844930345786934281875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"11", "/", "2"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "19"]}]], "+", 
      FractionBox[
       RowBox[{"98955806263334645625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"98955806263334645625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2537328365726529375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"109453380482320875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"32192170730094375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"1016594865160875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"6915611327625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"161903944125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"6476157765", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"109026225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"751905", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"8085", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"245", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "7"]}]], "+", 
      FractionBox[
       RowBox[{"2537328365726529375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"13", "/", "2"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "18"]}]], "+", 
      FractionBox[
       RowBox[{"2537328365726529375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"13", "/", "2"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "18"]}]], "+", 
      FractionBox[
       RowBox[{"113920865399966625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"113920865399966625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2233742458822875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"1182569537023875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"4149366796575", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"197588895075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1982497275", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"132166485", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"445005", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"9207", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"66", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       SuperscriptBox["T", "9"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "8"]}]], "+", 
      FractionBox[
       RowBox[{"2233742458822875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"15", "/", "2"}]]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "17"]}]], "+", 
      FractionBox[
       RowBox[{"2233742458822875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"15", "/", "2"}]]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "17"]}]], "+", 
      FractionBox[
       RowBox[{"609202488769875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"609202488769875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"35835440515875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"880168714425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"17962626825", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"300378375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"4005045", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"40455", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"279", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "+", 
      FractionBox[
       RowBox[{"35835440515875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"17", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "16"]}]], "+", 
      FractionBox[
       RowBox[{"35835440515875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"17", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "16"]}]], "+", 
      FractionBox[
       RowBox[{"899097073875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"899097073875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"9464179725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"321910875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1076625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"43065", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"145", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "10"]}]], "+", 
      FractionBox[
       RowBox[{"9464179725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"19", "/", "2"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "15"]}]], "+", 
      FractionBox[
       RowBox[{"9464179725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"19", "/", "2"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "15"]}]], "+", 
      FractionBox[
       RowBox[{"326351025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"326351025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2220075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"22275", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"297", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "+", 
      FractionBox[
       RowBox[{"2220075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"21", "/", "2"}]]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "14"]}]], "+", 
      FractionBox[
       RowBox[{"2220075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"21", "/", "2"}]]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "14"]}]], "+", 
      FractionBox[
       RowBox[{"22425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"22425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"75", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       SuperscriptBox["T", "13"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "12"]}]], "+", 
      FractionBox[
       RowBox[{"75", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"23", "/", "2"}]]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "13"]}]], "+", 
      FractionBox[
       RowBox[{"75", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"23", "/", "2"}]]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "13"]}]], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", 
         RowBox[{"25", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", 
         RowBox[{"25", "/", "2"}]]}]], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"67108864", " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "-", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"16777216", " ", 
          SuperscriptBox["T", "12"], " ", 
          SuperscriptBox["U", "12"]}], "+", 
         RowBox[{"4697022859296768000", " ", 
          SuperscriptBox["T", "8"], " ", 
          SuperscriptBox["U", "8"], " ", 
          RowBox[{"(", 
           RowBox[{"17", "+", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
         RowBox[{"1192568192774434123539907640625", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"63152547324225353114170050000", " ", 
          SuperscriptBox["T", "2"], " ", 
          SuperscriptBox["U", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"11", "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"41571587944063457280000", " ", 
          SuperscriptBox["T", "6"], " ", 
          SuperscriptBox["U", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"39", "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"292781091562831872000", " ", 
          SuperscriptBox["T", "7"], " ", 
          SuperscriptBox["U", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"51", "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"2480977929830400", " ", 
          SuperscriptBox["T", "9"], " ", 
          SuperscriptBox["U", "9"], " ", 
          RowBox[{"(", 
           RowBox[{"95", "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"2327917363200", " ", 
          SuperscriptBox["T", "10"], " ", 
          SuperscriptBox["U", "10"], " ", 
          RowBox[{"(", 
           RowBox[{"147", "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"629145600", " ", 
          SuperscriptBox["T", "11"], " ", 
          SuperscriptBox["U", "11"], " ", 
          RowBox[{"(", 
           RowBox[{"299", "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"83956141696113387660960000", " ", 
          SuperscriptBox["T", "4"], " ", 
          SuperscriptBox["U", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"45", "+", 
            RowBox[{"8", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"1518618445385580394455600000", " ", 
          SuperscriptBox["T", "3"], " ", 
          SuperscriptBox["U", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"49", "+", 
            RowBox[{"12", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"494404956620468974080000", " ", 
          SuperscriptBox["T", "5"], " ", 
          SuperscriptBox["U", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"209", "+", 
            RowBox[{"28", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"33831721780835010596876812500", " ", "T", " ", "U", " ", 
          RowBox[{"(", 
           RowBox[{"69", "+", 
            RowBox[{"44", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"Erf", "[", 
        RowBox[{
         SqrtBox["T"], "-", 
         SqrtBox["U"]}], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"67108864", " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "+", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"16777216", " ", 
          SuperscriptBox["T", "12"], " ", 
          SuperscriptBox["U", "12"]}], "-", 
         RowBox[{"4697022859296768000", " ", 
          SuperscriptBox["T", "8"], " ", 
          SuperscriptBox["U", "8"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "17"}], "+", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
         RowBox[{"1192568192774434123539907640625", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"629145600", " ", 
          SuperscriptBox["T", "11"], " ", 
          SuperscriptBox["U", "11"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "299"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"2327917363200", " ", 
          SuperscriptBox["T", "10"], " ", 
          SuperscriptBox["U", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "147"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"2480977929830400", " ", 
          SuperscriptBox["T", "9"], " ", 
          SuperscriptBox["U", "9"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "95"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"292781091562831872000", " ", 
          SuperscriptBox["T", "7"], " ", 
          SuperscriptBox["U", "7"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "51"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"41571587944063457280000", " ", 
          SuperscriptBox["T", "6"], " ", 
          SuperscriptBox["U", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "39"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"63152547324225353114170050000", " ", 
          SuperscriptBox["T", "2"], " ", 
          SuperscriptBox["U", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "11"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"83956141696113387660960000", " ", 
          SuperscriptBox["T", "4"], " ", 
          SuperscriptBox["U", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "45"}], "+", 
            RowBox[{"8", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"1518618445385580394455600000", " ", 
          SuperscriptBox["T", "3"], " ", 
          SuperscriptBox["U", "3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "49"}], "+", 
            RowBox[{"12", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"494404956620468974080000", " ", 
          SuperscriptBox["T", "5"], " ", 
          SuperscriptBox["U", "5"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "209"}], "+", 
            RowBox[{"28", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"33831721780835010596876812500", " ", "T", " ", "U", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "69"}], "+", 
            RowBox[{"44", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"Erf", "[", 
        RowBox[{
         SqrtBox["T"], "+", 
         SqrtBox["U"]}], "]"}]}]}], ",", 
     RowBox[{
      FractionBox[
       RowBox[{"58435841445947272053455474390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"]}], 
       RowBox[{"134217728", " ", 
        SuperscriptBox["T", 
         RowBox[{"51", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"58435841445947272053455474390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"]}], 
       RowBox[{"134217728", " ", 
        SuperscriptBox["T", 
         RowBox[{"51", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"58435841445947272053455474390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"33554432", " ", 
        SuperscriptBox["T", "25"]}]], "-", 
      FractionBox[
       RowBox[{"19478613815315757351151824796875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", "24"]}]], "-", 
      FractionBox[
       RowBox[{"3895722763063151470230364959375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"556531823294735924318623565625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"61836869254970658257624840625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"5621533568633696205238621875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"432425659125668938864509375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"28828377275044595924300625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"1695786898532035054370625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"89251942028001844966875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"65536", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"4250092477523897379375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"184786629457560755625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"7391465178302430225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"273757969566756675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"9439929985060575", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"304513870485825", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"9227693045025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"263648372715", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"7125631695", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"182708505", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"4456305", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"103635", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{"2303", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "3"]}]], "-", 
      FractionBox[
       RowBox[{"49", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "2"]}]], "-", 
      FractionBox[
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", "T"}]], 
       RowBox[{"2", " ", "T"}]], "+", 
      FractionBox[
       RowBox[{"58435841445947272053455474390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SqrtBox["U"]}], 
       RowBox[{"67108864", " ", 
        SuperscriptBox["T", "25"]}]], "+", 
      FractionBox[
       RowBox[{"58435841445947272053455474390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SqrtBox["U"]}], 
       RowBox[{"67108864", " ", 
        SuperscriptBox["T", "25"]}]], "+", 
      FractionBox[
       RowBox[{"3577704578323302370619722921875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", "U"}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"49", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"3577704578323302370619722921875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", "U"}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"49", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"9143022811270661613805958578125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", "24"]}]], "-", 
      FractionBox[
       RowBox[{"874550008034585023929265603125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"238513638554886824707981528125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"6309884617854148801798453125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"2179778322531433222439465625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"79425121063898376526134375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"10001681911750165932920625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"34607895888408878660625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"27322023069796483153125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"607156068217699625625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"49025024141801833125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"452538684385863075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"61455870719067825", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"963258161740875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"55931119068825", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"188320266225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"37664053245", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"436263165", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"18643725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"90945", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"6345", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{"47", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "3"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "2"]}]], "+", 
      FractionBox[
       RowBox[{"9143022811270661613805958578125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"3", "/", "2"}]]}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", "24"]}]], "+", 
      FractionBox[
       RowBox[{"9143022811270661613805958578125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"3", "/", "2"}]]}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", "24"]}]], "+", 
      FractionBox[
       RowBox[{"2139856402637814420252458390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", 
         RowBox[{"47", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2139856402637814420252458390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", 
         RowBox[{"47", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"390756386568644372393927184375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"25373791335626257947657609375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"2550804419983592068812140625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"417404359633678702169259375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"28728235278431327679665625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"212801742803195019849375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"11045073155875174040625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"4069237478480327278125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"167936784826172236875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"3129256860115010625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"105913309111584975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"6537858587134875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"184453690546125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"1190023809975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"28047699225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"2404088505", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"46410975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"396675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"5805", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"135", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "3"]}]], "+", 
      FractionBox[
       RowBox[{"390756386568644372393927184375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"5", "/", "2"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "23"]}]], "+", 
      FractionBox[
       RowBox[{"390756386568644372393927184375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"5", "/", "2"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "23"]}]], "+", 
      FractionBox[
       RowBox[{"14472458761801643421997303125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"14472458761801643421997303125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"3571126187977028896336996875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"170053627998906137920809375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"65536", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"52562030472389169902795625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"212801742803195019849375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"23644638089243891094375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"572707496971305320625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"391852497927735219375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"3731928551692716375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"254976484898260125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"3922715152280925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"435857239142325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"1366323633675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"61704938295", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"623282205", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"89040315", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"343785", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"8815", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"43", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       SuperscriptBox["T", "5"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "4"]}]], "+", 
      FractionBox[
       RowBox[{"3571126187977028896336996875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"7", "/", "2"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "22"]}]], "+", 
      FractionBox[
       RowBox[{"3571126187977028896336996875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"7", "/", "2"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "22"]}]], "+", 
      FractionBox[
       RowBox[{"747445016088215350396115625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"747445016088215350396115625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"67230504092590798712878125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"1222372801683469067506875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"74233166094137797621875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"3849127130807145061875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"173144126991324864375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"27338546367051294375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"954679396944648375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"29648428476541875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"821033403965775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"10136214863775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"222424777575", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"4304995695", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"72474675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"2070705", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"23985", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"205", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "5"]}]], "+", 
      FractionBox[
       RowBox[{"67230504092590798712878125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"9", "/", "2"}]]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "+", 
      FractionBox[
       RowBox[{"67230504092590798712878125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"9", "/", "2"}]]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "+", 
      FractionBox[
       RowBox[{"327953678500442920550625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"327953678500442920550625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"89441912318302614695625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"2534791037360802845625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"244090988782892125875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"2533816492555973625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"1466946390427142625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"23284863340113375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"1301638323360375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"4005040994955", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"346114653885", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"3254996745", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"104999895", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"353535", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"30303", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"117", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "6"]}]], "+", 
      FractionBox[
       RowBox[{"89441912318302614695625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"11", "/", "2"}]]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "20"]}]], "+", 
      FractionBox[
       RowBox[{"89441912318302614695625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"11", "/", "2"}]]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "20"]}]], "+", 
      FractionBox[
       RowBox[{"5351225523317250451875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"5351225523317250451875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"281643448595644760625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"6258743302125439125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"238222063402698375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"62690016684920625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"1791143333854875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"11125113874875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"239617837305", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"8874734715", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"139102425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"897435", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"9065", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"259", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "7"]}]], "+", 
      FractionBox[
       RowBox[{"281643448595644760625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"13", "/", "2"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "19"]}]], "+", 
      FractionBox[
       RowBox[{"281643448595644760625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"13", "/", "2"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "19"]}]], "+", 
      FractionBox[
       RowBox[{"3262279327362680625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"3262279327362680625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"265815352599922125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"4598881532870625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"2178417568201875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"6915611327625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"300678753375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"2775496185", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"171326925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"537075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"10395", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"70", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       SuperscriptBox["T", "9"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "8"]}]], "+", 
      FractionBox[
       RowBox[{"265815352599922125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"15", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "18"]}]], "+", 
      FractionBox[
       RowBox[{"265815352599922125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"15", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "18"]}]], "+", 
      FractionBox[
       RowBox[{"37973621799988875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"37973621799988875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1182569537023875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"62240501948625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"1383122265525", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"25772464575", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"396499455", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"4895055", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"46035", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"297", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "+", 
      FractionBox[
       RowBox[{"1182569537023875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"17", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "17"]}]], "+", 
      FractionBox[
       RowBox[{"1182569537023875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"17", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "17"]}]], "+", 
      FractionBox[
       RowBox[{"3981715612875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"3981715612875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1466947857375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"13970931975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"433879875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1335015", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"49445", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"155", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "10"]}]], "+", 
      FractionBox[
       RowBox[{"1466947857375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"19", "/", "2"}]]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "16"]}]], "+", 
      FractionBox[
       RowBox[{"1466947857375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"19", "/", "2"}]]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "16"]}]], "+", 
      FractionBox[
       RowBox[{"28392539175", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"28392539175", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"450675225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"2799225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"25839", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"319", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "+", 
      FractionBox[
       RowBox[{"450675225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"21", "/", "2"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "15"]}]], "+", 
      FractionBox[
       RowBox[{"450675225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"21", "/", "2"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "15"]}]], "+", 
      FractionBox[
       RowBox[{"1412775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1412775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"26325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"81", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       SuperscriptBox["T", "13"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "12"]}]], "+", 
      FractionBox[
       RowBox[{"26325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"23", "/", "2"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "14"]}]], "+", 
      FractionBox[
       RowBox[{"26325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"23", "/", "2"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "14"]}]], "+", 
      FractionBox[
       RowBox[{"325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "13"]}]], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"25", "/", "2"}]]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"25", "/", "2"}]]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"134217728", " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "-", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"58435841445947272053455474390625", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"4614446261791043758080000", " ", 
          SuperscriptBox["T", "6"], " ", 
          SuperscriptBox["U", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"19", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"472567224729600", " ", 
          SuperscriptBox["T", "10"], " ", 
          SuperscriptBox["U", "10"], " ", 
          RowBox[{"(", 
           RowBox[{"63", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"16777216", " ", 
          SuperscriptBox["T", "12"], " ", 
          SuperscriptBox["U", "12"], " ", 
          RowBox[{"(", 
           RowBox[{"325", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"244236048570511673195520000", " ", 
          SuperscriptBox["T", "5"], " ", 
          SuperscriptBox["U", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"22", "+", 
            RowBox[{"3", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"147220070400", " ", 
          SuperscriptBox["T", "11"], " ", 
          SuperscriptBox["U", "11"], " ", 
          RowBox[{"(", 
           RowBox[{"161", "+", 
            RowBox[{"3", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"109871879749632000", " ", 
          SuperscriptBox["T", "9"], " ", 
          SuperscriptBox["U", "9"], " ", 
          RowBox[{"(", 
           RowBox[{"152", "+", 
            RowBox[{"7", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"6334718162904907776000", " ", 
          SuperscriptBox["T", "7"], " ", 
          SuperscriptBox["U", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"135", "+", 
            RowBox[{"11", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"17222417150754816000", " ", 
          SuperscriptBox["T", "8"], " ", 
          SuperscriptBox["U", "8"], " ", 
          RowBox[{"(", 
           RowBox[{"289", "+", 
            RowBox[{"18", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"48116226532743126182224800000", " ", 
          SuperscriptBox["T", "3"], " ", 
          SuperscriptBox["U", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"77", "+", 
            RowBox[{"19", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"3180181847398490996106420375000", " ", "T", " ", "U", " ", 
          RowBox[{"(", 
           RowBox[{"36", "+", 
            RowBox[{"23", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"1012412296923720262970400000", " ", 
          SuperscriptBox["T", "4"], " ", 
          SuperscriptBox["U", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"189", "+", 
            RowBox[{"34", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"297719151671348093252515950000", " ", 
          SuperscriptBox["T", "2"], " ", 
          SuperscriptBox["U", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"115", "+", 
            RowBox[{"42", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"Erf", "[", 
        RowBox[{
         SqrtBox["T"], "-", 
         SqrtBox["U"]}], "]"}]}], "-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"134217728", " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "+", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"16777216", " ", 
          SuperscriptBox["T", "12"], " ", 
          SuperscriptBox["U", "12"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "325"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"472567224729600", " ", 
          SuperscriptBox["T", "10"], " ", 
          SuperscriptBox["U", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "63"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"4614446261791043758080000", " ", 
          SuperscriptBox["T", "6"], " ", 
          SuperscriptBox["U", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "19"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"58435841445947272053455474390625", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"147220070400", " ", 
          SuperscriptBox["T", "11"], " ", 
          SuperscriptBox["U", "11"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "161"}], "+", 
            RowBox[{"3", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"244236048570511673195520000", " ", 
          SuperscriptBox["T", "5"], " ", 
          SuperscriptBox["U", "5"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "22"}], "+", 
            RowBox[{"3", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"109871879749632000", " ", 
          SuperscriptBox["T", "9"], " ", 
          SuperscriptBox["U", "9"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "152"}], "+", 
            RowBox[{"7", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"6334718162904907776000", " ", 
          SuperscriptBox["T", "7"], " ", 
          SuperscriptBox["U", "7"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "135"}], "+", 
            RowBox[{"11", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"17222417150754816000", " ", 
          SuperscriptBox["T", "8"], " ", 
          SuperscriptBox["U", "8"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "289"}], "+", 
            RowBox[{"18", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"48116226532743126182224800000", " ", 
          SuperscriptBox["T", "3"], " ", 
          SuperscriptBox["U", "3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "77"}], "+", 
            RowBox[{"19", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"3180181847398490996106420375000", " ", "T", " ", "U", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "36"}], "+", 
            RowBox[{"23", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"1012412296923720262970400000", " ", 
          SuperscriptBox["T", "4"], " ", 
          SuperscriptBox["U", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "189"}], "+", 
            RowBox[{"34", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"297719151671348093252515950000", " ", 
          SuperscriptBox["T", "2"], " ", 
          SuperscriptBox["U", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "115"}], "+", 
            RowBox[{"42", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"Erf", "[", 
        RowBox[{
         SqrtBox["T"], "+", 
         SqrtBox["U"]}], "]"}]}]}], ",", 
     RowBox[{
      FractionBox[
       RowBox[{"2980227913743310874726229193921875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"]}], 
       RowBox[{"268435456", " ", 
        SuperscriptBox["T", 
         RowBox[{"53", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2980227913743310874726229193921875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"]}], 
       RowBox[{"268435456", " ", 
        SuperscriptBox["T", 
         RowBox[{"53", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2980227913743310874726229193921875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"67108864", " ", 
        SuperscriptBox["T", "26"]}]], "-", 
      FractionBox[
       RowBox[{"993409304581103624908743064640625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"33554432", " ", 
        SuperscriptBox["T", "25"]}]], "-", 
      FractionBox[
       RowBox[{"198681860916220724981748612928125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16777216", " ", 
        SuperscriptBox["T", "24"]}]], "-", 
      FractionBox[
       RowBox[{"28383122988031532140249801846875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"3153680332003503571138866871875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"286698212000318506467169715625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"22053708615409115882089978125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"1470247241027274392139331875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"86485131825133787772901875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"4551849043428094093310625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"216754716353718766348125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"65536", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"9424118102335598536875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"376964724093423941475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"13961656447904590425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"481436429238089325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"15530207394777075", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"470612345296275", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"13446067008465", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"363407216445", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"9318133755", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"227271555", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"5285385", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"117453", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{"2499", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "3"]}]], "-", 
      FractionBox[
       RowBox[{"51", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "2"]}]], "-", 
      FractionBox[
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", "T"}]], 
       RowBox[{"2", " ", "T"}]], "+", 
      FractionBox[
       RowBox[{"2980227913743310874726229193921875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SqrtBox["U"]}], 
       RowBox[{"134217728", " ", 
        SuperscriptBox["T", "26"]}]], "+", 
      FractionBox[
       RowBox[{"2980227913743310874726229193921875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SqrtBox["U"]}], 
       RowBox[{"134217728", " ", 
        SuperscriptBox["T", "26"]}]], "+", 
      FractionBox[
       RowBox[{"1460896036148681801336386859765625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", "U"}], 
       RowBox[{"67108864", " ", 
        SuperscriptBox["T", 
         RowBox[{"51", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1460896036148681801336386859765625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", "U"}], 
       RowBox[{"67108864", " ", 
        SuperscriptBox["T", 
         RowBox[{"51", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"58435841445947272053455474390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "25"]}]], "-", 
      FractionBox[
       RowBox[{"89601623550452483815298394065625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", "24"]}]], "-", 
      FractionBox[
       RowBox[{"6121850056242095167504859221875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"1298574254354383823410121653125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"28107667843168481026193109375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"8216087523387709838425678125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"259455395475401363318705625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"28828377275044595924300625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"89251942028001844966875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"63751387162858460690625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32768", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"1293506406202925289375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"96089047317931592925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"821273908700270025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"103839229835666325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"1522569352429125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"83049237405225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"263648372715", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"49879421865", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"548125515", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"22281525", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"103635", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"6909", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{"49", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "3"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", "U"}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "2"]}]], "+", 
      FractionBox[
       RowBox[{"58435841445947272053455474390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"3", "/", "2"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "25"]}]], "+", 
      FractionBox[
       RowBox[{"58435841445947272053455474390625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"3", "/", "2"}]]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "25"]}]], "+", 
      FractionBox[
       RowBox[{"27429068433811984841417875734375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"49", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"27429068433811984841417875734375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"49", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"20114650184795455550373108871875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", "24"]}]], "-", 
      FractionBox[
       RowBox[{"2623650024103755071787796809375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2097152", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"132507576974937124837767515625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"10898891612657166112197328125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"1509077300214069153996553125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"90015137205751493396285625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"588334230102950937230625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"27322023069796483153125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"9107341023265494384375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"343175168992612831875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"5883002897016219975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"184367612157203475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"10595839779149625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"279655595344125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"1694882396025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"37664053245", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"3053842155", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"55931175", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"454725", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"6345", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "5"]}]], "-", 
      FractionBox[
       RowBox[{"141", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "4"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "2"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "3"]}]], "+", 
      FractionBox[
       RowBox[{"20114650184795455550373108871875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"5", "/", "2"}]]}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", "24"]}]], "+", 
      FractionBox[
       RowBox[{"20114650184795455550373108871875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"5", "/", "2"}]]}], 
       RowBox[{"8388608", " ", 
        SuperscriptBox["T", "24"]}]], "+", 
      FractionBox[
       RowBox[{"2995798963692940188353441746875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"47", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2995798963692940188353441746875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4194304", " ", 
        SuperscriptBox["T", 
         RowBox[{"47", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"93037234897296279141411234375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "23"]}]], "-", 
      FractionBox[
       RowBox[{"17855630939885144481684984375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"695673932722797836948765625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"65536", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"181945490096731741971215625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"638405228409585059548125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"62588747883292652896875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"1356412492826775759375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"839683924130861184375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"7301599340268358125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"458957672816868225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"6537858587134875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"676330198669125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"1983373016625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"84143097675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"801362835", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"108292275", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"396675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"9675", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{"45", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       SuperscriptBox["T", "5"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "3"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "4"]}]], "+", 
      FractionBox[
       RowBox[{"93037234897296279141411234375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"7", "/", "2"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "23"]}]], "+", 
      FractionBox[
       RowBox[{"93037234897296279141411234375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"7", "/", "2"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "23"]}]], "+", 
      FractionBox[
       RowBox[{"39282388067747317859706965625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"39282388067747317859706965625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"1048576", " ", 
        SuperscriptBox["T", 
         RowBox[{"45", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"3571126187977028896336996875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", "22"]}]], "-", 
      FractionBox[
       RowBox[{"262810152361945849513978125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"131072", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"4043233113260705377138125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16384", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"212801742803195019849375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"9736027448512190450625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"391852497927735219375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"55978928275390745625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"1784835394287820875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"50995296979652025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1307571717426975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"15029559970425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"308524691475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"5609539845", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"89040315", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"2406495", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"26445", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{"215", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "6"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "4"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "5"]}]], "+", 
      FractionBox[
       RowBox[{"3571126187977028896336996875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"9", "/", "2"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "22"]}]], "+", 
      FractionBox[
       RowBox[{"3571126187977028896336996875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"9", "/", "2"}]]}], 
       RowBox[{"524288", " ", 
        SuperscriptBox["T", "22"]}]], "+", 
      FractionBox[
       RowBox[{"282368117188881354594088125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"282368117188881354594088125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"262144", " ", 
        SuperscriptBox["T", 
         RowBox[{"43", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1222372801683469067506875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "21"]}]], "-", 
      FractionBox[
       RowBox[{"282086031157723630963125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"6928428835452861111375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"588690031770504538875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"5467709273410258875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"2864038190833945125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"41507799867158625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"2134686850311015", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"6081728918265", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"489334510665", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"4304995695", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"130454415", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"414141", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"33579", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{"123", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "7"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "5"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "6"]}]], "+", 
      FractionBox[
       RowBox[{"1222372801683469067506875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"11", "/", "2"}]]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "21"]}]], "+", 
      FractionBox[
       RowBox[{"1222372801683469067506875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"11", "/", "2"}]]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "21"]}]], "+", 
      FractionBox[
       RowBox[{"149069853863837691159375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"149069853863837691159375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", 
         RowBox[{"41", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"16053676569951751355625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", "20"]}]], "-", 
      FractionBox[
       RowBox[{"732272966348676377625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"14358293457817183875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"488982130142380875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"116424316700566875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"3037156087840875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"17355177644805", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"346114653885", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"11934988065", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"174999825", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"1060605", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"10101", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "-", 
      FractionBox[
       RowBox[{"273", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "8"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "6"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "7"]}]], "+", 
      FractionBox[
       RowBox[{"16053676569951751355625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"13", "/", "2"}]]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "20"]}]], "+", 
      FractionBox[
       RowBox[{"16053676569951751355625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"13", "/", "2"}]]}], 
       RowBox[{"8192", " ", 
        SuperscriptBox["T", "20"]}]], "+", 
      FractionBox[
       RowBox[{"764460789045321493125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"764460789045321493125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"4096", " ", 
        SuperscriptBox["T", 
         RowBox[{"39", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"8046955674161278875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "19"]}]], "-", 
      FractionBox[
       RowBox[{"578539296835124625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"8955716669274375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"3838164286831875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"11125113874875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"445004554995", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"3803457735", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"218589525", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"641025", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"11655", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{"74", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       SuperscriptBox["T", "9"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "7"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "8"]}]], "+", 
      FractionBox[
       RowBox[{"8046955674161278875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"15", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "19"]}]], "+", 
      FractionBox[
       RowBox[{"8046955674161278875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"15", "/", "2"}]]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "19"]}]], "+", 
      FractionBox[
       RowBox[{"2392338173399299125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2392338173399299125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"2048", " ", 
        SuperscriptBox["T", 
         RowBox[{"37", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"78180986058800625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", "18"]}]], "-", 
      FractionBox[
       RowBox[{"2178417568201875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"103734169914375", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"256", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"2104751273625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"36081450405", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"513980775", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"5907825", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"51975", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{"315", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "10"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "8"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "9"]}]], "+", 
      FractionBox[
       RowBox[{"78180986058800625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"17", "/", "2"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "18"]}]], "+", 
      FractionBox[
       RowBox[{"78180986058800625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"17", "/", "2"}]]}], 
       RowBox[{"1024", " ", 
        SuperscriptBox["T", "18"]}]], "+", 
      FractionBox[
       RowBox[{"2233742458822875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"2233742458822875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"512", " ", 
        SuperscriptBox["T", 
         RowBox[{"35", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"6915611327625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", "17"]}]], "-", 
      FractionBox[
       RowBox[{"2305203775875", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"20045250225", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"572721435", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"1631685", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"56265", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{"165", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "9"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "10"]}]], "+", 
      FractionBox[
       RowBox[{"6915611327625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"19", "/", "2"}]]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "17"]}]], "+", 
      FractionBox[
       RowBox[{"6915611327625", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"19", "/", "2"}]]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "17"]}]], "+", 
      FractionBox[
       RowBox[{"293389571475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"293389571475", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", 
         RowBox[{"33", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"41912795925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", "16"]}]], "-", 
      FractionBox[
       RowBox[{"607431825", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"32", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"3471039", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"29667", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "13"]}]], "-", 
      FractionBox[
       RowBox[{"341", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "12"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "10"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "11"]}]], "+", 
      FractionBox[
       RowBox[{"41912795925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"21", "/", "2"}]]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "16"]}]], "+", 
      FractionBox[
       RowBox[{"41912795925", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"21", "/", "2"}]]}], 
       RowBox[{"128", " ", 
        SuperscriptBox["T", "16"]}]], "+", 
      FractionBox[
       RowBox[{"614557125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"614557125", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"64", " ", 
        SuperscriptBox["T", 
         RowBox[{"31", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"1781325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "15"]}]], "-", 
      FractionBox[
       RowBox[{"30537", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{"87", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       SuperscriptBox["T", "13"]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "11"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "12"]}]], "+", 
      FractionBox[
       RowBox[{"1781325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"23", "/", "2"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "15"]}]], "+", 
      FractionBox[
       RowBox[{"1781325", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"23", "/", "2"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "15"]}]], "+", 
      FractionBox[
       RowBox[{"61425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"61425", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"16", " ", 
        SuperscriptBox["T", 
         RowBox[{"29", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{"351", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", "14"]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", "T"}]], " ", 
        SuperscriptBox["U", "12"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["T", "13"]}]], "+", 
      FractionBox[
       RowBox[{"351", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"25", "/", "2"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "14"]}]], "+", 
      FractionBox[
       RowBox[{"351", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", 
         RowBox[{"25", "/", "2"}]]}], 
       RowBox[{"8", " ", 
        SuperscriptBox["T", "14"]}]], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "-", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "13"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"U", "+", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]}]], " ", 
        SqrtBox["\[Pi]"], " ", 
        SuperscriptBox["U", "13"]}], 
       RowBox[{"4", " ", 
        SuperscriptBox["T", 
         RowBox[{"27", "/", "2"}]]}]], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"268435456", " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "-", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "13"], " ", 
          SuperscriptBox["U", "13"]}], "+", 
         RowBox[{"87897503799705600", " ", 
          SuperscriptBox["T", "10"], " ", 
          SuperscriptBox["U", "10"], " ", 
          RowBox[{"(", 
           RowBox[{"28", "+", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
         RowBox[{"2980227913743310874726229193921875", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"914208304122119397462271200000", " ", 
          SuperscriptBox["T", "4"], " ", 
          SuperscriptBox["U", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"11", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"5888802816", " ", 
          SuperscriptBox["T", "12"], " ", 
          SuperscriptBox["U", "12"], " ", 
          RowBox[{"(", 
           RowBox[{"175", "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"75149553406311284060160000", " ", 
          SuperscriptBox["T", "6"], " ", 
          SuperscriptBox["U", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"65", "+", 
            RowBox[{"7", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"527365287061833572352000", " ", 
          SuperscriptBox["T", "7"], " ", 
          SuperscriptBox["U", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"95", "+", 
            RowBox[{"8", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"7471418572800", " ", 
          SuperscriptBox["T", "11"], " ", 
          SuperscriptBox["U", "11"], " ", 
          RowBox[{"(", 
           RowBox[{"345", "+", 
            RowBox[{"8", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"2049467640939823104000", " ", 
          SuperscriptBox["T", "8"], " ", 
          SuperscriptBox["U", "8"], " ", 
          RowBox[{"(", 
           RowBox[{"153", "+", 
            RowBox[{"10", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"58515345992132234328358134900000", " ", 
          SuperscriptBox["T", "2"], " ", 
          SuperscriptBox["U", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"30", "+", 
            RowBox[{"11", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"233743365783789088213821897562500", " ", "T", " ", "U", " ", 
          RowBox[{"(", 
           RowBox[{"25", "+", 
            RowBox[{"16", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"3625772031737856000", " ", 
          SuperscriptBox["T", "9"], " ", 
          SuperscriptBox["U", "9"], " ", 
          RowBox[{"(", 
           RowBox[{"323", "+", 
            RowBox[{"16", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"1251709748923872325127040000", " ", 
          SuperscriptBox["T", "5"], " ", 
          SuperscriptBox["U", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"231", "+", 
            RowBox[{"32", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
         RowBox[{"1190876606685392373010063800000", " ", 
          SuperscriptBox["T", "3"], " ", 
          SuperscriptBox["U", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"161", "+", 
            RowBox[{"40", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"Erf", "[", 
        RowBox[{
         SqrtBox["T"], "-", 
         SqrtBox["U"]}], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"268435456", " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"U", "+", 
         RowBox[{"2", " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}]}]], " ", 
       SqrtBox["\[Pi]"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "13"], " ", 
          SuperscriptBox["U", "13"]}], "-", 
         RowBox[{"87897503799705600", " ", 
          SuperscriptBox["T", "10"], " ", 
          SuperscriptBox["U", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "28"}], "+", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
         RowBox[{"5888802816", " ", 
          SuperscriptBox["T", "12"], " ", 
          SuperscriptBox["U", "12"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "175"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"914208304122119397462271200000", " ", 
          SuperscriptBox["T", "4"], " ", 
          SuperscriptBox["U", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "11"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"2980227913743310874726229193921875", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"2", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"75149553406311284060160000", " ", 
          SuperscriptBox["T", "6"], " ", 
          SuperscriptBox["U", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "65"}], "+", 
            RowBox[{"7", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"7471418572800", " ", 
          SuperscriptBox["T", "11"], " ", 
          SuperscriptBox["U", "11"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "345"}], "+", 
            RowBox[{"8", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"527365287061833572352000", " ", 
          SuperscriptBox["T", "7"], " ", 
          SuperscriptBox["U", "7"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "95"}], "+", 
            RowBox[{"8", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"2049467640939823104000", " ", 
          SuperscriptBox["T", "8"], " ", 
          SuperscriptBox["U", "8"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "153"}], "+", 
            RowBox[{"10", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"58515345992132234328358134900000", " ", 
          SuperscriptBox["T", "2"], " ", 
          SuperscriptBox["U", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "30"}], "+", 
            RowBox[{"11", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"3625772031737856000", " ", 
          SuperscriptBox["T", "9"], " ", 
          SuperscriptBox["U", "9"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "323"}], "+", 
            RowBox[{"16", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"233743365783789088213821897562500", " ", "T", " ", "U", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "25"}], "+", 
            RowBox[{"16", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"1251709748923872325127040000", " ", 
          SuperscriptBox["T", "5"], " ", 
          SuperscriptBox["U", "5"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "231"}], "+", 
            RowBox[{"32", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
         RowBox[{"1190876606685392373010063800000", " ", 
          SuperscriptBox["T", "3"], " ", 
          SuperscriptBox["U", "3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "161"}], "+", 
            RowBox[{"40", " ", 
             SqrtBox[
              RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"Erf", "[", 
        RowBox[{
         SqrtBox["T"], "+", 
         SqrtBox["U"]}], "]"}]}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", "U"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"157952079428395476360490147277859375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"]}], 
         RowBox[{"536870912", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"157952079428395476360490147277859375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"]}], 
         RowBox[{"536870912", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"157952079428395476360490147277859375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", "27"]}]], "-", 
        FractionBox[
         RowBox[{"52650693142798492120163382425953125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"10530138628559698424032676485190625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"1504305518365671203433239497884375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16777216", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"167145057596185689270359944209375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"15195005236016880842759994928125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"1168846556616683141750768840625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"77923103774445542783384589375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"4583711986732090751963799375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"241247999301688986945463125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"11487999966747094616450625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"499478259423786722454375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"65536", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"19979130376951468898175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"32768", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"739967791738943292525", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"25516130749618734225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"823100991923184975", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"24942454300702575", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"712641551448645", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"19260582471585", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"493861089015", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"12045392415", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"280125405", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"6225009", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"132447", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{"2703", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "3"]}]], "-", 
        FractionBox[
         RowBox[{"53", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "2"]}]], "-", 
        FractionBox[
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "T"}], "-", "U"}]], 
         RowBox[{"2", " ", "T"}]], "+", 
        FractionBox[
         RowBox[{"157952079428395476360490147277859375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox["U"]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", "27"]}]], "+", 
        FractionBox[
         RowBox[{"38742962878663041371440979520984375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", "U"}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"53", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"38742962878663041371440979520984375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", "U"}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"53", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"24835232614527590622718576616015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"596045582748662174945245838784375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"652811828724725239225745442478125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"34690483652038539282527535590625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"6020662452006688635810564028125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"110268543077045579410449890625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"27934697579518213450647305625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"778366186426204089956116875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"77381433738277599586280625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"216754716353718766348125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"141361771535033978053125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32768", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"2638753068653967590325", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"181501533822759675525", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"1444309287714267975", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"170832281342547825", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"2353061726481375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"121014603076185", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"363407216445", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"65226936285", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"681814665", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"26426925", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"117453", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"7497", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{"51", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "2"]}]], "+", 
        FractionBox[
         RowBox[{"24835232614527590622718576616015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "26"]}]], "+", 
        FractionBox[
         RowBox[{"1460896036148681801336386859765625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1460896036148681801336386859765625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"268804870651357451445895182196875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"140802551293568188852611762103125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"14284316797898222057511338184375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"590261024706538101550055296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"41080437616938549192128390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"4929652514032625903055406875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"259455395475401363318705625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"1517283014476031364436875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"63751387162858460690625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"19402596093043879340625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"672623331225521150475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"10676560813103510325", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"311517689506998975", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"16748262876720375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"415246187026125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"2372835354435", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"49879421865", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"3836878605", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"66844575", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"518175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"6909", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"147", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "3"]}]], "+", 
        FractionBox[
         RowBox[{"268804870651357451445895182196875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "25"]}]], "+", 
        FractionBox[
         RowBox[{"20114650184795455550373108871875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"20114650184795455550373108871875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"20114650184795455550373108871875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"485861115574769457738480890625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"76292241288600162785381296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"2515128833690115256660921875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"65536", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"570095868969759458176475625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"1765002690308852811691875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"154824797395513404534375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"3035780341088498128125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"1715875844963064159375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"13727006759704513275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"798926319347881725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"10595839779149625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"1025403849595125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"2824803993375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"112992159735", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"1017947385", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"130506075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"454725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"10575", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"47", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         SuperscriptBox["T", "5"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "4"]}]], "+", 
        FractionBox[
         RowBox[{"20114650184795455550373108871875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"7", "/", "2"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "24"]}]], "+", 
        FractionBox[
         RowBox[{"2139856402637814420252458390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"2139856402637814420252458390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"196411940338736589298534828125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"14609152587178754575924078125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"909727450483658709856078125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"12129699339782116131414375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"563298730949633876071875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"23059012378055187909375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"839683924130861184375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"109523990104025371875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"3212703709718077575", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"84992161632753375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"2028990596007375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"21817103182875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"420715488375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"7212265515", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"108292275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"2776725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"29025", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "5"]}]], "+", 
        FractionBox[
         RowBox[{"196411940338736589298534828125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"9", "/", "2"}]]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "23"]}]], "+", 
        FractionBox[
         RowBox[{"7856477613549463571941393125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"7856477613549463571941393125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1103802639920172567958708125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"4043233113260705377138125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"808646622652141075427625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"17524849407321942811125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"1332298492954299745875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"11195785655078149125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"5354506182863462625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"71393415771512835", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"3399686465310135", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"9017735982255", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"678754321245", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"5609539845", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"160272567", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"481299", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"37023", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"129", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "6"]}]], "+", 
        FractionBox[
         RowBox[{"1103802639920172567958708125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"11", "/", "2"}]]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "22"]}]], "+", 
        FractionBox[
         RowBox[{"8556609611784283472548125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"8556609611784283472548125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"470143385262872718271875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"43880049291201453705375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"1766070095311513616625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"30983685882658133625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"954679396944648375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"207538999335793125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"4980935984059035", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"26354158645815", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"489334510665", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"15784984215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"217424025", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"1242423", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"11193", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"287", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "7"]}]], "+", 
        FractionBox[
         RowBox[{"470143385262872718271875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"13", "/", "2"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "21"]}]], "+", 
        FractionBox[
         RowBox[{"11466911835679822396875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"11466911835679822396875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1987598051517835882125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"18460663017193522125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"1187528030345782125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"16632045242938125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"6508191616801875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"17355177644805", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"642784357215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"5114994885", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"274999725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"757575", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"12987", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"78", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         SuperscriptBox["T", "9"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "8"]}]], "+", 
        FractionBox[
         RowBox[{"1987598051517835882125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"15", "/", "2"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "20"]}]], "+", 
        FractionBox[
         RowBox[{"152892157809064298625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"152892157809064298625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"5206853671516121625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"152247183377664375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"3838164286831875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"166876708123125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"3115031884965", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"49444950555", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"655768575", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"7051275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"58275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"333", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "+", 
        FractionBox[
         RowBox[{"5206853671516121625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"17", "/", "2"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "19"]}]], "+", 
        FractionBox[
         RowBox[{"78180986058800625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"78180986058800625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"4114788739936875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"11526018879375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"3507918789375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"28063350315", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"742416675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"1969275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"63525", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "10"]}]], "+", 
        FractionBox[
         RowBox[{"4114788739936875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"19", "/", "2"}]]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "18"]}]], "+", 
        FractionBox[
         RowBox[{"23513078513925", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"23513078513925", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"461040755175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"60135750675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"801810009", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"4242381", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"33759", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"363", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "+", 
        FractionBox[
         RowBox[{"461040755175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"21", "/", "2"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "17"]}]], "+", 
        FractionBox[
         RowBox[{"3810254175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"3810254175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"828316125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"2208843", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"35061", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"93", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         SuperscriptBox["T", "13"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "12"]}]], "+", 
        FractionBox[
         RowBox[{"828316125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"23", "/", "2"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "16"]}]], "+", 
        FractionBox[
         RowBox[{"8906625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"8906625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"71253", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"377", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "13"]}]], "+", 
        FractionBox[
         RowBox[{"71253", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"25", "/", "2"}]]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "15"]}]], "+", 
        FractionBox[
         RowBox[{"189", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"29", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"189", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"29", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "14"]}]], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"27", "/", "2"}]]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"157952079428395476360490147277859375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"268435456", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"157952079428395476360490147277859375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"268435456", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"20114650184795455550373108871875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"20114650184795455550373108871875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"196411940338736589298534828125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"196411940338736589298534828125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1103802639920172567958708125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"1103802639920172567958708125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"470143385262872718271875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"470143385262872718271875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1987598051517835882125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"1987598051517835882125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"5206853671516121625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"5206853671516121625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"4114788739936875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"4114788739936875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"828316125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"828316125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"71253", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"71253", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"29", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"29", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"24835232614527590622718576616015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"24835232614527590622718576616015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"461040755175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"461040755175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"268804870651357451445895182196875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"268804870651357451445895182196875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"536870912", " ", 
           SuperscriptBox["T", 
            RowBox[{"55", "/", "2"}]]}]], 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "2"}], " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2574675223653818310447757935600000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"4", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"4314668717768048640000", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{"19", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"134217728", " ", 
            SuperscriptBox["T", "13"], " ", 
            SuperscriptBox["U", "13"], " ", 
            RowBox[{"(", 
             RowBox[{"189", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"157952079428395476360490147277859375", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"3867490167187046400", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{"51", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1195426971648", " ", 
            SuperscriptBox["T", "12"], " ", 
            SuperscriptBox["U", "12"], " ", 
            RowBox[{"(", 
             RowBox[{"125", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1389683854540800", " ", 
            SuperscriptBox["T", "11"], " ", 
            SuperscriptBox["U", "11"], " ", 
            RowBox[{"(", 
             RowBox[{"184", "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"3081131689658762646466560000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"91", "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"20039880908349675749376000", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"150", "+", 
              RowBox[{"13", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"132975753326853730539966720000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"121", "+", 
              RowBox[{"17", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"62042974948451008512000", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"323", "+", 
              RowBox[{"22", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{
           "7947274436648828999269944517125000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"39", "+", 
              RowBox[{"25", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2646392459300871940022364000000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"207", "+", 
              RowBox[{"38", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"747978770508125082284230072200000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"125", "+", 
              RowBox[{"46", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"536870912", " ", 
           SuperscriptBox["T", 
            RowBox[{"55", "/", "2"}]]}]], 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"134217728", " ", 
            SuperscriptBox["T", "13"], " ", 
            SuperscriptBox["U", "13"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "189"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"4314668717768048640000", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "19"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"2574675223653818310447757935600000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"1195426971648", " ", 
            SuperscriptBox["T", "12"], " ", 
            SuperscriptBox["U", "12"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "125"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"3867490167187046400", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "51"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"157952079428395476360490147277859375", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1389683854540800", " ", 
            SuperscriptBox["T", "11"], " ", 
            SuperscriptBox["U", "11"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "184"}], "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"3081131689658762646466560000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "91"}], "+", 
              RowBox[{"10", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"20039880908349675749376000", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "150"}], "+", 
              RowBox[{"13", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"132975753326853730539966720000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "121"}], "+", 
              RowBox[{"17", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"62042974948451008512000", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "323"}], "+", 
              RowBox[{"22", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{
           "7947274436648828999269944517125000", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "39"}], "+", 
              RowBox[{"25", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2646392459300871940022364000000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "207"}], "+", 
              RowBox[{"38", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"747978770508125082284230072200000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "125"}], "+", 
              RowBox[{"46", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", "U"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"8687364368561751199826958100282265625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"]}], 
         RowBox[{"1073741824", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"8687364368561751199826958100282265625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"]}], 
         RowBox[{"1073741824", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"8687364368561751199826958100282265625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"268435456", " ", 
          SuperscriptBox["T", "28"]}]], "-", 
        FractionBox[
         RowBox[{"2895788122853917066608986033427421875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", "27"]}]], "-", 
        FractionBox[
         RowBox[{"579157624570783413321797206685484375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"82736803510111916188828172383640625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"9192978167790212909869796931515625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16777216", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"835725287980928446351799721046875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"64286560613917572796292286234375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"4285770707594504853086152415625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"252104159270264991358008965625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"13268639961592894282000471875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"631839998171090203904784375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"27471304268308269734990625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"1098852170732330789399625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"65536", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"40698228545641881088875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"32768", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"1403387191229030382375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"45270554555775173625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"1371834986538641625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"39195285329675475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"1059332035937175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"27162359895825", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"662496582825", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"15406897275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"342375495", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"7284585", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"148665", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{"2915", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "3"]}]], "-", 
        FractionBox[
         RowBox[{"55", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "2"]}]], "-", 
        FractionBox[
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "T"}], "-", "U"}]], 
         RowBox[{"2", " ", "T"}]], "+", 
        FractionBox[
         RowBox[{"8687364368561751199826958100282265625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox["U"]}], 
         RowBox[{"268435456", " ", 
          SuperscriptBox["T", "28"]}]], "+", 
        FractionBox[
         RowBox[{"4264706144566677861733233976502203125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", "U"}], 
         RowBox[{"268435456", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"4264706144566677861733233976502203125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", "U"}], 
         RowBox[{"268435456", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"684459010856380397562123971537390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "27"]}]], "-", 
        FractionBox[
         RowBox[{"263253465713992460600816912129765625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"4512916555097013610299718493653125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"3844336324712270853218278716815625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"167145057596185689270359944209375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"24545777688950345976766145653125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"389615518872227713916922946875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"87090527747909724287312188125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"2171231993715200882509168125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"195295999434700608479660625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"499478259423786722454375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"299686955654272033472625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32768", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"5179774542172603047675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"331709699745043544925", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"2469302975769554925", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"274366997307728325", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"3563207757243225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"173345242244265", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"493861089015", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"84317746905", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"840376215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"31125045", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"132447", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"8109", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{"53", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "2"]}]], "+", 
        FractionBox[
         RowBox[{"684459010856380397562123971537390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "27"]}]], "+", 
        FractionBox[
         RowBox[{"322858023988858678095341496008203125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"53", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"322858023988858678095341496008203125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"53", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"14901139568716554373631145969609375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"1958435486174175717677236327434375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"797881123996886403498133318584375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"66227286972073574993916204309375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"2315639404617957167619447703125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"139673487897591067253236528125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"14788957542097877709166220625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"696432903644498396276525625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"3684830178013219027918125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"141361771535033978053125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"39581296029809513854875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"1270510736759317728675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"18776020740285483675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"512496844027643475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"25883678991295125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"605073015380925", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"3270664948005", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"65226936285", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"4772702655", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"79280775", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"587265", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"7497", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"153", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "3"]}]], "+", 
        FractionBox[
         RowBox[{"14901139568716554373631145969609375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "26"]}]], "+", 
        FractionBox[
         RowBox[{"2240040588761312095382459851640625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"2240040588761312095382459851640625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"140802551293568188852611762103125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"109513095450553035774253592746875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"2164290423923973039016869421875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"287563063318569844344898734375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"8216087523387709838425678125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"65536", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"1643217504677541967685135625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"4551849043428094093310625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"361257860589531277246875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"6467532031014626446875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"3363116656127605752375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"24911975230574857425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"1349909987863662225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"16748262876720375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"1522569352429125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"3954725590725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"149638265595", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"1278959535", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"155970675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"518175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"11515", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"49", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         SuperscriptBox["T", "5"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "4"]}]], "+", 
        FractionBox[
         RowBox[{"140802551293568188852611762103125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"7", "/", "2"}]]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "25"]}]], "+", 
        FractionBox[
         RowBox[{"60343950554386366651119326615625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"60343950554386366651119326615625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"11174805658219697527985060484375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"839214654174601790639194265625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"52817705507492420389879359375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"2850479344848797290882378125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"33535051115868203422145625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"1393423176559620640809375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"51608265798504468178125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"1715875844963064159375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"205905101395567699125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"5592484235435172075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"137745917128945125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"3076211548785375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"31072843927125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"564960798675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"9161526465", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"130506075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"3183075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"31725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"235", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "5"]}]], "+", 
        FractionBox[
         RowBox[{"11174805658219697527985060484375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"9", "/", "2"}]]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", "24"]}]], "+", 
        FractionBox[
         RowBox[{"903494925558188310773260209375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"903494925558188310773260209375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"32140135691793260067032971875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"3820855292031366581395528125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"12129699339782116131414375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"2140535177608608729073125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"41506222280499338236875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"2854925342044928026875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"21904798020805074375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"9638111129154232725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"118989026285854725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"5275375549619175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"13090261909725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"925574074425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"7212265515", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"194926095", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"555345", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"40635", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"135", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "6"]}]], "+", 
        FractionBox[
         RowBox[{"32140135691793260067032971875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"11", "/", "2"}]]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "23"]}]], "+", 
        FractionBox[
         RowBox[{"4047276346373966082515263125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"4047276346373966082515263125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"28302631792824937639966875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"1347744371086901792379375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"110990712913038971137125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"3996895478862899237625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"63442785378776178375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"1784835394287820875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"356967078857564175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"7932601752390315", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"39076855923105", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"678754321245", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"20568312765", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"267120945", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"1443897", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"12341", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"301", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "7"]}]], "+", 
        FractionBox[
         RowBox[{"28302631792824937639966875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"13", "/", "2"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "22"]}]], "+", 
        FractionBox[
         RowBox[{"1410430155788618154815625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1410430155788618154815625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"31342892350858181218125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"4793618830131251245125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"39836167563417600375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"2318507106865574625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"29648428476541875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"10673434251555075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"26354158645815", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"908764091235", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"6764993235", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"341666325", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"887445", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"14391", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"82", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         SuperscriptBox["T", "9"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "8"]}]], "+", 
        FractionBox[
         RowBox[{"31342892350858181218125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"15", "/", "2"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "21"]}]], "+", 
        FractionBox[
         RowBox[{"9937990257589179410625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"9937990257589179410625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"350752597326676920375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"10687752273112039125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"282744769129948125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"6508191616801875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"260327664672075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"4499490500505", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"66494933505", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"824999175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"8333325", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"64935", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"351", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "+", 
        FractionBox[
         RowBox[{"350752597326676920375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"17", "/", "2"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "20"]}]], "+", 
        FractionBox[
         RowBox[{"10992246639867367875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"10992246639867367875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"152247183377664375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"7249865875126875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"18541856458125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"5191719808275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"38457183765", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"947221275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"2350425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"71225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"185", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "10"]}]], "+", 
        FractionBox[
         RowBox[{"152247183377664375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"19", "/", "2"}]]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "19"]}]], "+", 
        FractionBox[
         RowBox[{"7406619731886375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"7406619731886375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"39188464189875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"701583757875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"84190050945", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"1039383345", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"5120115", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"38115", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"385", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "+", 
        FractionBox[
         RowBox[{"39188464189875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"21", "/", "2"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "18"]}]], "+", 
        FractionBox[
         RowBox[{"712517530725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"712517530725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"5466886425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"1093377285", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"2699697", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"39897", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"99", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         SuperscriptBox["T", "13"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "12"]}]], "+", 
        FractionBox[
         RowBox[{"5466886425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"23", "/", "2"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "17"]}]], "+", 
        FractionBox[
         RowBox[{"276105375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"276105375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"11044215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"81809", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"403", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "13"]}]], "+", 
        FractionBox[
         RowBox[{"11044215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"25", "/", "2"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "16"]}]], "+", 
        FractionBox[
         RowBox[{"82215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"82215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"203", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "14"]}]], "+", 
        FractionBox[
         RowBox[{"203", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"27", "/", "2"}]]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "15"]}]], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "14"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"29", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "14"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"29", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"8687364368561751199826958100282265625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"536870912", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"8687364368561751199826958100282265625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"536870912", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"140802551293568188852611762103125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"140802551293568188852611762103125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"11174805658219697527985060484375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"11174805658219697527985060484375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"32140135691793260067032971875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"32140135691793260067032971875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"28302631792824937639966875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"28302631792824937639966875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"31342892350858181218125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"31342892350858181218125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"350752597326676920375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"350752597326676920375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"152247183377664375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"152247183377664375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"5466886425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"5466886425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"11044215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"11044215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"203", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"203", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"684459010856380397562123971537390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"684459010856380397562123971537390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"39188464189875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"39188464189875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"14901139568716554373631145969609375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"14901139568716554373631145969609375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"1073741824", " ", 
           SuperscriptBox["T", 
            RowBox[{"57", "/", "2"}]]}]], 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "2"}], " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"268435456", " ", 
            SuperscriptBox["T", "14"], " ", 
            SuperscriptBox["U", "14"]}], "+", 
           RowBox[{"370582361210880", " ", 
            SuperscriptBox["T", "12"], " ", 
            SuperscriptBox["U", "12"], " ", 
            RowBox[{"(", 
             RowBox[{"50", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"8687364368561751199826958100282265625", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"4108175586211683528622080000", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"45", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"13623099392", " ", 
            SuperscriptBox["T", "13"], " ", 
            SuperscriptBox["U", "13"], " ", 
            RowBox[{"(", 
             RowBox[{"405", "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"1144300099401697026865670193600000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"27", "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"15324614812267399102464000", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"85", "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"82184166052724736000", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{"189", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"61146089599795200", " ", 
            SuperscriptBox["T", "11"], " ", 
            SuperscriptBox["U", "11"], " ", 
            RowBox[{"(", 
             RowBox[{"391", "+", 
              RowBox[{"12", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"115927579823410944573304320000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"143", "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"15964274255741779968000", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{"361", "+", 
              RowBox[{"20", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"79472744366488289992699445171250000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"65", "+", 
              RowBox[{"24", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"3656833216488477589849084800000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"253", "+", 
              RowBox[{"36", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"3276859375559405122388055554400000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"175", "+", 
              RowBox[{"44", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{
           "210602772571193968480653529703812500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"81", "+", 
              RowBox[{"52", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"1073741824", " ", 
           SuperscriptBox["T", 
            RowBox[{"57", "/", "2"}]]}]], 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"268435456", " ", 
            SuperscriptBox["T", "14"], " ", 
            SuperscriptBox["U", "14"]}], "-", 
           RowBox[{"370582361210880", " ", 
            SuperscriptBox["T", "12"], " ", 
            SuperscriptBox["U", "12"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "50"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"8687364368561751199826958100282265625", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"13623099392", " ", 
            SuperscriptBox["T", "13"], " ", 
            SuperscriptBox["U", "13"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "405"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"4108175586211683528622080000", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "45"}], "+", 
              RowBox[{"4", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"1144300099401697026865670193600000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "27"}], "+", 
              RowBox[{"5", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"15324614812267399102464000", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "85"}], "+", 
              RowBox[{"6", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"82184166052724736000", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "189"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"61146089599795200", " ", 
            SuperscriptBox["T", "11"], " ", 
            SuperscriptBox["U", "11"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "391"}], "+", 
              RowBox[{"12", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"115927579823410944573304320000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "143"}], "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"15964274255741779968000", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "361"}], "+", 
              RowBox[{"20", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"79472744366488289992699445171250000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "65"}], "+", 
              RowBox[{"24", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"3656833216488477589849084800000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "253"}], "+", 
              RowBox[{"36", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"3276859375559405122388055554400000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "175"}], "+", 
              RowBox[{"44", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{
           "210602772571193968480653529703812500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "81"}], "+", 
              RowBox[{"52", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2147483648", " ", 
        SuperscriptBox["T", 
         RowBox[{"59", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"495179769008019818390136611716089140625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"495179769008019818390136611716089140625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"1980719076032079273560546446864356562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"1320479384021386182373697631242904375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"528191753608554472949479052497161750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"150911929602444135128422586427760500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"33535984356098696695205019206169000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"6097451701108853944582730764758000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"938069492478285222243497040732000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"125075932330438029632466272097600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"14714815568286827015584267305600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"1548927954556508106903607084800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"147516948053000772086057817600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"12827560700260936703135462400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"1026204856020874936250836992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"76015174520064810092654592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"5242425828969986902941696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"338221021223870122770432000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"20498243710537583198208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"1171328212030719039897600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"63315038488146975129600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"3246925050674203852800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"158386587837766041600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"7366818038965862400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"327414135065149440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"13932516385751040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"568674138193920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"22300946595840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"841545154560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"30601641984", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "+", 
        RowBox[{"1980719076032079273560546446864356562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"972984809278916134380619307231613750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"972984809278916134380619307231613750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"1250980469072892172775081966440646250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"481859143642891799883735275962323000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"132378885616179065902125075813825000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"28240828931451534059120016173616000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4920750495631706692119396757524000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"724123818755167539977436312144000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"92161213296112232360764621545600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"10326186363710054046024047232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1032618636371005404602404723200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"93168598770316277106983884800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7651527435243365752747468800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"576115006888912244912750592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"40007986589507794785607680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2575226723002800583901184000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"154276255295098652491776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"8630839457068456083456000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"452091590608347699609600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"22215802978297184256000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1025344752844485427200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"44459393077267660800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1809393904307404800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"68929291592663040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2444301120307200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"79813914132480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2347468062720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"59055800320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"1250980469072892172775081966440646250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"295686292689956331746837555704152750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"295686292689956331746837555704152750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"219026883474041727219879670891965000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"57765331905241774211836396718760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"11809801189516096061086552218057600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1968300198252682676847758703009600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"276483639888336697082293864636800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"33513168471313539040278044198400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3567228016554382306808307225600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"337947917357783586960787000320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"28797566892643212923976837120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2225898890252615491708354560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"157122274606066975885295616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"10183851131874711399972864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"608689952709752865285734400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"33660273882566978725478400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1726167891413691216691200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"82198471019699581747200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3635313214630448332800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"149141054959197880320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5658468209834065920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"197388425924444160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6266299235696640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"177767354204160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4353486225408", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"85362475008", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"219026883474041727219879670891965000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"33060661656459128636962969191240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"33060661656459128636962969191240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"16711982815352966124179083327440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3268121083891246708728354072921600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"519928354255425612752238147964800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"69555632676311118762841223808000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8009436489999462160569595468800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"807674267899105427956597862400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"72265592390972590922432440320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5795736733110583733127413760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"419980922689172734284595200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"27669331377169027199926272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1665283832885172933328896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"91877728710906092873318400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4657396386267129131827200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"217128036655810215936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"9305487285249009254400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"365817681975391027200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"13131916788860190720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"427054204515778560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"12414366410342400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"315285496135680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6708202045440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"109521666048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"16711982815352966124179083327440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"1802272656557672817313430554920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1802272656557672817313430554920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"672848458448197851797014073836800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"101946736128514826029850617248000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"12956441380881482906803757376000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1413429968823434498924046259200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"134612377983184237992766310400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"11335779198583935830969794560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"852314225457438784283443200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"57644440369102139999846400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3526483410815660329402368000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"195915745045314462744576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9908382508038892368691200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"456607488849718542336000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"19158356175512666112000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"729842140019530137600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"25105135037526835200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"772465693462364160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"20934029633126400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"486837898444800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9273102827520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"131533373440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"672848458448197851797014073836800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"54926404771281457289552169292800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"54926404771281457289552169292800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"15812146828096177098507442675200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1903803631476462794469123532800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"196149465061211318218030909440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"17582024879436308635789885440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1388054595744971734404464640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"97407340052278718203822080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"6117369182027165877534720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"345451436161534073084313600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"17592434248967012981145600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"808847551676644274995200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"33546672650183403110400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1251157954319194521600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"41705265143973150720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1229639267144171520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"31529211978055680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"683560151285760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"11922560778240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"151397597184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"15812146828096177098507442675200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"1009285967750819814798347404800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1009285967750819814798347404800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"229536608050353670255142553600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"22258095326094901358074429440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1870428178663437088913817600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"137821023690990101288386560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8980818586380307352125440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"520627164427843904471040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"26950112040970743290265600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1247690372267164041216000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"51628567128296443084800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1903357313485583155200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"62114224682513203200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1774692133786091520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"43604229331353600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"894445729873920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"14543833006080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"169114337280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"229536608050353670255142553600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"11659002313668757854229463040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"11659002313668757854229463040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2119818602485228700768993280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"166260282547861074570117120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"11375703542748389312692224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"684252844676594845876224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"36361262277500209201152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1711118224823539256524800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"71296592700980802355200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2622403409691247902720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"84593658377137029120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2366256178381455360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"56339432818606080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1107408998891520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"17037061521408", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"184683593728", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"2119818602485228700768993280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"86271687310445354101063680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"86271687310445354101063680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"12566184146059267264020480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"793653735540585300885504000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"43760356345596182003712000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2114026876598849372160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"89535255950068914585600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"3316120590743293132800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"106725720161853112320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2950941571295477760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"68786516813414400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1310219367874560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"19315273236480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"198105366528", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"12566184146059267264020480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"408656394993797309399040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"408656394993797309399040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"47318108894018635825152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2371835032281635880960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"103123262273114603520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"3882287520870196838400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"125814873361534156800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"3470755127214735360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"79971316295270400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1491306597580800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"21304379965440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"209379655680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"47318108894018635825152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"1213284843436375277568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1213284843436375277568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"109469309182229348352000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"4230697939409829888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"139364167415853219840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3871226872662589440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"88993721210634240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1640437257338880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"22943178424320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"218506461184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"109469309182229348352000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"2151730893016793088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"2151730893016793088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"145527693247512576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"4109017221106237440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"95116139377459200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1749262333378560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"24183350231040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"225485783040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"145527693247512576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"2078967046393036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"2078967046393036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"97833743359672320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1811735988142080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"24989461905408", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"230317621248", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"97833743359672320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"912202735288320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"912202735288320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"25338964869120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"233001975808", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"25338964869120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"116769423360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"116769423360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"1073741824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"990359538016039636780273223432178281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"990359538016039636780273223432178281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"625490234536446086387540983220323125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"625490234536446086387540983220323125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"109513441737020863609939835445982500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"109513441737020863609939835445982500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"8355991407676483062089541663720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"8355991407676483062089541663720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"336424229224098925898507036918400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"336424229224098925898507036918400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"7906073414048088549253721337600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"7906073414048088549253721337600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"114768304025176835127571276800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"114768304025176835127571276800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"1059909301242614350384496640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1059909301242614350384496640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"6283092073029633632010240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"6283092073029633632010240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"23659054447009317912576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"23659054447009317912576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"54734654591114674176000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"54734654591114674176000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"72763846623756288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"72763846623756288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"48916871679836160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"48916871679836160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"12669482434560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"12669482434560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"536870912", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"536870912", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"495179769008019818390136611716089140625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"972984809278916134380619307231613750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"295686292689956331746837555704152750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"33060661656459128636962969191240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1802272656557672817313430554920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"54926404771281457289552169292800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1009285967750819814798347404800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"11659002313668757854229463040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"86271687310445354101063680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"408656394993797309399040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1213284843436375277568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2151730893016793088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2078967046393036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"912202735288320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"116769423360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"990359538016039636780273223432178281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"625490234536446086387540983220323125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"109513441737020863609939835445982500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"8355991407676483062089541663720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"336424229224098925898507036918400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7906073414048088549253721337600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"114768304025176835127571276800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1059909301242614350384496640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6283092073029633632010240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"23659054447009317912576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"54734654591114674176000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"72763846623756288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"48916871679836160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"12669482434560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"536870912", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"495179769008019818390136611716089140625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"972984809278916134380619307231613750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"295686292689956331746837555704152750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"33060661656459128636962969191240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1802272656557672817313430554920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"54926404771281457289552169292800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1009285967750819814798347404800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"11659002313668757854229463040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"86271687310445354101063680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"408656394993797309399040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1213284843436375277568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2151730893016793088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2078967046393036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"912202735288320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"116769423360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"990359538016039636780273223432178281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"625490234536446086387540983220323125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"109513441737020863609939835445982500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"8355991407676483062089541663720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"336424229224098925898507036918400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"7906073414048088549253721337600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"114768304025176835127571276800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1059909301242614350384496640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"6283092073029633632010240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"23659054447009317912576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"54734654591114674176000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"72763846623756288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"48916871679836160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"12669482434560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"536870912", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", "U"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"29215606371473169285018060091249259296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"]}], 
         RowBox[{"4294967296", " ", 
          SuperscriptBox["T", 
           RowBox[{"61", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"29215606371473169285018060091249259296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"]}], 
         RowBox[{"4294967296", " ", 
          SuperscriptBox["T", 
           RowBox[{"61", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"29215606371473169285018060091249259296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"1073741824", " ", 
          SuperscriptBox["T", "30"]}]], "-", 
        FractionBox[
         RowBox[{"9738535457157723095006020030416419765625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"536870912", " ", 
          SuperscriptBox["T", "29"]}]], "-", 
        FractionBox[
         RowBox[{"1947707091431544619001204006083283953125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"268435456", " ", 
          SuperscriptBox["T", "28"]}]], "-", 
        FractionBox[
         RowBox[{"278243870204506374143029143726183421875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", "27"]}]], "-", 
        FractionBox[
         RowBox[{"30915985578278486015892127080687046875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"2810544143479862365081102461880640625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"216195703344604797313930958606203125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16777216", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"14413046889640319820928730573746875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"847826287625901165936984151396875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"44622436190836903470367586915625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"2124877913849376355731789853125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"92385996254320711118773471875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"3695439850172828444750938875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"136868142598993646101886625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"4719591124103229175927125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"65536", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"152244874971071908900875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"32768", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"4613481059729451784875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"131813744563698622425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"3562533636856719525", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"91347016329659475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"2227976008040475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"51813395535825", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"1151408789685", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"24498059355", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"499960395", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"9803145", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"184965", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{"3363", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "3"]}]], "-", 
        FractionBox[
         RowBox[{"59", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "2"]}]], "-", 
        FractionBox[
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "T"}], "-", "U"}]], 
         RowBox[{"2", " ", "T"}]], "+", 
        FractionBox[
         RowBox[{"29215606371473169285018060091249259296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox["U"]}], 
         RowBox[{"1073741824", " ", 
          SuperscriptBox["T", "30"]}]], "+", 
        FractionBox[
         RowBox[{"14360213301232574733313961739766585078125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", "U"}], 
         RowBox[{"1073741824", " ", 
          SuperscriptBox["T", 
           RowBox[{"59", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"14360213301232574733313961739766585078125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", "U"}], 
         RowBox[{"1073741824", " ", 
          SuperscriptBox["T", 
           RowBox[{"59", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1155419461018712909576985427337541328125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "29"]}]], "-", 
        FractionBox[
         RowBox[{"891323584214435673102245901088960453125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", "28"]}]], "-", 
        FractionBox[
         RowBox[{"61307971400992929895921675736277703125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "27"]}]], "-", 
        FractionBox[
         RowBox[{"13099993889101053396564460627409765625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"142909024244738764326157752299015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"84279680964845937935939187253265625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"2687178233661754542885017564596875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"301768678646507194655536731853125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"3781562389053974870370134484375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"684282718019290690828881478125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"14092779089642142374050190625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"1064787753439628534928236625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"2319799027101587222065875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"1199896048500820976930625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32768", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"18062951267754294276375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"1016529725025133444125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"6702393791374506225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"664201186532608725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"7741272570310125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"339860746989225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"878193144675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"136607822505", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"1245664035", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"42369525", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"166155", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"9405", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{"57", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", "U"}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "2"]}]], "+", 
        FractionBox[
         RowBox[{"1155419461018712909576985427337541328125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "29"]}]], "+", 
        FractionBox[
         RowBox[{"547303955219390325589098360317782734375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"547303955219390325589098360317782734375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", 
           RowBox[{"57", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"203284326224344978075950819546605015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "28"]}]], "-", 
        FractionBox[
         RowBox[{"26889461140786372761369156024683203125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"33554432", " ", 
          SuperscriptBox["T", "27"]}]], "-", 
        FractionBox[
         RowBox[{"689473362584265968240234769863671875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"57665044870684062798274180752234375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"16264499835321145917461948417296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"990013033454330621062901208009375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"26470936723377824092590941390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"1260520796351324956790044828125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"108044639687256424867718128125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"4203109553051165269453565625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"18680486902449623419793625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"610473428184628216333125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"147355655079048190149375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"4119620464575540799875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"53501564475007023375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"1293444415879290675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"58263261976544625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"1222306195312125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"5962469245425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"107848280925", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"7189885395", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"109268775", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"743325", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"8745", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "5"]}]], "-", 
        FractionBox[
         RowBox[{"165", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "4"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "2"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "3"]}]], "+", 
        FractionBox[
         RowBox[{"203284326224344978075950819546605015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", "28"]}]], "+", 
        FractionBox[
         RowBox[{"30800655488537117890295578719182578125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"30800655488537117890295578719182578125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"67108864", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"488899293468843141115802836812421875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "27"]}]], "-", 
        FractionBox[
         RowBox[{"96108408117806771330456967920390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"3844336324712270853218278716815625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"2070027251768145844040611616746875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"30000394953161533971603066909375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"3048168471176840350055926584375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"68755679800981361279456990625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"65536", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"11131871967777934683340655625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"25473391230613122845173125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"1698226082040874856344875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"25898872710863015238375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"11609839491076524072375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"74902190265009832725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"3566770965000468225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"39195285329675475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"3177996107811525", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"7407916335225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"252953240715", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"1960877835", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"217875315", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"662235", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"13515", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{"53", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         SuperscriptBox["T", "5"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "3"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "4"]}]], "+", 
        FractionBox[
         RowBox[{"488899293468843141115802836812421875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"7", "/", "2"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "27"]}]], "+", 
        FractionBox[
         RowBox[{"212163844335535702748367268805390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", 
           RowBox[{"53", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"212163844335535702748367268805390625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"8388608", " ", 
          SuperscriptBox["T", 
           RowBox[{"53", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"19947028099922160087453332964609375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "26"]}]], "-", 
        FractionBox[
         RowBox[{"1523227600357692224860072699115625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"195285589789447721135906756296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"1048576", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"10754858568114512178499212665625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"517613513973425719820817721875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"22053708615409115882089978125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"210035320146753484591333125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"7209450348286732880709375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"224294010835587245177625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"6352553683796588643375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"657160725909991928625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"15545737602171852075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"336487826886836625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"6655803169190175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"59962190713425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"978404044275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"14318107965", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"184988475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"4110855", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"37485", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{"255", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "6"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "4"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "5"]}]], "+", 
        FractionBox[
         RowBox[{"19947028099922160087453332964609375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"9", "/", "2"}]]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", "26"]}]], "+", 
        FractionBox[
         RowBox[{"1642696431758295536613803891203125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1642696431758295536613803891203125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2097152", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"29867207850150827938432798021875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "25"]}]], "-", 
        FractionBox[
         RowBox[{"14550691003919634123851875959375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"379583243580512194535266329375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"34507567598228381321387848125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"86485131825133787772901875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"12355018832161969681843125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"197906480149047569274375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"11434596630833859558075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"74735925691724572275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"28348109745136906725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"304818384356310825", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"11876040948947175", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"26101188898785", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"1646020921545", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"11510635815", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"280747215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"725445", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"48363", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{"147", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "7"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "5"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "6"]}]], "+", 
        FractionBox[
         RowBox[{"29867207850150827938432798021875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"11", "/", "2"}]]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "25"]}]], "+", 
        FractionBox[
         RowBox[{"3860387409203168236940293621875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"3860387409203168236940293621875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"890858632893038823909298528125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "24"]}]], "-", 
        FractionBox[
         RowBox[{"43897381910671478279588623125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"131072", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"234745357811077423955019375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"8825013451544264058459375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"588334230102950937230625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"17501933618623254425625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"233359114914976725675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"5592484235435172075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"964221419902615875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"18662350062631275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"80789394210525", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"1242913757085", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"33592263705", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"391518225", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"1909845", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"14805", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "-", 
        FractionBox[
         RowBox[{"329", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "8"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "6"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "7"]}]], "+", 
        FractionBox[
         RowBox[{"890858632893038823909298528125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"13", "/", "2"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", "24"]}]], "+", 
        FractionBox[
         RowBox[{"46032208994473130718717553125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"46032208994473130718717553125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"133426692737603277445558125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "23"]}]], "-", 
        FractionBox[
         RowBox[{"10702675888043043645365625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"187766243649877958690625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"23247249213794413933125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"159592099865865541875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"7802280437886759825", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"84992161632753375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"26376877748095875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"56724468275475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"1718923281075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"11333560095", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"510520725", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"1190025", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"17415", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{"90", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         SuperscriptBox["T", "9"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "7"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "8"]}]], "+", 
        FractionBox[
         RowBox[{"133426692737603277445558125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"15", "/", "2"}]]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "23"]}]], "+", 
        FractionBox[
         RowBox[{"44475564245867759148519375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"32768", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"44475564245867759148519375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"32768", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1664860693695584567056875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "22"]}]], "-", 
        FractionBox[
         RowBox[{"54243581498853632510625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"4096", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"1549816614252960928875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"2048", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"39011402189433799125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"866920048654084425", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"16998432326550675", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"586152838846575", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"8823806176185", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"114594885405", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"1259284455", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"11344905", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"79335", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{"387", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "10"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "8"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "9"]}]], "+", 
        FractionBox[
         RowBox[{"1664860693695584567056875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"17", "/", "2"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", "22"]}]], "+", 
        FractionBox[
         RowBox[{"55925553018197931193125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"55925553018197931193125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"420492879836074670625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "21"]}]], "-", 
        FractionBox[
         RowBox[{"44051635030445917875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"504023284101211875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"20160931364048475", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"43923597743025", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"10602247731075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"128", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"68401598265", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"1480554075", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"3253965", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"87945", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{"205", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "9"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "10"]}]], "+", 
        FractionBox[
         RowBox[{"420492879836074670625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"19", "/", "2"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "21"]}]], "+", 
        FractionBox[
         RowBox[{"22563032576569860375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"22563032576569860375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", 
           RowBox[{"41", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1074430122693802875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "20"]}]], "-", 
        FractionBox[
         RowBox[{"22127851497126375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"256", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"98346006653895", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"1499830166835", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"155154844845", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"1668331665", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"7222215", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"47619", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "13"]}]], "-", 
        FractionBox[
         RowBox[{"429", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "12"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "10"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "11"]}]], "+", 
        FractionBox[
         RowBox[{"1074430122693802875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"21", "/", "2"}]]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", "20"]}]], "+", 
        FractionBox[
         RowBox[{"22540492084485375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"22540492084485375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"512", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"51580073419875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "19"]}]], "-", 
        FractionBox[
         RowBox[{"1604713395285", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"10488322845", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"1808331525", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"3888885", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"50505", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{"111", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         SuperscriptBox["T", "13"]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "11"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "12"]}]], "+", 
        FractionBox[
         RowBox[{"51580073419875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"23", "/", "2"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "19"]}]], "+", 
        FractionBox[
         RowBox[{"3252797422875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"3252797422875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"64", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"43370632305", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "18"]}]], "-", 
        FractionBox[
         RowBox[{"472446975", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "17"]}]], "-", 
        FractionBox[
         RowBox[{"16291275", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"105105", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{"455", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "14"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "12"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "13"]}]], "+", 
        FractionBox[
         RowBox[{"43370632305", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"25", "/", "2"}]]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", "18"]}]], "+", 
        FractionBox[
         RowBox[{"476600355", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"476600355", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"16", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1038345", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "13"]}], 
         SuperscriptBox["T", "17"]], "-", 
        FractionBox[
         RowBox[{"107415", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{"231", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "15"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "13"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "14"]}]], "+", 
        FractionBox[
         RowBox[{"1038345", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"27", "/", "2"}]]}], 
         SuperscriptBox["T", "17"]], "+", 
        FractionBox[
         RowBox[{"13485", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "14"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"13485", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "14"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"465", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "14"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "16"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "T"}], "-", "U"}]], " ", 
          SuperscriptBox["U", "14"]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", "15"]}]], "+", 
        FractionBox[
         RowBox[{"465", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", 
           RowBox[{"29", "/", "2"}]]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", "16"]}]], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "15"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "15"]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["T", 
           RowBox[{"31", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"29215606371473169285018060091249259296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2147483648", " ", 
          SuperscriptBox["T", 
           RowBox[{"61", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"29215606371473169285018060091249259296875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2147483648", " ", 
          SuperscriptBox["T", 
           RowBox[{"61", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"488899293468843141115802836812421875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"488899293468843141115802836812421875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "3"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"55", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"19947028099922160087453332964609375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"53", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"19947028099922160087453332964609375", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "4"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"4194304", " ", 
          SuperscriptBox["T", 
           RowBox[{"53", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"29867207850150827938432798021875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"29867207850150827938432798021875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "5"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"262144", " ", 
          SuperscriptBox["T", 
           RowBox[{"51", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"890858632893038823909298528125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"890858632893038823909298528125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "6"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"524288", " ", 
          SuperscriptBox["T", 
           RowBox[{"49", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"133426692737603277445558125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"133426692737603277445558125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "7"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"8192", " ", 
          SuperscriptBox["T", 
           RowBox[{"47", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1664860693695584567056875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"1664860693695584567056875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "8"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"16384", " ", 
          SuperscriptBox["T", 
           RowBox[{"45", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"420492879836074670625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"420492879836074670625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"51580073419875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"51580073419875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "11"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"39", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"43370632305", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"43370632305", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "12"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"32", " ", 
          SuperscriptBox["T", 
           RowBox[{"37", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1038345", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"1038345", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "13"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"2", " ", 
          SuperscriptBox["T", 
           RowBox[{"35", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"465", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "14"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"465", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "14"], " ", 
          SqrtBox[
           RowBox[{"T", " ", "U"}]]}], 
         RowBox[{"8", " ", 
          SuperscriptBox["T", 
           RowBox[{"33", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1155419461018712909576985427337541328125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", 
           RowBox[{"61", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"1155419461018712909576985427337541328125", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", 
           RowBox[{"61", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"1074430122693802875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"1074430122693802875", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["U", "9"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"3", "/", "2"}]]}], 
         RowBox[{"1024", " ", 
          SuperscriptBox["T", 
           RowBox[{"43", "/", "2"}]]}]], "-", 
        FractionBox[
         RowBox[{"203284326224344978075950819546605015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", 
           RowBox[{"61", "/", "2"}]]}]], "+", 
        FractionBox[
         RowBox[{"203284326224344978075950819546605015625", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]], " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"T", " ", "U"}], ")"}], 
           RowBox[{"5", "/", "2"}]]}], 
         RowBox[{"134217728", " ", 
          SuperscriptBox["T", 
           RowBox[{"61", "/", "2"}]]}]], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"4294967296", " ", 
           SuperscriptBox["T", 
            RowBox[{"61", "/", "2"}]]}]], 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "2"}], " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"1073741824", " ", 
            SuperscriptBox["T", "15"], " ", 
            SuperscriptBox["U", "15"]}], "+", 
           RowBox[{"4506486561335108173824000", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{"21", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"249644974080", " ", 
            SuperscriptBox["T", "14"], " ", 
            SuperscriptBox["U", "14"], " ", 
            RowBox[{"(", 
             RowBox[{"116", "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "+", 
           RowBox[{"29215606371473169285018060091249259296875", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2910553864950251520", " ", 
            SuperscriptBox["T", "12"], " ", 
            SuperscriptBox["U", "12"], " ", 
            RowBox[{"(", 
             RowBox[{"75", "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2432637973553258015154991180800000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"26", "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"61168041677108895617910370348800000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"55", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"220459370983495916912640000", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{"133", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"278728613560320", " ", 
            SuperscriptBox["T", "13"], " ", 
            SuperscriptBox["U", "13"], " ", 
            RowBox[{"(", 
             RowBox[{"459", "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"500392187629156869110032786576258500000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"35", "+", 
              RowBox[{"13", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"31173802977723951481896960000", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"187", "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"31289554782005961031411381555995000000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"63", "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"432685016530550784000", " ", 
            SuperscriptBox["T", "11"], " ", 
            SuperscriptBox["U", "11"], " ", 
            RowBox[{"(", 
             RowBox[{"437", "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"928443489741831451343282407080000000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"117", "+", 
              RowBox[{"22", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{"2186062933812892097668024320000", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"345", "+", 
              RowBox[{"32", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "+", 
           RowBox[{
           "660239692010693091186848815621452187500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{"87", "+", 
              RowBox[{"56", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"4294967296", " ", 
           SuperscriptBox["T", 
            RowBox[{"61", "/", "2"}]]}]], 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"1073741824", " ", 
            SuperscriptBox["T", "15"], " ", 
            SuperscriptBox["U", "15"]}], "-", 
           RowBox[{"249644974080", " ", 
            SuperscriptBox["T", "14"], " ", 
            SuperscriptBox["U", "14"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "116"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"4506486561335108173824000", " ", 
            SuperscriptBox["T", "10"], " ", 
            SuperscriptBox["U", "10"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "21"}], "+", 
              SqrtBox[
               RowBox[{"T", " ", "U"}]]}], ")"}]}], "-", 
           RowBox[{"2910553864950251520", " ", 
            SuperscriptBox["T", "12"], " ", 
            SuperscriptBox["U", "12"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "75"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"29215606371473169285018060091249259296875", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"2432637973553258015154991180800000", " ", 
            SuperscriptBox["T", "6"], " ", 
            SuperscriptBox["U", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "26"}], "+", 
              RowBox[{"3", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"278728613560320", " ", 
            SuperscriptBox["T", "13"], " ", 
            SuperscriptBox["U", "13"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "459"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"220459370983495916912640000", " ", 
            SuperscriptBox["T", "9"], " ", 
            SuperscriptBox["U", "9"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "133"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"61168041677108895617910370348800000", " ", 
            SuperscriptBox["T", "5"], " ", 
            SuperscriptBox["U", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "55"}], "+", 
              RowBox[{"8", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"500392187629156869110032786576258500000", " ", 
            SuperscriptBox["T", "2"], " ", 
            SuperscriptBox["U", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "35"}], "+", 
              RowBox[{"13", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"31173802977723951481896960000", " ", 
            SuperscriptBox["T", "8"], " ", 
            SuperscriptBox["U", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "187"}], "+", 
              RowBox[{"14", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"432685016530550784000", " ", 
            SuperscriptBox["T", "11"], " ", 
            SuperscriptBox["U", "11"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "437"}], "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"31289554782005961031411381555995000000", " ", 
            SuperscriptBox["T", "3"], " ", 
            SuperscriptBox["U", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "63"}], "+", 
              RowBox[{"16", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"928443489741831451343282407080000000", " ", 
            SuperscriptBox["T", "4"], " ", 
            SuperscriptBox["U", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "117"}], "+", 
              RowBox[{"22", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{"2186062933812892097668024320000", " ", 
            SuperscriptBox["T", "7"], " ", 
            SuperscriptBox["U", "7"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "345"}], "+", 
              RowBox[{"32", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}], "-", 
           RowBox[{
           "660239692010693091186848815621452187500", " ", "T", " ", "U", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "87"}], "+", 
              RowBox[{"56", " ", 
               SqrtBox[
                RowBox[{"T", " ", "U"}]]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"8589934592", " ", 
        SuperscriptBox["T", 
         RowBox[{"63", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"1782151988659863326386101665566204817109375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"1782151988659863326386101665566204817109375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"7128607954639453305544406662264819268437500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"4752405303092968870362937774843212845625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"1900962121237187548145175109937285138250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"543132034639196442327192888553510039500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"120696007697599209406042864123002231000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"21944728672290765346553248022364042000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"3376112103429348514854345849594468000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"450148280457246468647246113279262400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"52958621230264290429087778032854400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"5574591708448872676746081898195200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"530913496042749778737722085542400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"46166390960239111194584529177600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"3693311276819128895566762334208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"273578613097713251523463876608000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"18867490558462982863687163904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"1217257455384708571850784768000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"73773179114224761930350592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"4215610235098557824591462400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"227870823518840963491430400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"11685683257376459666227200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"570033329628119983718400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"26513178122238138777600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"1178363472099472834560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"50143126472317992960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"2046658223359918080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"80261106798428160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"3028721011261440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"110135309500416", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"3864396824576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"130996502528", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "+", 
        RowBox[{"7128607954639453305544406662264819268437500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"3505872764576780314202167210949911115625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"3505872764576780314202167210949911115625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"4518680452121183516082793294113218771250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1745145553922663978625078789450622422000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"480805407713387014519154360358844953000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"102888400004510801460888998924526492000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"17987482518271119136519055756036100000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2656612802698503749393583619353024000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"339456080344808812422513462472886400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"38199661215272602932456757925337600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3838243471391027088907138356134400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"348139997405081822123096449536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"28759391089985020088429706700800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2179659114188338364596777771008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"152486440087250009045865111552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9897699965095335272753922048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"598651207566250117303664640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"33863098609808087443439616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1796817477255123007202918400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"89654094499216116783513600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4214508715775116600934400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"186896173648563929088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7823560757381745868800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"309078943501501071360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"11508258534630359040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"402621289841295360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"13157558491545600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"397209312952320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"10832981262336", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"253403070464", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"4518680452121183516082793294113218771250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"1072229259825365580087442476569238352500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1072229259825365580087442476569238352500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"798625931456134363099612327375708566000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"211880349161831565720305311344575742000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"43596779662928305703766524968019700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"7316942041330624733499276917709600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1035628719696026885356820732968128000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"126576843518403285988055867362771200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13596489585097028162399862990374400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1301099481827466809799029951232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"112112880520280586785403941376000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8774051518978480704944656281600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"628037371884775460985512239104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"41352254938915256690404098048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2516364397905593713412014080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"142052828914025451563581440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"7461360710635680284147712000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"365454402153584340448051200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"16715170160870801434214400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"714323511148324847616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"28509585810797887488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1060821797611084185600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"36670383127296737280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1170331376403087360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"34120448291635200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"892037863833600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"20197083709440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"367219703808", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"798625931456134363099612327375708566000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"121428504198008733570701289542505396000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"121428504198008733570701289542505396000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"61953318468371802842194535480870100000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"12237692536962331425618673675233600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1968300198252682676847758703009600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"266477565301901654711696562868992000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"31089049285221859716364599001382400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3180465400022696646175406547456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"289133218183881513288673322496000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"23602711688480123533769250816000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1744548255235487391626422886400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"117527461405338097962201120768000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7254781568230746787790192640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"412036275680448093424189440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"21598675741313811348848640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1047208520790972671459328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"47017525423268160759398400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1954990662090152214528000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"75191948541928931328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2667563584636059648000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"86850907406755430400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2573360219459420160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"68440431368601600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1596278282649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"31299574169600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"472446402560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"61953318468371802842194535480870100000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"6758543832913287582784858416094920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6758543832913287582784858416094920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2558790257728487479902086313912480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"393660039650536535369551740601920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"50872989739453952263142071093171200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5652554415494883584793563454796800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"549353114549374875248479312742400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"47312708430089702174510180044800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3647691806401473637037066035200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"253752473488798166054752419840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"16026472009818831540300152832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"923335835956640500264206336000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"48695196216780229222858752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2356219171779688510783488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"104720852079097267145932800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4274320493024378250854400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"159953781443739726643200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5468505348503922278400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"169754046295021977600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4737322222186659840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"116970919066337280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2488742958858240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"43534862254080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"569083166720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"2558790257728487479902086313912480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"212427870452931036067343014739904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"212427870452931036067343014739904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"62391402510651073530268577755776000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7678941847464747511417671108403200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"810554972787945570649643061442560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"74629102353877341543189642485760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"6070309760841697637484324986880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"440475991716404363717683445760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"28726695111939415025066311680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1693363080282744464635487846400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"90591440508953407573091942400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4410130978123492457919283200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"195610648223219423536742400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7903460534271491860070400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"290331203299769088737280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"9657586804150323118080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"288902169354924195840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7686975681284014080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"178766876308930560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3531197556719616", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"56348897181696", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"657129996288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"62391402510651073530268577755776000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"4077869445140593041194024689920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4077869445140593041194024689920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"953594085632877141940756542873600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"95359408563287714194075654287360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8292122483764149060354404720640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"634803635120700406534308495360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"43183920756510231737027788800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2628586480831057583992995840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"143880523161278941439616614400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7105211020310071182203289600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"317068240257244555798118400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"12785009687792119185408000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"464909443192440697651200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"15180716512406226862080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"441850376660472299520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"11329496837448007680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"251208355597516800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4673643825070080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"69239167778816", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"736586891264", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"953594085632877141940756542873600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"50042838313095593454616961433600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"50042838313095593454616961433600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"9452536125806945430316537159680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"773609094695197579974754959360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"55522183829798869376178585600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3525218020939610754043084800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"199251453357456260011130880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"10067441853850421558457139200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"455727820544669288654438400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"18487944038323297714176000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"670933453003668062208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"21686737874866038374400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"619621082139029667840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"15458322215526727680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"330306030246297600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"5859087011020800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"81754702479360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"807453851648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"9452536125806945430316537159680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"402235579821572145970916474880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"402235579821572145970916474880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"61724129895893423934155980800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4134630710729703038651596800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"243765075916036913843404800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"12718177873880186809221120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"589052448895503389058662400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"24240841518333472800768000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"885061150770796167168000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"28550359702283747328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"807484920872671641600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"19775140919330734080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"411125590838476800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"7027787877580800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"93496069324800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"869730877440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"61724129895893423934155980800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"2133673626030883790316503040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2133673626030883790316503040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"265433082664129083962818560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"14445337832061446746275840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"690863983272503974821888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"29089009822000167360921600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1077370734148154346700800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"34965378795883305369600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"986926014399932006400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"23925479136968048640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"488275084427919360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"8120999325204480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"104115375964160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"923417968640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"265433082664129083962818560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"7407434865045462808264704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"7407434865045462808264704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"739063796058957740507136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"32133208524302510456832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1217679480920937238364160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"40088213363652254760960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1138407681726433198080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"27542121332091125760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"556406491557396480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"9084187617263616", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"113316269654016", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"968515125248", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"739063796058957740507136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"16387223859400393359360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"16387223859400393359360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1282478388996552523776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"43199272050410190274560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1244423474703174205440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"30290226564783144960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"610690051709337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"9869738209443840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"120853937258496", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1005022347264", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"1282478388996552523776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"21922707504214573056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"21922707504214573056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1292285916037911674880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"31908294223158312960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"647227063350067200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"10439146183065600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"126535105249280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1032939634688", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"1292285916037911674880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"16119990636647546880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"16119990636647546880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"663374100273561600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"10764691282329600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"130218039705600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1052266987520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"663374100273561600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"5415298777743360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"5415298777743360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"131812546314240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1063004405760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"131812546314240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"532575944704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"532575944704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"3564303977319726652772203331132409634218750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"3564303977319726652772203331132409634218750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"2259340226060591758041396647056609385625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"2259340226060591758041396647056609385625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"399312965728067181549806163687854283000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"399312965728067181549806163687854283000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"30976659234185901421097267740435050000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"30976659234185901421097267740435050000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"1279395128864243739951043156956240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1279395128864243739951043156956240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"31195701255325536765134288877888000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"31195701255325536765134288877888000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"476797042816438570970378271436800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"476797042816438570970378271436800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"4726268062903472715158268579840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"4726268062903472715158268579840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"30862064947946711967077990400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"30862064947946711967077990400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"132716541332064541981409280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"132716541332064541981409280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"369531898029478870253568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"369531898029478870253568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"641239194498276261888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"641239194498276261888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"646142958018955837440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"646142958018955837440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"331687050136780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"331687050136780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"65906273157120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"65906273157120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"2147483648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"2147483648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1782151988659863326386101665566204817109375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3505872764576780314202167210949911115625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1072229259825365580087442476569238352500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"121428504198008733570701289542505396000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6758543832913287582784858416094920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"212427870452931036067343014739904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4077869445140593041194024689920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"50042838313095593454616961433600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"402235579821572145970916474880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2133673626030883790316503040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7407434865045462808264704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"16387223859400393359360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"21922707504214573056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"16119990636647546880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5415298777743360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"532575944704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3564303977319726652772203331132409634218750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2259340226060591758041396647056609385625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"399312965728067181549806163687854283000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"30976659234185901421097267740435050000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1279395128864243739951043156956240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"31195701255325536765134288877888000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"476797042816438570970378271436800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4726268062903472715158268579840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"30862064947946711967077990400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"132716541332064541981409280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"369531898029478870253568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"641239194498276261888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"646142958018955837440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"331687050136780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"65906273157120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2147483648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1782151988659863326386101665566204817109375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3505872764576780314202167210949911115625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1072229259825365580087442476569238352500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"121428504198008733570701289542505396000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6758543832913287582784858416094920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"212427870452931036067343014739904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4077869445140593041194024689920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"50042838313095593454616961433600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"402235579821572145970916474880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2133673626030883790316503040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7407434865045462808264704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"16387223859400393359360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"21922707504214573056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"16119990636647546880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5415298777743360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"532575944704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"3564303977319726652772203331132409634218750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2259340226060591758041396647056609385625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"399312965728067181549806163687854283000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"30976659234185901421097267740435050000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1279395128864243739951043156956240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"31195701255325536765134288877888000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"476797042816438570970378271436800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"4726268062903472715158268579840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"30862064947946711967077990400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"132716541332064541981409280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"369531898029478870253568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"641239194498276261888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"646142958018955837440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"331687050136780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"65906273157120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2147483648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"17179869184", " ", 
        SuperscriptBox["T", 
         RowBox[{"65", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"112275575285571389562324404930670903477890625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"112275575285571389562324404930670903477890625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"449102301142285558249297619722683613911562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"299401534094857038832865079815122409274375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"119760613637942815533146031926048963709750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"34217318182269375866613151978871132488500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"7603848484948750192580700439749140553000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"1382517906354318216832854625408934646000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"212695062516048956435823788524451484000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"28359341668806527524776505136593531200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"3336393137506650297032530016069827200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"351199277632278978635003159586297600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"33447550250693236060476491389171200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"2908482630495064005258825338188800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"232678610439605120420706027055104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"17235452625155934845978224226304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"1188651905183167920412291325952000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"76687219689236640026599440384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"4647710284196160001612087296000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"265583444811209142949262131200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"14355861881686980699960115200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"736198045214716958972313600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"35912099766571558974259200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"1670330221701002742988800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"74236898742266788577280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"3159016967756033556480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"128939468071674839040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"5056449728300974080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"190809423709470720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"6938524498526208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"243456999948288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"8252779659264", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"270582939648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "+", 
        RowBox[{"449102301142285558249297619722683613911562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"220986846593823052471876606530209397321562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"220986846593823052471876606530209397321562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"285144318185578132221776266490592770737500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"110255803031756877792420156376362538018500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"30415393939795000770322801758996562212000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6517584415670357307926314662642120474000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1141125890959119798020768897162930184000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"168805605171467425742717292479723400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"21607117461947830495067813437404595200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2436096576592157359738037789511302400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"245282035171750397776827603520588800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"22298366833795490706984327592780800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1846655638409564447783381167104000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"140345828519126898031536968699904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9848830071517677054844699557888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"641494678987741417365363572736000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"38952238572310674299225112576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2213195373426742857910517760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"118037086582759619088560947200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5924641411489865050777190400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"280456398177035031989452800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"12540733251818639641804800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"530263562444762775552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"21210542497790511022080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"802290023557087887360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"28653215127038853120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"963133281581137920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"30287210112614400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"881082476003328", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"23186380947456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"523986010112", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"285144318185578132221776266490592770737500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"67780206781817752741241899411698281568750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"67780206781817752741241899411698281568750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"50609221063757255380127284894068050238000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13462551415974836406536322090047658684000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2777986800121791639444002970962215284000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"467674545475049097549495449656938600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"66415320067462593734839590483825600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8146945928275411498140323099349273600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"878592207951269867446505432282764800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"84441356370602595955957043834956800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"7310939945506718264585025440256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"575187821799700401768594134016000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"41413523169578428927338777649152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2744755921570500162825572007936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"168260899406620699636816674816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"9578419321060001876858634240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"507946479147121311651594240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"25155444681571722100840857600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1165503228489809518185676800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"50574104589301399211212800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2055857910134203219968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"78235607573817458688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2781710491513509642240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"92066068277042872320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2818349028889067520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"78945350949273600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1986046564761600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"43331925049344", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"760209211392", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"50609221063757255380127284894068050238000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"7720050670742632176629585831298516138000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7720050670742632176629585831298516138000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3955099851020855893445699145098747184000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"784742033932709502667797449424354600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"126826995383064162047320799906966400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"17260478661600448089280345549468800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2025229496294452575808893877804339200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"208479506971487765156797899185740800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"19082792400136179877052439284736000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1569580327283928214995655179264000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"116987353586379742732595417088000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7955140043873822505816488361984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"496227059266983080284849176576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"28518796509596728752002826240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1515230175082938150011535360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"74613607106356802841477120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3410907753433453844181811200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"144864808060880279096524800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5714588089186598780928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"209070295945851174912000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7072145317407227904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"220022298763780423680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6241767340816465920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"159228758694297600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3568151455334400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"67323612364800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"979252543488", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"3955099851020855893445699145098747184000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"433673229278602619895361748366090700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"433673229278602619895361748366090700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"165208849248991474245852094615653600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"25587902577284874799020863139124800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3330969566273770683896207035862400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"373068591422662316596375188016588800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"36575352100261011431017175295744000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3180465400022696646175406547456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"247828472729041297104577133568000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"17445482552354873916264228864000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1116510883350711930640910647296000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"65293034114076721090111733760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3502308343283808794105610240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"172789405930510490790789120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"7854063905932295035944960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"329122677962877125315788800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"12707439303585989394432000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"451151691251573587968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"14671599715498328064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"434254537033777152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"11580120987567390720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"273761725474406400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5586973989273600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"93898722508800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1181116006400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"165208849248991474245852094615653600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"13817467391733832391471266095127392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"13817467391733832391471266095127392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4094064412365579967843338102259968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"508729897394539522631420710931712000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"54264522388750882414018209166049280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5054048653854248852286009677230080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"416351834184789379135689584394240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"30640611173772378551111354695680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2030019787910385328438019358720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"121801187274623119706281161523200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"6648018018887811601902285619200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"331127334274105558715439513600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"15079802699390006469014323200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"628325112474583602875596800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"23936194760936518204784640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"831759663507446578544640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"26248825672818826936320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"746917803698096701440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"18949288888746639360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"421095308638814208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7963977468346368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"121897614311424", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1365799600128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"4094064412365579967843338102259968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"270362744212821318631163836941696000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"270362744212821318631163836941696000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"63991182062206229261813925903360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"6484439782303564565197144491540480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"572156451379726285164453925724160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"44515604912839116008218383237120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3083331942014830546023784120320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"191511300746262766833775411200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"10724632841790714942691423027200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"543548643053720445438551654400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"24990742209366457261542604800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1043256790523836925529292800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"39517302671357459300352000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1354878948732255747440640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"41849542817984733511680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1155608677419696783360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"28185577498041384960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"595889587696435200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"10593592670158848", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"150263725817856", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1533303324672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"63991182062206229261813925903360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"3405693162974561221216987653120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3405693162974561221216987653120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"653893087291115754473661629399040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"54491090607592979539471802449920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3990194277901545412501367685120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"259103524539061390422166732800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"15020494176177471908531404800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"781065697161228539243633049600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"36541085247308937508474060800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1540045738392330699590860800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"58445758572763973419008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1992469042253317275648000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"60722866049624907448320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1641158541881754255360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"38843989156964597760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"789511974735052800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"13353268071628800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"178043574288384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1683627180032", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"653893087291115754473661629399040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"28357608377420836290949611479040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"28357608377420836290949611479040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4448252294497386084854841016320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"305372011063893781568982220800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"18507394609932956458726195200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"996257266787281300055654400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"47820348805789502402671411200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2050775192451011798944972800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"78573762162874015285248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2683733812014672248832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"81325267030747643904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2168673787486603837440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"50239547200461864960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"990918090738892800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"16112489280307200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"204386756198400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1816771166208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"4448252294497386084854841016320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"157739443067283194498398617600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"157739443067283194498398617600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"20213750141345214855630028800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1137570354274838931269222400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"56525234995023052485427200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2487110339781014309358796800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"96963366073333891203072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"3343564347356341075968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"101512390052564434944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2691616402908905472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"61522660637917839360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1187696151311155200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"18740767673548800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"228545947238400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1932735283200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"20213750141345214855630028800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"583952781861083984718200832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"583952781861083984718200832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"60670418894658076334358528000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2763455933090015899287552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"110538237323600635971502080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3878534642933355648122880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"118882287906003238256640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3158163246079782420480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"71776437410904145920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1367170236398174208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"21114598245531648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"249876902313984", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2031519531008", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"60670418894658076334358528000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"1410939974294373868240896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1410939974294373868240896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"116848030997463674388480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"4206529115908692277985280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"131197789190134651944960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"3518714652608975339520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"80122534784265093120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1517472249701990400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"23123386662125568", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"267838455545856", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"2113123909632", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"116848030997463674388480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"2137463981660920872960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"2137463981660920872960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"136797694826298935869440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"3733270424109522616320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"85822308600218910720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1628506804558233600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"24674345523609600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"281992520269824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"2177548419072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"136797694826298935869440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"1888725569593870909440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1888725569593870909440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"88361430156438405120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1692747704146329600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"25696359835238400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"292004089036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"2224793059328", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"88361430156438405120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"852909557494579200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"852909557494579200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"26142821685657600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"297641233612800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"2254857830400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"26142821685657600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"149387552489472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"149387552489472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"2267742732288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"2267742732288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"224551150571142779124648809861341806955781250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"224551150571142779124648809861341806955781250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"142572159092789066110888133245296385368750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"142572159092789066110888133245296385368750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"25304610531878627690063642447034025119000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"25304610531878627690063642447034025119000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"1977549925510427946722849572549373592000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1977549925510427946722849572549373592000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"82604424624495737122926047307826800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"82604424624495737122926047307826800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"2047032206182789983921669051129984000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"2047032206182789983921669051129984000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"31995591031103114630906962951680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"31995591031103114630906962951680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"326946543645557877236830814699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"326946543645557877236830814699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"2224126147248693042427420508160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"2224126147248693042427420508160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"10106875070672607427815014400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"10106875070672607427815014400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"30335209447329038167179264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"30335209447329038167179264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"58424015498731837194240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"58424015498731837194240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"68398847413149467934720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"68398847413149467934720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"44180715078219202560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"44180715078219202560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"13071410842828800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"13071410842828800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"1133871366144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1133871366144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"112275575285571389562324404930670903477890625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"220986846593823052471876606530209397321562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"67780206781817752741241899411698281568750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7720050670742632176629585831298516138000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"433673229278602619895361748366090700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"13817467391733832391471266095127392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"270362744212821318631163836941696000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3405693162974561221216987653120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"28357608377420836290949611479040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"157739443067283194498398617600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"583952781861083984718200832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1410939974294373868240896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2137463981660920872960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1888725569593870909440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"852909557494579200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"149387552489472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"224551150571142779124648809861341806955781250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"142572159092789066110888133245296385368750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"25304610531878627690063642447034025119000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1977549925510427946722849572549373592000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"82604424624495737122926047307826800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2047032206182789983921669051129984000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"31995591031103114630906962951680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"326946543645557877236830814699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2224126147248693042427420508160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"10106875070672607427815014400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"30335209447329038167179264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"58424015498731837194240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"68398847413149467934720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"44180715078219202560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"13071410842828800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1133871366144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"112275575285571389562324404930670903477890625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"220986846593823052471876606530209397321562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"67780206781817752741241899411698281568750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7720050670742632176629585831298516138000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"433673229278602619895361748366090700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"13817467391733832391471266095127392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"270362744212821318631163836941696000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3405693162974561221216987653120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"28357608377420836290949611479040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"157739443067283194498398617600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"583952781861083984718200832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1410939974294373868240896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2137463981660920872960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1888725569593870909440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"852909557494579200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"149387552489472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4294967296", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"224551150571142779124648809861341806955781250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"142572159092789066110888133245296385368750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"25304610531878627690063642447034025119000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1977549925510427946722849572549373592000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"82604424624495737122926047307826800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2047032206182789983921669051129984000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"31995591031103114630906962951680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"326946543645557877236830814699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2224126147248693042427420508160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"10106875070672607427815014400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"30335209447329038167179264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"58424015498731837194240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"68398847413149467934720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"44180715078219202560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"13071410842828800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1133871366144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"34359738368", " ", 
        SuperscriptBox["T", 
         RowBox[{"67", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"7297912393562140321551086320493608726062890625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"7297912393562140321551086320493608726062890625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"29191649574248561286204345281974434904251562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"19461099716165707524136230187982956602834375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"7784439886466283009654492075193182641133750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"2224125681847509431329854878626623611752500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"494250151521668762517745528583694135945000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"89863663913030684094135550651580751990000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"13825179063543182168328546254089346460000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"1843357208472424289110472833878579528000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"216865553937932269307114451044538768000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"22827953046098133611275205373109344000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"2174090766295060343930971940296128000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"189051370982179160341823646982272000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"15124109678574332827345891758581760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"1120304420635135764988584574709760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"77262373836905914826798936186880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"4984669279800381601728963624960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"302101168472750400104785674240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"17262923912728594291702038528000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"933131022309653745497407488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"47852872938956602333200384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"2334286484827151333326848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"108571464410565178294272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"4825398418247341257523200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"205336102904142181171200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"8381065424658864537600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"328669232339563315200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"12402612541115596800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"451004092404203520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"15824704996638720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"536430677852160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"17587891077120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"558345748480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]]}], "+", 
        RowBox[{"29191649574248561286204345281974434904251562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"14371273636553137863977523831125875645170000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"14371273636553137863977523831125875645170000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"18562895113881136407637634948537589375011250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7185636818276568931988761915562937822585000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1984604454571623800263562814774525684333000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"425815515157130010784519224625951870968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"74655966943133183708974149772082470884000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"11060143250834545734662837003271477168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1417967083440326376238825256829676560000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"160146870600319214257561440771351705600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"16155166771084833017210145340969689600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1471692211030502386660965621123532800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"122156270480792688220870664203929600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9307144417584204816828241082204160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"654947199755925524147172520599552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"42791468586594045134842487734272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2607365469434045760904380973056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"148726729094277120051586793472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7967503344336274288477863936000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"401964132687235459598883225600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"19141149175582640933280153600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"861890394397717415382220800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"36747264877422060345753600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1484737974845335771545600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"56862305419608604016640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2063031489146797424640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"70790296196213637120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2289713084513648640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"69385244985262080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1947655999586304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"49516677955584", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1082331758592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"18562895113881136407637634948537589375011250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"4419736931876461049437532130604187946431250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4419736931876461049437532130604187946431250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3307674090952706333772604691290876140555000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"882046424254055022339361251010900304148000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"182492363638770004621936810553979373272000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"30810399055896234546560760223399114968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4388945734458153069310649604472808400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"540177936548695762376695335935114880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"58466317838211776633712906948271257600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5641486808950259148867034880973542400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"490564070343500795553655207041177600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"38779768406600853403451004509184000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2806916570382537960630739373998080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"187127771358835864042049291599872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"11546904221779345512576544309248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"662188055729281463086826913792000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"35411125974827885726568284160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1770556298741394286328414208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"82944979760858110710880665600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3645933176301455415862886400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"150488799021823675701657600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5832899186892390531072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"212105424977905110220800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"7220610212013790986240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"229225721016310824960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6741932971067965440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"181723260675686400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4405412380016640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"92745523789824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1571958030336", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"3307674090952706333772604691290876140555000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"506092210637572553801272848940680502380000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"506092210637572553801272848940680502380000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"260275994042180170526368893740921401224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"51855753602273443936288055457961351968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8418141818550883755890918093824894800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1151198881169351624737219568386310400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"135782432137923524969005384989154560000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"14057475327220317879144086916524236800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1294767464349239804658008005469337600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"107227119200765201213913706457088000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8052629505195805624760317876224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"552180308927712385697850368655360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"34766908339893002062457245433856000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2019130792879448395641800097792000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"108555418972013354604397854720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5418095777569293990950338560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"251554446815717221008408576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"10878030132571555503066316800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"438308906440612126497177600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"16446863281073625759744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"573727788874661363712000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"18544736610090064281600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"552396409662257233920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"15031194820741693440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"368411637763276800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7944186259046400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"144439750164480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2027224563712", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"260275994042180170526368893740921401224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"28674473919901205227481318801965917084000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"28674473919901205227481318801965917084000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"10986388475057933037349164291940964400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1712164437671366187638830798744046400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"224386222600805825160644492143094400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"25315368703680657197611173472554240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2501754083657853181881574790228889600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"219452112601566068586103051774464000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"17265383600123210364952206971904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1228367212656987298692251879424000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"79551400438738225058164883619840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4714157063036339262706067177472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"256669168586370558768025436160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"12879456488204974275098050560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"596908856850854422731816960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"25581808150750903831363584000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1014053656426161953675673600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"37144822579712892076032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1254421775675107049472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"38896799245739753472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1100111493818902118400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"28087953033674096640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"636915034777190400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"12488530093670400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"201970837094400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2448131358720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"10986388475057933037349164291940964400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"925169555794352255776771729847660160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"925169555794352255776771729847660160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"276349347834676647829425321902547840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"34642083489247215112520553172968960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3730685914226623165963751880165888000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"351123380162505709737764882839142400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"29260281680208809144813740236595200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2180890560015563414520278775398400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"146542053439780940896619522457600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8932087066805695445127285178368000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"496227059266983080284849176576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"25216620071643423317560393728000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1174967960327471337377366016000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"50266008997966688230047744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1974736067777262751894732800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"71161660100081540608819200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2345988794508182657433600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"70423678634391974707200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1910719962948619468800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"46320483950269562880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"985542211707863040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"17878316765675520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"262916423024640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2834678415360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"276349347834676647829425321902547840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"18423289855645109855295021460169856000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"18423289855645109855295021460169856000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4408992444086009196138979494741504000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"452204353239590686783485076383744000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"40432389230833990818288077417840640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3192030728750051906706953480355840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"224697815274330776041483267768320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"14210138515372697299066135511040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"812007915164154131375207743488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"42104114119622806812047808921600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1986764005644633352292637081600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"85452215296543369991081164800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3351067266531112548669849600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"119680973804682591023923200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3881545096368084033208320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"113744911248881583390720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2987671214792386805760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"69480725925404344320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1403651028796047360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"23891932405039104", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"325060304830464", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3186865733632", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"4408992444086009196138979494741504000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"237681533373908851543880296212480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"237681533373908851543880296212480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"46317427016454032608551032082432000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3923358523746694526841969776394240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"292531117998657048054006518415360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"19380943635521792003578071613440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1149067804477576601002652467200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"61283616238804085386808131584000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2950692633720196703809280409600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"128523817076741780202219110400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"5067247268258636495427993600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"180650526497634099658752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"5806624065995381774745600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"167398171271938934046720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4292260801844588052480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"96636265707570462720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1872795847045939200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"30267407629025280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"386392437817344", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3504693313536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"46317427016454032608551032082432000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"2043415897784736732730192591872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2043415897784736732730192591872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"326946543645557877236830814699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"22943617097933886121882864189440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1425069384964837647321917030400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"78857594424931727519789875200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"3905328485806142696218165248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"173570154924717453165251788800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6930205822765488148158873600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"248394473934246887030784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"7969876169013269102592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"227710747686093402931200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"5744054896586139893760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"126242964760134942720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2368535924205158400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"36721487196979200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"445108935720960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"3788161155072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"326946543645557877236830814699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"11862006118659696226279576043520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"11862006118659696226279576043520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1560790278771012661352575795200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"90480595870783342687105843200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"4649200578340646066926387200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"212534883581286677345206272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"8658828590348716484434329600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"314295048651496061140992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"10138549956499872940032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"289156504998213844992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"7228912624955346124800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"156300813512548024320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2862652262134579200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"42966638080819200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"499612070707200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"4037269258240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"1560790278771012661352575795200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"46491625325093994167949066240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"46491625325093994167949066240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"5005309558809291297584578560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"237405986979096820438794240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"9948441359124057237435187200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"368460791078668786571673600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"12036831650482827873484800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"345142126178719078809600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"8613172489308497510400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"184567981913753518080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3325549223671234560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"48725995951226880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"548510273372160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"4252017623040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"5005309558809291297584578560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"121340837789316152668717056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"121340837789316152668717056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"10551377199070969797279744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"401957226631275039896371200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"13398574221042501329879040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"389069305874192416112640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"9761595487882963845120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"208804181558993879040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"3728646099267747840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"53746250079535104", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"590618132742144", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"4432406249472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"10551377199070969797279744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"204484054245561430179840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"204484054245561430179840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"14021763719695640926617600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"415459665768759731159040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"10556143957826926018560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"227013848555417763840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"4046592665871974400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"57808466655313920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"624956396273664", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"4578435137536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"14021763719695640926617600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"210457992040459901337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"210457992040459901337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"10912636624320143032320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"237661777662144675840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"4259171642690764800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"60736850519654400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"650751969853440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"4690104287232", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"10912636624320143032320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"119919083783737835520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"119919083783737835520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"4352779810661990400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"62405445314150400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"667437917798400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"4767413698560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"4352779810661990400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"31371386022789120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"31371386022789120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"674653462855680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"4810363371520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"674653462855680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"2409476653056", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"2409476653056", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "+", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"14595824787124280643102172640987217452125781250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"14595824787124280643102172640987217452125781250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"9281447556940568203818817474268794687505625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"9281447556940568203818817474268794687505625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"1653837045476353166886302345645438070277500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1653837045476353166886302345645438070277500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"130137997021090085263184446870460700612000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"130137997021090085263184446870460700612000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"5493194237528966518674582145970482200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"5493194237528966518674582145970482200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"138174673917338323914712660951273920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"138174673917338323914712660951273920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"2204496222043004598069489747370752000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"2204496222043004598069489747370752000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"23158713508227016304275516041216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"23158713508227016304275516041216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"163473271822778938618415407349760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"163473271822778938618415407349760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"780395139385506330676287897600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"780395139385506330676287897600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"2502654779404645648792289280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"2502654779404645648792289280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"5275688599535484898639872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"5275688599535484898639872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"7010881859847820463308800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"7010881859847820463308800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"5456318312160071516160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"5456318312160071516160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"2176389905330995200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"2176389905330995200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"337326731427840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"337326731427840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"7297912393562140321551086320493608726062890625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"14371273636553137863977523831125875645170000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4419736931876461049437532130604187946431250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"506092210637572553801272848940680502380000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"28674473919901205227481318801965917084000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"925169555794352255776771729847660160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"18423289855645109855295021460169856000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"237681533373908851543880296212480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2043415897784736732730192591872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"11862006118659696226279576043520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"46491625325093994167949066240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"121340837789316152668717056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"204484054245561430179840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"210457992040459901337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"119919083783737835520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"31371386022789120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2409476653056", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"14595824787124280643102172640987217452125781250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"9281447556940568203818817474268794687505625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1653837045476353166886302345645438070277500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"130137997021090085263184446870460700612000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5493194237528966518674582145970482200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"138174673917338323914712660951273920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2204496222043004598069489747370752000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"23158713508227016304275516041216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"163473271822778938618415407349760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"780395139385506330676287897600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2502654779404645648792289280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5275688599535484898639872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7010881859847820463308800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5456318312160071516160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2176389905330995200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"337326731427840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7297912393562140321551086320493608726062890625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"14371273636553137863977523831125875645170000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4419736931876461049437532130604187946431250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"506092210637572553801272848940680502380000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"28674473919901205227481318801965917084000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"925169555794352255776771729847660160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"18423289855645109855295021460169856000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"237681533373908851543880296212480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2043415897784736732730192591872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"11862006118659696226279576043520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"46491625325093994167949066240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"121340837789316152668717056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"204484054245561430179840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"210457992040459901337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"119919083783737835520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"31371386022789120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2409476653056", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"14595824787124280643102172640987217452125781250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"9281447556940568203818817474268794687505625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1653837045476353166886302345645438070277500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"130137997021090085263184446870460700612000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"5493194237528966518674582145970482200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"138174673917338323914712660951273920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2204496222043004598069489747370752000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"23158713508227016304275516041216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"163473271822778938618415407349760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"780395139385506330676287897600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2502654779404645648792289280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"5275688599535484898639872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"7010881859847820463308800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"5456318312160071516160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2176389905330995200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"337326731427840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"8589934592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"68719476736", " ", 
        SuperscriptBox["T", 
         RowBox[{"69", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"488960130368663401543922783473071784646213671875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"488960130368663401543922783473071784646213671875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"1955840521474653606175691133892287138584854687500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"1303893680983102404117127422594858092389903125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"521557472393240961646850969037943236955961250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"149016420683783131899100276867983781987417500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"33114760151951807088688950415107507108315000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"6020865482173055834307081893655910383330000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"926286997257393205278012599023986212820000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"123504932967652427370401679869864828376000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"14529992113841462043576668219984097456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"1529472854088574951955438759998326048000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"145664081341769043043375119999840576000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"12666441855806003742902184347812224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"1013315348464480299432174747824977920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"75060396182554096254235166505553920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"5176579047072696293395528724520960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"333972841746625567315840562872320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"20240778287674276807020640174080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"1156615902152815817544036581376000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"62519778494746800948326301696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"3206142486910092356324425728000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"156397194483419139332898816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"7274288115507866945716224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"323301694022571864254054400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"13757518894577526138470400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"561531383452143924019200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"22020838566750742118400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"830975040254744985600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"30217274191081635840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"1060255234774794240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"35940855416094720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"1178388702167040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"37409165148160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "-", 
        RowBox[{"1151051235328", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]]}], "+", 
        RowBox[{"1955840521474653606175691133892287138584854687500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"963324435950202522444743394305156351840301562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"963324435950202522444743394305156351840301562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"1245510381834605281544718732030909222581400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"482635272960909546598578508661977323750292500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"133447540910850565879791292717597416705150000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"28666508788256788226029240657854259884810000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5032365179129718309271590836488522111440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"746559669431331837089741497720824708840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"95854574840566063033744587361686135456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"10843277696896613465355722552226938400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1095741746212710413341209857909248512000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"100008175249572775820824709253621888000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"8318260323215883055040240467219968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"635212606500121978748527453860433920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"44812176825405430599543382988390400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2935970205802424763418359575101440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"179448094072813737662242690498560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"10271439728073513603562712924160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"552413565207315017334465232896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"27993930669289612364922224640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1339880442290784865329610752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"60691448605505934666498048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2605715145853564279062528000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"106158765201441507665510400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4106722058082843623424000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"150859177643859561676800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5258707717433013043200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"173636575575618355200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5412049108850442240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"158247049966387200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4291445422817280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"105527346462720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2233382993920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"1245510381834605281544718732030909222581400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"297006321822098182522202159176601430000180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"297006321822098182522202159176601430000180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"222754741366573636891651619382451072500135000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"59538133637148714007906884443235770529990000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"12348649939556770312751057514152604258072000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2090367074407729143851276193618309184752000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"298623867772532734835896599088329883536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"36867144169448485782209456677571590560000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4003671765007980356439036019283792640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"387724002506035992413043488183272550400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"33848920853701554893202209285841254400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2687437950577439140859154612486451200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"195450032769268301153393062726287360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13098943995118510482943450411991040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"813037903145286857562007266951168000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"46932578449812823696278857515008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2528354394602711040876975489024000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"127480053509380388615645822976000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6029461990308531893983248384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"267976088458156973065922150400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"11204575127170326399968870400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"440967178529064724149043200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"16332117723298693487001600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"568623054196086040166400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"18567283402321176821760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"566322369569709096960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"16027991591595540480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"416311469911572480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"9738279997931520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"198066711822336", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3246995275776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"222754741366573636891651619382451072500135000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"34179298939844632115650248476672386785735000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"34179298939844632115650248476672386785735000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"17640928485081100446787225020218006082960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3528185697016220089357445004043601216592000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"575127449043396378202467524170116812736000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"79001023220246755247591692880510551200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"9363084233510726547862719156208657920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"974438630636862943895215115804520960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"90263788943204146381872558095576678400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7521982411933678865156046507964723200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"568769936630145849917281399468032000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"39296831985355531448830351235973120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2495036951451144853893990554664960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"146260786809205043159302894583808000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7946256668751377557041922965504000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"401326094381382704901107220480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"18885933853241539054169751552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"829449797608581107108806656000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"34028709645480250548053606400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1304236258189138522747699200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"46663193495139124248576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1555439783171304141619200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"48137401413425273241600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1375354326097864949760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"35956975845695815680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"848041883153203200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"17621649520066560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"309151745966080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4191888080896", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"17640928485081100446787225020218006082960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"1952069955316351278947766703056910509180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1952069955316351278947766703056910509180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"751908427232964937076176804140439603536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"117853985459712372582472853313548527200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"15541184895786246933952464173215190400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1765171617793005824597070004859009280000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"175718441590253973489301086456552960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"15537209572190877655896096065632051200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1233111870808799813960007624256512000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"88578924557153861872363496638464000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5797893243740980049827428870881280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"347669083398930020624572454338560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"19181742532354759758597100929024000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"976998770748120191439580692480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"46053814109338998923077877760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2012435574525737768067268608000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"81585225994286666272997376000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3068162345084284885480243200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"106904611326978567438336000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3442366733247968182272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"101996051355495353548800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2761982048311286169600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"67640376693337620480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1473646551053107200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"27804651906662400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"433319250493440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5068061409280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"751908427232964937076176804140439603536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"63721053155336011616625152893257593520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"63721053155336011616625152893257593520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"19176241701919301301554904945933319680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2423371204088702911734960515145419520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"263279834518278834855156204114564096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"25017540836578531818815747902288896000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2106740280975034258426589297034854400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"158841529121133535357560304141516800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"10809631471381488228491816538931200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"668231763685401090488585022406656000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"37713256504290714101648537419776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1950685681256416246636993314816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"92732086715075814780705964032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4058980226585810074576355328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"163723572164805784520726937600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"6084321938556971722054041600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"208011006446392195625779200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"6522993233510556657254400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"186704636379550816665600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4840490572803169320960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"112351812134696386560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2292894125197885440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"39963296299745280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"565518343864320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5875515260928", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"19176241701919301301554904945933319680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"1289630289895157689870651502211889920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1289630289895157689870651502211889920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"311778751403224936012684978556720640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"32332611256630734105019182961437696000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2926028168020880914481374023659520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"234082253441670473158509921892761600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"16720160960119319511322137278054400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1074641725225060233241876498022400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"62524609467639868115890996248576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3308180395113220535232327843840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"159705260453741681011215826944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7049807761964828024264196096000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"284840717655144566636937216000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"10531925694812068010105241600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"355808300500407703044096000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"10947947707704852401356800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"305169274082365223731200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7642879851794477875200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"169841774484321730560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3285140705692876800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"53634950297026560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"701110461399040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"6614249635840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"311778751403224936012684978556720640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"17006113712903178327964635194002944000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"17006113712903178327964635194002944000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3359232338351245101820174853136384000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"288802780220242791559200552984576000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"21888210711428927360276252436725760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1476585643231316528272604331048960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"89320870668056954451272851783680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4872047490984924788251246460928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"240594937826416038925987479552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"10785290316356581055302887014400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"439468535810794474239845990400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"16276612437436832379253555200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"547113023107120416109363200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"16635193270148931570892800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"454979644995526333562880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"11097064512086008135680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"238219631744243466240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4411474661930434560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"68262664014397440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"835869355278336", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"7284264534016", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"3359232338351245101820174853136384000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"150531637803475605977790854267904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"150531637803475605977790854267904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"24520990773416840792762311102464000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1755186707991942288324039110492160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"111440425904250304020573911777280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6319872924626671305514588569600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"321738985253721448280742690816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"14753463168600983519046402048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"610488131114523455960540774400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"22802612707163864229425971200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"767764737614944923549696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"23226496263981527098982400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"627743142269771002675200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"15022912806456058183680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"314067863549604003840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"5618387541137817600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"83235370979819520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"965981094543360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"7885559955456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"24520990773416840792762311102464000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"908184843459882992324530040832000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"908184843459882992324530040832000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"122365957855647392650041942343680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"7283687967598059086312020377600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"385526017188555112318972723200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"18224866267095332582351437824000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"771422910776522014067785728000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"29260869029454283292226355200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"993577895736987548123136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"30108421082939016609792000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"809638213994998765977600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"19146849655287132979200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"392755890364864266240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"6842437114370457600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"97923965858611200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1088044065095680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"8418135900160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"122365957855647392650041942343680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"3745896669050430387246181908480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3745896669050430387246181908480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"416210741005603376360686878720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"20456482544698842694476103680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"892646511041404044849866342400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"34635314361394865937737318400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1194321184875685032335769600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"36498779843399542584115200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"983132116993927072972800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"23132520399857107599360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"468902440537644072960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"8015426333976821760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"111713259010129920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1199068969697280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"8881992368128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"416210741005603376360686878720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"10465647259328518167676846080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"10465647259328518167676846080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"949623947916387281755176960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"37984957916655491270207078400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1339857422104250132987904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"41581782065304314472038400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1129556049312171530649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"26622533148771719577600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"536925038294555688960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"9069679700921548800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"124029807875850240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1296478827970560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"9277129359360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"949623947916387281755176960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"19344191531630111295012864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"19344191531630111295012864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1406850293209462639637299200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"44661914070141671099596800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1232052801934942651023360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"29284786463648891535360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"591611847750482657280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"9943056264713994240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"134365625198837760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1378108976398336", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"9603546873856", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"1406850293209462639637299200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"22650541393354496881459200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"22650541393354496881459200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1278337433134645326643200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"30856420799801783746560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"628653734461156884480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"10583396203049779200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"142297764074618880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1442207068323840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"9861244911616", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"1278337433134645326643200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"15589480891885918617600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"15589480891885918617600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"645081967940106977280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"10952155652633395200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"147503779833446400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1487433073950720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"10050223472640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"645081967940106977280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"5513521093505187840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"5513521093505187840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"149773068753960960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"1512859280343040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"10170482556928", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"149773068753960960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"758985145712640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"758985145712640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"10222022164480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "+", 
        RowBox[{"10222022164480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"977920260737326803087845566946143569292427343750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"977920260737326803087845566946143569292427343750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"622755190917302640772359366015454611290700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"622755190917302640772359366015454611290700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"111377370683286818445825809691225536250067500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"111377370683286818445825809691225536250067500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"8820464242540550223393612510109003041480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"8820464242540550223393612510109003041480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"375954213616482468538088402070219801768000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"375954213616482468538088402070219801768000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"9588120850959650650777452472966659840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"9588120850959650650777452472966659840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"155889375701612468006342489278360320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"155889375701612468006342489278360320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"1679616169175622550910087426568192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1679616169175622550910087426568192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"12260495386708420396381155551232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"12260495386708420396381155551232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"61182978927823696325020971171840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"61182978927823696325020971171840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"208105370502801688180343439360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"208105370502801688180343439360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"474811973958193640877588480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"474811973958193640877588480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"703425146604731319818649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"703425146604731319818649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"639168716567322663321600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"639168716567322663321600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"322540983970053488640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"322540983970053488640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"74886534376980480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"74886534376980480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"5111011082240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"5111011082240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"488960130368663401543922783473071784646213671875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"963324435950202522444743394305156351840301562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"297006321822098182522202159176601430000180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"34179298939844632115650248476672386785735000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1952069955316351278947766703056910509180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"63721053155336011616625152893257593520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1289630289895157689870651502211889920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"17006113712903178327964635194002944000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"150531637803475605977790854267904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"908184843459882992324530040832000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3745896669050430387246181908480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"10465647259328518167676846080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"19344191531630111295012864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"22650541393354496881459200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"15589480891885918617600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5513521093505187840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"758985145712640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"977920260737326803087845566946143569292427343750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"622755190917302640772359366015454611290700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"111377370683286818445825809691225536250067500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"8820464242540550223393612510109003041480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"375954213616482468538088402070219801768000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"9588120850959650650777452472966659840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"155889375701612468006342489278360320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1679616169175622550910087426568192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"12260495386708420396381155551232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"61182978927823696325020971171840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"208105370502801688180343439360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"474811973958193640877588480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"703425146604731319818649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"639168716567322663321600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"322540983970053488640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"74886534376980480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5111011082240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"488960130368663401543922783473071784646213671875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"963324435950202522444743394305156351840301562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"297006321822098182522202159176601430000180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"34179298939844632115650248476672386785735000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1952069955316351278947766703056910509180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"63721053155336011616625152893257593520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1289630289895157689870651502211889920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"17006113712903178327964635194002944000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"150531637803475605977790854267904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"908184843459882992324530040832000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3745896669050430387246181908480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"10465647259328518167676846080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"19344191531630111295012864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"22650541393354496881459200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"15589480891885918617600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5513521093505187840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"758985145712640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"17179869184", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"977920260737326803087845566946143569292427343750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"622755190917302640772359366015454611290700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"111377370683286818445825809691225536250067500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"8820464242540550223393612510109003041480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"375954213616482468538088402070219801768000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"9588120850959650650777452472966659840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"155889375701612468006342489278360320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1679616169175622550910087426568192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"12260495386708420396381155551232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"61182978927823696325020971171840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"208105370502801688180343439360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"474811973958193640877588480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"703425146604731319818649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"639168716567322663321600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"322540983970053488640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"74886534376980480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"5111011082240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"137438953472", " ", 
        SuperscriptBox["T", 
         RowBox[{"71", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"33738248995437774706530672059641953140588743359375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"33738248995437774706530672059641953140588743359375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"134952995981751098826122688238567812562354973437500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"89968663987834065884081792159045208374903315625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"35987465595133626353632716863618083349961326250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"10282133027181036101037919103890880957131807500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"2284918450484674689119537578642417990473735000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"415439718269940852567188650662257816449770000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"63913802810760131164182869332655048684580000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"8521840374768017488557715911020673157944000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"1002569455855060881006790107178902724464000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"105533626932111671684925274439884497312000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"10050821612582063969992883279988999744000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"873984488050614258260250719999043456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"69918759044049140660820057599923476480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"5179167336596232641542226488883220480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"357183954248016044244291481991946240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"23044126080517164144792998838190080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"1396613701849525099684424172011520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"79806497248544291410538524114944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"4313864716137529265434514817024000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"221223831596796372586385375232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"10791406419355920613970018304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"501925879970042819254419456000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"22307816887557458633529753600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"949268803725849303554457600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"38745665458197930757324800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"1519437861105801206169600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"57337277777577404006400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"2084991919184632872960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"73157611199460802560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"2479919023710535680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"81308820449525760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"2581232395223040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "-", 
        RowBox[{"79422535237632", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]]}], "-", 
        RowBox[{"2370821947392", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]]}], "+", 
        RowBox[{"134952995981751098826122688238567812562354973437500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"66498577730138222609973498552337762711885059375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"66498577730138222609973498552337762711885059375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"86056982944884758671730409891260634097733606250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"33379678233167421545398462018428367165181520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9239018082394554177744217165814994483219885000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1986885609117108425321337024906450426498900000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"349210197966037238389810749832042802233140000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"51872071846414019495568705545343227917920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6669266380253231078001690712972700732304000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"755559589919756026265986747439173067712000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"76473642704428747597771937999916302400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6991875904404914066082005759992347648000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"582656325367076172173500479999362304000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"44585875332437133175015688904299028480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3152536639667272042677876993233264640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"207063161882907851735821148980838400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"12690967986371771558001941389148160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"728668018356273965052743046266880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"39324940673195737796497243766784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2000632911831897630346441654272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"96184274607302770689732771840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4379121445535735901321166848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"189131491003204540588621824000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7759240656541724742097305600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"302665415680705575046348800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"11230627669042878480384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"396375094201513358131200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"13295600644075919769600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"423041838675142901760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"12723062817297530880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"359408554160947200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9427109617336320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"224454990888960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4604204941312", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"86056982944884758671730409891260634097733606250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"20550921300270987145487859078510002172593100000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"20550921300270987145487859078510002172593100000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"15444328734749105491154512277183274360009360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4136873768236367542273530074245519917859650000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"859995263647703646780877219735627796544300000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"145938590194761830968876134258167141231760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"20903670744077291438512761936183091847520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2588073520695283701911103858765525657312000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"281925220119311950099248786357900398400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"27393543655317760333530246447731212800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2400196205989746619699793022086925312000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"191319987433965310265925530746059264000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13974677343002683532467603984929546240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"941055713333514042590411042756198400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"58719404116048495268367191502028800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3409513787383461015582611119472640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"184885915105323244864128832634880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"9391030608524355294685908959232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"447902890708633797838755594240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"20098206634361772979944161280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"849680280477083085330972672000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"33874296896096335627812864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1273905182417298091986124800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"45173942638911279857664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1508591776438595616768000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"47328369456897117388800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1389092604604946841600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"37884343761953095680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"949482299798323200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"21457227114086400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"422109385850880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6700148981760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"15444328734749105491154512277183274360009360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"2376050574576785460177617273412811440001440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2376050574576785460177617273412811440001440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1230454761834406756163408945160205924286460000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"246972998791135406255021150283052085161440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"40413763438549430114458006409953977571872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5574312198420611050270069849648824492672000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"663608595050072744079770220196288630080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"69396977260138326178276624334252405760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6462066708433933206884058136387875840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"541582733659224878291235348573460070400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"41207381908854066826507037391458918400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2866600480615935083583098253318881280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"183385215931659146761208305767874560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"10840505375270491434160096892682240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"594479327030962433486198861856768000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"30340252735232532490523705868288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1444773939772977737643985993728000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"64314261229957673535821316096000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2679760884581569730659221504000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"104576034520256379733042790400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3821715547251894275958374400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"130656941786389547896012800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4169902397437964294553600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"123781889348807845478400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3397934217418254581760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"85482621821842882560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1942786859587338240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"38953119991726080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"660222372741120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8658654068736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"1230454761834406756163408945160205924286460000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"136717195759378528462600993906689547142940000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"136717195759378528462600993906689547142940000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"52922785455243301340361675060654018248880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"8339348011129247483935779100466693784672000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1106014325083454573466283700327147716800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"126401637152394808396146708608816881920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"12667702198279218270637796505458772480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1128297361790051829773406976194708480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"90263788943204146381872558095576678400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6540854271246677274048736093882368000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"432265151838910845937133863595704320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"26197887990237020965886900823982080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1462607868092050431593028945838080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"75489438353138086791898268172288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3611934849432444344109964984320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"160530437752553081960442888192000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6635598380868648856870453248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"255215322341101879110402048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9129653807323969659233894400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"303310757718404307615744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9332638699027824849715200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"264755707773839002828800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6876771630489324748800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"161806391305631170560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3392167532612812800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"61675773320232960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"927455237898240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"10479720202240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"52922785455243301340361675060654018248880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"4511450563397789622457060824842637621216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4511450563397789622457060824842637621216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1367106231332663521956685098437162915520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"174061270832805965660267598740010132480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"19063853472164462905648356052477300224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1827471792538641324288731299148150784000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"155372095721908776558960960656320512000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"11837873959764478214016073192862515200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"814926105925815529225744169073868800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"51021460544920624438481374063755264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2920420300551012173246408616443904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"153453940258838078068776807432192000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7425190657685713454940813262848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"331587461587240792246160719872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"13684561906775016822857426534400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"522145446363434664147183206400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"18408974070505709312881459200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"598665823431079977654681600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"17900307012889434547814400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"489581046506377697034240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"12152721012569659146240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"270561506773350481920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5305127583791185920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"88974886101319680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1213293901381632", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"12163347382272", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"1367106231332663521956685098437162915520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"92685168225943289624182040572011045120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"92685168225943289624182040572011045120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"22618131238161227176192964808023915520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2369518510664509513696405837031076864000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"216818687250347275763069815153170432000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"17556169008125285486888244141957120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1270732232969068282860482433132134400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"82873841280591409751770593465139200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4900366267026274663582956830982144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"263992795530034998711539761938432000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"13004571208376108310913288765440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"587303215862146826944471105536000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"24353881359514860447458131968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"927766908933899445617452646400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"32449717005637182517621555200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1040055032231960978128896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"30440635089715931067187200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"809053424311386872217600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"19361962291212677283840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"411956644493886750720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7642980417326284800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"119889888899235840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1508048916971520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"13709535608832", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"22618131238161227176192964808023915520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"1247115005612899744050739914226882560000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1247115005612899744050739914226882560000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"249423001122579948810147982845376512000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"21736209248155115364718778461470720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1672016096011931951132213727805440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"114652532297961048077637512763801600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"7061931337193252961303759844147200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"393011830939450599585600547848192000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"19849082370679323211393967063040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"912601488307095320064090439680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"38270384993523352131719921664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1464895119369314914132819968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"51155067660515758906225459200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1626552230859006642487296000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"46919775890163653148672000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1220677096329460894924800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"28387839449522346393600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"582314655374817361920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"10324727932177612800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"153242715134361600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1802855472168960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"15118284881920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"249423001122579948810147982845376512000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"11337409141935452218643090129335296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"11337409141935452218643090129335296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1877218071431578145134803594399744000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"136801316946430796001726577729536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"8859513859387899169635625986293760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"513595006341327488094818897756160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"26796261200417086335381855535104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1263123423588684204361434267648000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"53926451581782905276514435072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2087475545101273752639268454400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"73244755968465745706640998400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2325230348205261768464793600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"66540773080595726283571200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1706173668733223750860800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"38839725792301028474880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"774213803168791265280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"13234423985791303680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"187722326039592960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2089673388195840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"16389595201536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"1877218071431578145134803594399744000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"70838417789870873401313343184896000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"70838417789870873401313343184896000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"9751037266621901601800217280512000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"594348938156001621443060862812160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"32301572725869653339296786022400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1572946150129304858261408710656000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"68849494786804589755549876224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2713280582731215359824625664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"96277698096914093413131878400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"3071058950459779694198784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"87744541441707991262822400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2231975616959185787289600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"50076376021520193945600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"977100019932101345280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"16230897341064806400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"221960989279518720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2361287119994880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"17523466567680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"9751037266621901601800217280512000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"305914894639118481625104855859200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"305914894639118481625104855859200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"34961702244470683614297697812480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1773419679067353516667274526720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"80189411575219463362346326425600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3239976225261392459084700057600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"117043476117817133168905420800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3775596003800552682867916800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"108390315898580459795251200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2752769927582995804323840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"61269918896918825533440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1178267671094592798720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"19158823920237281280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"254602311232389120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2611305756229632", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"18519898980352", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"34961702244470683614297697812480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"908096162194043730241498644480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"908096162194043730241498644480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"85545290641467887631445524480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"3570586044165616179399465369600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"132243927561689488125906124800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"4342986126820672844857344000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"126086694004471147108761600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"3217523291980124966092800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"71500517599558332579840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1364079827018600939520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"21860253638118604800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"284361022934876160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"2834163019284480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"19378892439552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"85545290641467887631445524480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"1820112566839742290030755840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1820112566839742290030755840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"139278179027736801324092620800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"4689500977364875465457664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"138605940217681048240128000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"3576927489488543180390400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"79867599446315158732800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1521287608501241118720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"24185812535790796800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"310074519689625600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"3025117265264640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"20100446945280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"139278179027736801324092620800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"2380823573123706005540044800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"2380823573123706005540044800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"144292337765073091244851200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"3790931698261362003148800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"85601683509127529103360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1638309732232105820160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"26004916384636600320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"330746154335600640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"3180251483996160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"20684562497536", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"144292337765073091244851200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"1917506149701967989964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1917506149701967989964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"88161202285147953561600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1706345850680282972160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"27214447379270860800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"345580284181217280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"3296473299025920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"21131239096320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"88161202285147953561600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"860109290586809303040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"860109290586809303040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"27745460986671267840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"354009071600271360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"3371514967621632", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"21440476741632", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"27745460986671267840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"177855519145328640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"177855519145328640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"3403933380771840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"21612275433472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "+", 
        RowBox[{"3403933380771840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"10823317585920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"10823317585920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", 
           SqrtBox[
            RowBox[{"T", " ", "U"}]]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "+", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"67476497990875549413061344119283906281177486718750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"67476497990875549413061344119283906281177486718750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"43028491472442379335865204945630317048866803125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"43028491472442379335865204945630317048866803125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"7722164367374552745577256138591637180004680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"7722164367374552745577256138591637180004680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"615227380917203378081704472580102962143230000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"615227380917203378081704472580102962143230000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"26461392727621650670180837530327009124440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"26461392727621650670180837530327009124440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"683553115666331760978342549218581457760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"683553115666331760978342549218581457760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"11309065619080613588096482404011957760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"11309065619080613588096482404011957760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"124711500561289974405073991422688256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"124711500561289974405073991422688256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"938609035715789072567401797199872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"938609035715789072567401797199872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"4875518633310950800900108640256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"4875518633310950800900108640256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"17480851122235341807148848906240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"17480851122235341807148848906240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"42772645320733943815722762240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"42772645320733943815722762240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"69639089513868400662046310400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"69639089513868400662046310400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"72146168882536545622425600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"72146168882536545622425600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"44080601142573976780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"44080601142573976780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"13872730493335633920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"13872730493335633920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"1701966690385920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"1701966690385920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}], "+", 
        RowBox[{"33738248995437774706530672059641953140588743359375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"66498577730138222609973498552337762711885059375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"20550921300270987145487859078510002172593100000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2376050574576785460177617273412811440001440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"136717195759378528462600993906689547142940000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4511450563397789622457060824842637621216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"92685168225943289624182040572011045120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1247115005612899744050739914226882560000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"11337409141935452218643090129335296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"70838417789870873401313343184896000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"305914894639118481625104855859200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"908096162194043730241498644480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1820112566839742290030755840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2380823573123706005540044800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1917506149701967989964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"860109290586809303040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"177855519145328640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"10823317585920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"67476497990875549413061344119283906281177486718750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"43028491472442379335865204945630317048866803125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7722164367374552745577256138591637180004680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"615227380917203378081704472580102962143230000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"26461392727621650670180837530327009124440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"683553115666331760978342549218581457760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"11309065619080613588096482404011957760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"124711500561289974405073991422688256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"938609035715789072567401797199872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4875518633310950800900108640256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"17480851122235341807148848906240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"42772645320733943815722762240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"69639089513868400662046310400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"72146168882536545622425600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"44080601142573976780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"13872730493335633920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1701966690385920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"33738248995437774706530672059641953140588743359375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"66498577730138222609973498552337762711885059375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"20550921300270987145487859078510002172593100000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2376050574576785460177617273412811440001440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"136717195759378528462600993906689547142940000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4511450563397789622457060824842637621216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"92685168225943289624182040572011045120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1247115005612899744050739914226882560000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"11337409141935452218643090129335296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"70838417789870873401313343184896000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"305914894639118481625104855859200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"908096162194043730241498644480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1820112566839742290030755840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2380823573123706005540044800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1917506149701967989964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"860109290586809303040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"177855519145328640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"10823317585920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"67476497990875549413061344119283906281177486718750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"43028491472442379335865204945630317048866803125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"7722164367374552745577256138591637180004680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"615227380917203378081704472580102962143230000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"26461392727621650670180837530327009124440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"683553115666331760978342549218581457760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"11309065619080613588096482404011957760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"124711500561289974405073991422688256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"938609035715789072567401797199872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"4875518633310950800900108640256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"17480851122235341807148848906240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"42772645320733943815722762240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"69639089513868400662046310400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"72146168882536545622425600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"44080601142573976780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"13872730493335633920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1701966690385920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"34359738368", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"4", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"274877906944", " ", 
        SuperscriptBox["T", 
         RowBox[{"73", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2395415678676082004163677716234578672981800778515625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"2395415678676082004163677716234578672981800778515625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"9581662714704328016654710864938314691927203114062500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"6387775143136218677769807243292209794618135409375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"2555110057254487471107922897316883917847254163750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"730031444929853563173692256376252547956358332500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"162229209984411902927487168083611677323635185000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"29496219997165800532270394197020304967933670000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"4537879999563969312656983722618508456605180000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"605050666608529241687597829682467794214024000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"71182431365709322551482097609702093436944000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"7492887512179928689629694485231799309152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"713608334493326541869494712879218981824000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"62052898651593612336477801119932085376000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"4964231892127488986918224089594566830080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"367720880898332517549498080710708654080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"25360060751609139141344695221428183040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"1636132951716718654280302917511495680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"99159572831316282077594116212817920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"5666261304646644690148235212161024000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"306284394845764577845850552008704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"15706892043372542453633361641472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"766189855774270363591871299584000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"35636737477873040167063781376000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"1583854999016579562980612505600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"67398085064535300552366489600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"2750942247532053083770060800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"107880088138511885638041600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"4070946722207995684454400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"148034426262108933980160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"5194190395161716981760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"176074250683448033280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"5772926251916328960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"183267500060835840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "-", 
        RowBox[{"5639000001871872", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]]}], "-", 
        RowBox[{"168328358264832", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]]}], "-", 
        RowBox[{"4879082848256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]]}], "+", 
        RowBox[{"9581662714704328016654710864938314691927203114062500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{"4790831357352164008327355432469157345963601557031250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"4790831357352164008327355432469157345963601557031250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"4723354859361288458914294088349873439682424070312500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"4723354859361288458914294088349873439682424070312500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"6117869151172716480117561866815074169493425462500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2375172729278819339339759312998793501097447532500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"658056513739586310466426822649016381256435680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"141664943930049830725411329875829915409371570000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"24926383096196451154031319039735468986986200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3707000563024087607522606421293992823705640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"477223060987008979359232091017157696844864000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"54138750616173287574366665787660747121056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5487748600469806927616114270873993860224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"502541080629103198499644163999449987200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"41951255426429484396492034559954085888000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3216262916026260470397722649596479918080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"227883362810234236227857965510861701120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"15001726078416673858260242243661742080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"921765043220686565791719953527603200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"53071320670281953788008118536437760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2873033900947594490779386868137984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"146671400348675995024773503778816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"7079162611097483922764332007424000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"323742192580677618419100549120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"14053924639161198939123744768000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"580003239076493924471773593600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"22782451289420383285306982400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"852404640080354476661145600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"30388757222116024123392000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1032070999996393272115200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"33359870706954125967360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1024206556792451235840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"29759028284526428160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"813088204495257600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"20649859161784320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"476535211425792", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9483287789568", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"6117869151172716480117561866815074169493425462500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"3058934575586358240058780933407537084746712731250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"3058934575586358240058780933407537084746712731250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"1462968710063040897419416968151430779661471306250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1462968710063040897419416968151430779661471306250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1101529381694524910998149246608136116450990160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"295648578636625733687814949306079823463036320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"61593453882630361184961447772099963221465900000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"10476305938981117151694322494961284066994200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1504290083546006565371492460814953609619680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"186739458647090470184047339963235620504512000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"20400108927833412709181642180857672828224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1988314710315147437542070387997823862400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"174796897610122851652050143999808691200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13983751808809828132164011519984695296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1025475132646054063025360844798877655040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"69355806072679984938913293851131822080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4348326399541064886452244128597606400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"253819359727435431160038827782963200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13844692348769205336002117879070720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"707848932117523280336950387802112000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"34010759501142259715889508122624000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1538948393716844331035724349440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"65686821683036038519817502720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2647840874044863568240705536000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"100870128535042421647264972800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3631984988168466900556185600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"123536904359471663284224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3963750942015133581312000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"119660405796683277926400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"3384334709401143214080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"89061439721082716160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2156451324965683200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"47135548086681600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"897819963555840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13812614823936", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{"1101529381694524910998149246608136116450990160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{"550764690847262455499074623304068058225495080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"550764690847262455499074623304068058225495080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"169887616082240160402699635049016017960102960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"169887616082240160402699635049016017960102960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"88253307055709174235168641583904424914339200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"17773235448719208700138129207869641128582200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2918771803895236619377522685163342824635200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"404137634385494301144580064099539775718720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"48310705719645295769007272030289812269824000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5074653962147615101786478154442207171200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"474821423358841179114524271760674355200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"40003270099829110328329883701448755200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3061119798943444964254808491936948224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"214278385926041147497836594435586375680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"13802150462224872624659361960424243200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"822071657624678933757140681028403200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"45460183831779480207768148259635200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2341888258000761101612298546708480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"112692367302292263536230907510784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5076232761364516375505896734720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"214380870766525578452737720320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8496802804770830853309726720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"316160104363565799192920064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"11040511580949916797213081600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"361391541111290238861312000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"11063006360549701189632000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"315522463045980782592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8334555627629681049600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"202049833397083176960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4430917399058841600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"85828908456345600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1407031286169600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"17867063951360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"88253307055709174235168641583904424914339200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"44126653527854587117584320791952212457169600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"44126653527854587117584320791952212457169600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"9843638094675254049307271561281647394291680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9843638094675254049307271561281647394291680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3828081481262598796952827829387307320002320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"606206451578241451716870096149309663578080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"80827526877098860228916012819907955143744000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9290520330701018417116783082748040821120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"936859193011867403406734428512407477760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"84006867209641131689492755773042385920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6769784170740310978640441857168250880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"494488582906248801918084448697507020800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"32965905527083253461205629913167134720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2017237375248250614373291363446620160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"113825306440340160058681017373163520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5944793270309624334861988618567680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"288232400984709058659975205748736000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"13002965457956799638795873943552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"546671220454640225054481186816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"21438087076652557845273772032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"784320258901922847997820928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"26752008830763259931708620800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"849270121611532061324083200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"25019414384627785767321600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"680800391418443150131200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"16989671087091272908800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"384671798198292971520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"7771147438349352960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"136335919971041280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1980667118223360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"21646635171840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"3828081481262598796952827829387307320002320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"1914040740631299398476413914693653660001160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"1914040740631299398476413914693653660001160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"328121269822508468310242385376054913143056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"328121269822508468310242385376054913143056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"100072176133550969807229349205600325416064000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"12829766170968073052208890923794913514880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1415698336106821854036843136418749077504000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"136811183741415557322888202258954742784000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"11734292562616539029643432552424968192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"902637889432041463818725580955766784000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"62792201003968101830867866501270732800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3976839396917979782621631545080479744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"230541414314085784499804727251042304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"12285906091973223625381443145039872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"603915506825104694335186145378304000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"27450704855686577015235733880832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1155819151818382190115188794982400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"45122068989906812226719082086400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1633378062983052026306573107200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"54777922843943817955403366400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1698540243223064122648166400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"48529721234944689218519040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1270827397314427213578240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"30257795174153028894720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"647225565222524682240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"12211803117406126080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"197362474624745472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2596874666115072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"25151328485376", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"100072176133550969807229349205600325416064000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"50036088066775484903614674602800162708032000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"50036088066775484903614674602800162708032000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"6835531156663317609783425492185814577600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"6835531156663317609783425492185814577600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1682592284717124334715920121153431280640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"177929299073534987119384656489788135424000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"16447246132847771918598581692333357056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1346558162923209396844328325688111104000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"98648949664703985116800609940520960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"6519408847406524233805953352590950400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"391164530844391454028357201155457024000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"21416415537374089270473663187255296000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1074177581811866546481437652025344000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"49501271051238089699605421752320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2100053923385858350892351225856000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"82107371440650100937144559206400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2958824196059463096834038169600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"98181195042697116335367782400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2993329117155399888273408000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"83534766060150694556467200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2121517868194303353815040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"48610884050278636584960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"992058858168951767040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"17683758612637286400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"266924658303959040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3235450403684352", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"28381143891968", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"1682592284717124334715920121153431280640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"841296142358562167357960060576715640320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"841296142358562167357960060576715640320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"93703686558096512587085139918956221440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"93703686558096512587085139918956221440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"18956148085316076109571246696248614912000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1672601301645536127315110002610171904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"130417255488930692188312670768824320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"9076658806921916306146303093800960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"568277768781198238297855498046668800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"32202406897601233503545144889311232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1659383286188791420472535646470144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"78027427250256649865479732592640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3356018376355124725396977745920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"132206784523080671000487002112000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4771372674517197148889756467200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"157612911170237743657018982400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4754537290203250185732096000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"130459864670211133145088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3236213697245547488870400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"71915859938789944197120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1412422781121897431040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"24020795597311180800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"342542539712102400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3877840072212480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"31336081391616", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"18956148085316076109571246696248614912000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"9478074042658038054785623348124307456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"9478074042658038054785623348124307456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"872980503929029820835517939958817792000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"872980503929029820835517939958817792000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"146719412425047028711851754614927360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"10868104624077557682359389230735360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"716578326862256550485234454773760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"42371588023159517767822559064883200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2259818027901840947617203150127104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"109169953038736277662666818846720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4791157813612250430336474808320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"191351924967616760658599608320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6958251817004245842130894848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"230197804472320915078014566400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6912846981150778230571008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"187679103560654612594688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4577539111235478355968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"99357438073328212377600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1892522629968156426240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"30974183796532838400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"421417466619494400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4507138680422400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"34016140984320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"146719412425047028711851754614927360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"73359706212523514355925877307463680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"73359706212523514355925877307463680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"5631654214294734435404410783199232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"5631654214294734435404410783199232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"790407609023822376898864671326208000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"49219521441043884275753477701632000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2739173367153746603172367454699520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"136958668357687330158618372734976000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"6175270070878011665767011975168000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"251656774048320224623734030336000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"9277669089338994456174526464000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"309255636311299815205817548800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"9300921392821047073859174400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"251376253860028299293491200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"6066395266607017780838400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"129465752641003428249600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2408665165414017269760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"38232780403397099520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"500592869438914560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"5108090504478720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"36421322670080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"790407609023822376898864671326208000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"395203804511911188449432335663104000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"395203804511911188449432335663104000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"25352696893216944164680564929331200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"25352696893216944164680564929331200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2971744690780008107215304314060800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"155047549084174336028624572907520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"7235552290594802348002480069017600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"302937777061940194924419455385600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"11395778447471104511263427788800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"385110792387656373652527513600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"11670024011747162837955379200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"315880349190148768546160640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"7588717097661231676784640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"160244403268864620625920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2931300059796304035840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"45446512554981457920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"577098572126748672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"5667089087987712", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"38551626448896", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"2971744690780008107215304314060800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"1485872345390004053607652157030400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"1485872345390004053607652157030400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"79458414191978826396131131392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"79458414191978826396131131392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"7738558599566633527275379752960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"335337539314554119515266455961600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"12959904901045569836338800230400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"446893272449847235735820697600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"13729440013820191574065152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"374439273104187042929049600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"9009065217544349905059840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"189379749317749097103360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"3427687770456997232640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"52251337964283494400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"648078610409717760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"6172177241997312", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"40407052320768", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"7738558599566633527275379752960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"3869279299783316763637689876480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"3869279299783316763637689876480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"171090581282935775262891048960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"171090581282935775262891048960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"13687246502634862021031283916800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"484894401059528123128322457600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"15200451443872354957000704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"420288980014903823695872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"10188823757937062392627200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"214501552798674997739520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"3864892843219369328640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"58294009701649612800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"710902557337190400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"6613047044997120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"41987600285696", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"13687246502634862021031283916800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"6843623251317431010515641958400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"6843623251317431010515641958400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"246415239818303571573394636800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"246415239818303571573394636800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"15872157154158040036933632000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"447803806857123386621952000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"11005930736887825170432000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"233459136843075079372800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"4212796454311129251840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"63255202016683622400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"763260356159078400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"6981039842918400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"43293270343680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"15872157154158040036933632000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"7936078577079020018466816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"7936078577079020018466816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"226745102202257714813337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"226745102202257714813337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"11372795094784086009446400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"244576238597507226009600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"4446840701772858654720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"66869784989065543680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"803240660529315840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"7269146249134080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"44324062494720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"11372795094784086009446400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"5686397547392043004723200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"5686397547392043004723200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"123425683199207134986240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"123425683199207134986240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"4550255601814087925760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"68943266694152847360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"829392682034921472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"7472006144458752", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"45079976738816", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"4550255601814087925760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"2275127800907043962880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"2275127800907043962880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"34681826233339084800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"34681826233339084800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"840771545050644480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"7585908677148672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"45561013075968", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "+", 
        RowBox[{"840771545050644480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"420385772525322240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"420385772525322240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"3804396131450880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"3804396131450880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"45767171506176", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "+", 
        RowBox[{"45767171506176", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"22883585753088", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"22883585753088", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "+", 
        RowBox[{"2395415678676082004163677716234578672981800778515625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4790831357352164008327355432469157345963601557031250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4723354859361288458914294088349873439682424070312500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3058934575586358240058780933407537084746712731250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1462968710063040897419416968151430779661471306250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"550764690847262455499074623304068058225495080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"169887616082240160402699635049016017960102960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"44126653527854587117584320791952212457169600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"9843638094675254049307271561281647394291680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1914040740631299398476413914693653660001160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"328121269822508468310242385376054913143056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"50036088066775484903614674602800162708032000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6835531156663317609783425492185814577600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"841296142358562167357960060576715640320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"93703686558096512587085139918956221440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"9478074042658038054785623348124307456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"872980503929029820835517939958817792000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"73359706212523514355925877307463680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5631654214294734435404410783199232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"395203804511911188449432335663104000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"25352696893216944164680564929331200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1485872345390004053607652157030400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"79458414191978826396131131392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3869279299783316763637689876480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"171090581282935775262891048960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6843623251317431010515641958400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"246415239818303571573394636800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7936078577079020018466816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"226745102202257714813337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5686397547392043004723200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"123425683199207134986240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2275127800907043962880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"34681826233339084800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"420385772525322240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3804396131450880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"22883585753088", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2395415678676082004163677716234578672981800778515625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"4790831357352164008327355432469157345963601557031250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4723354859361288458914294088349873439682424070312500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"3058934575586358240058780933407537084746712731250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1462968710063040897419416968151430779661471306250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"550764690847262455499074623304068058225495080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"169887616082240160402699635049016017960102960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"44126653527854587117584320791952212457169600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"9843638094675254049307271561281647394291680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1914040740631299398476413914693653660001160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"328121269822508468310242385376054913143056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"50036088066775484903614674602800162708032000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6835531156663317609783425492185814577600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"841296142358562167357960060576715640320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"93703686558096512587085139918956221440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"9478074042658038054785623348124307456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"872980503929029820835517939958817792000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"73359706212523514355925877307463680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5631654214294734435404410783199232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"395203804511911188449432335663104000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"25352696893216944164680564929331200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1485872345390004053607652157030400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"79458414191978826396131131392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"3869279299783316763637689876480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"171090581282935775262891048960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"6843623251317431010515641958400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"246415239818303571573394636800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"7936078577079020018466816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"226745102202257714813337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"5686397547392043004723200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"123425683199207134986240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2275127800907043962880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"34681826233339084800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"420385772525322240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3804396131450880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"22883585753088", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"68719476736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"549755813888", " ", 
        SuperscriptBox["T", 
         RowBox[{"75", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"174865344543353986303948473285124243127671456831640625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"174865344543353986303948473285124243127671456831640625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{"699461378173415945215793893140496972510685827326562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{"466307585448943963477195928760331315007123884884375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"186523034179577585390878371504132526002849553953750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{
        "53292295479879310111679534715466436000814158272500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{
        "11842732328862068913706563270103652444625368505000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"2153224059793103438855738776382482262659157910000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"331265239968169759823959811751151117332178140000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"44168698662422634643194641566820148977623752000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"5196317489696780546258193125508252820896912000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"546980788389134794342967697421921349568096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"52093408418012837556473114040182985673152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"4529861601566333700562879481755042232448000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"362388928125306696045030358540403378595840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"26843624305578273781113359891881731747840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"1851284434867467157318162751164257361920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"119437705475320461762462112978339184640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"7238648816686088591664370483535708160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"413637075239205062380821170487754752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"22358760823740814182747090296635392000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"1146603119166195599115235399827456000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"55931859471521736542206604869632000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"2601481835884731932195656040448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"115621414928210308097584712908800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"4920060209711076940322753740800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"200818784069839875115214438400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"7875246434111367651577036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"297179110721183684965171200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"10806513117133952180551680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"379175898846805339668480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"12853420299891706429440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"421423616389892014080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"13378527504441016320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "-", 
        RowBox[{"411647000136646656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]]}], "-", 
        RowBox[{"12287970153332736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]]}], "-", 
        RowBox[{"356173047922688", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]]}], "-", 
        RowBox[{"10033043603456", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]]}], "+", 
        RowBox[{"699461378173415945215793893140496972510685827326562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{"349730689086707972607896946570248486255342913663281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"349730689086707972607896946570248486255342913663281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{"344939857729355808599569591137779328909379312106250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"344939857729355808599569591137779328909379312106250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{"447144260019535307443886507030454685623269478656250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"173747483893305148035338757017548106413613283135000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "48182075365370335169463688920832668165119649945000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "10382669439002361787359178757351147348712651840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1828765639824279633000764440215258908011887540000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"272272799973838158759419023357110507396310800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"35092938663294696017880674121583132064413392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3986216156479722062882997466143317232468864000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"404615925657716149240003502202517162694208000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"37107633393652980177213725069719387054848000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3102644932579680616823890055996604268800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"238283130822119471372074756300539207843840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"16915160521323295807276911712692598087680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1115842673070802122219166589742840053760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"68717583972102183479772722535482818560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3966382913252651283103764648512716800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"215317929576572498225632938062118912000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"11026238214447524802450619872313344000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"534034329474666443423534295810048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"24518075384776651634939881586688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1069102124336191205011913441280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"44347939972464227763457150156800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1752350211677917814361528729600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"66022613940769274010481459200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2373361939047261484036915200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"81418934444159913689088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2664619672717960811642880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"83107046322587471708160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2465039509568272465920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"69275115022995947520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1832675000608358400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"45112000014974976", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1009970149588992", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"19516331393024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{"447144260019535307443886507030454685623269478656250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{"223572130009767653721943253515227342811634739328125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"223572130009767653721943253515227342811634739328125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{"107062710145522538402057332669263797966134945593750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"107062710145522538402057332669263797966134945593750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "80755872795479857537551816641958979037313216105000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "21715864953406348245392085147417540581462377440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4533278205761594583213162556026557293099890240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"772717875982089985774970890231799538596572200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"111210016890722628225678192638819784711169200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13839468768623260401417730639497573208501056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1515885017252852052082266642054500919389568000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"148169212212684787045635085313597834226048000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"13066068096356683160990748263985699667200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1048781385660737109912300863998852147200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"77190309984630251289545343590315518033920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5241317344635387433240733206749819125760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"330037973725166824881725329360558325760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"19357065907634417881626119024079667200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1061426413405639075760162370728755200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"54587644118004295324808350494621696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2640085206276167910445923068018688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"120345764388657226686993644126208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5179875081290841894705608785920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"210808869587417984086856171520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8120045347070914942604830310400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"296171866762464982708990771200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"10228855680964253719933747200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"334276329443276265357312000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"10320709999963932721152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"300238836362587133706240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8193652454339609886720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"208313197991684997120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4878529226971545600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"103249295808921600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1906140845703168", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"28449863368704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{
        "80755872795479857537551816641958979037313216105000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{
        "40377936397739928768775908320979489518656608052500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
        "40377936397739928768775908320979489518656608052500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
        "12483999659204615657979024794892209319777888480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "12483999659204615657979024794892209319777888480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6504268730005766141131928884733756116186799040000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1313993682829447705279177552471465882057939200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"216510322738943087801682664895866537384546800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"30085801670920131307429849216299072192393600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3610296200510415756891581905955888663087232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"380802033319557037238057320709343226126848000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"35789664785672653875757266983960829523200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3029812891908796095302202495996683980800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"233062530146830468869400191999744921600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"16407602122336865008405773516782042480640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1063455693114426435730003839050687938560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"63775453859935618334632913886098227200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"3553471036184096036240543588961484800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"184595897983589404480028238387609600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8966086473488628217601371578826752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"408129114013707116590674097471488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"17441415128790902418404875960320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"700659431285717744211386695680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"26478408740448635682407055360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"941454532993729268707806412800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"31477203230793379804820275200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"988295234875773306273792000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"29067506908110979596288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"797736038644555186176000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"20306008256406859284480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"474994345179107819520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"10063439516506521600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"188542192346726400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2992733211852800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"36833639530496", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"6504268730005766141131928884733756116186799040000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"3252134365002883070565964442366878058093399520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"3252134365002883070565964442366878058093399520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"728089783209600687440141293067211505543298400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"728089783209600687440141293067211505543298400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"284371767179507339202210067325914258057315200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"45240962960376167600351601620031813781845600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6062064515782414517168700961493096635780800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"700505232934856788650605444439202277912448000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"71045155470066611425010694162190900396800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6410089215344355918046077668769103795200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"520042511297778434268288488118833817600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"38263997486793062053185106149211852800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2571340631112493769974039133227036508160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"158724730315586035183582662544878796800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"9042788233871468271328547491312435200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"477331930233684542181565556726169600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"23418882580007611016122985467084800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1070577489371776503594193621352448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"45686094852280647379553070612480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1822237401515467416848270622720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"67974422438166646826477813760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2371200782726743493946900480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"77283581066649417580491571200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2349045017223386552598528000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"66378038163298207137792000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1735373546752894304256000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"41672778138148405248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"909224250286874296320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"17723669596235366400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"300401179597209600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4221093858508800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"44667659878400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{"284371767179507339202210067325914258057315200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"142185883589753669601105033662957129028657600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"142185883589753669601105033662957129028657600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"24499721480080632300498098108078766848014848000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"24499721480080632300498098108078766848014848000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7516959999570194001289189192251439828368192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"969930322525186322746992153838895461724928000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"107770035836131813638554683759877273524992000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"10492822961732914918155425599338963750912000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"907274165864124222246521762348857767936000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"70405755375699234177860595314549809152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4944885829062488019180844486975070208000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"316472693059999233227574047166404493312000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"18558583852283905652234280543708905472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1001662696674993408516392952883838976000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"49936263470600844412840704395968512000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2305859207877672469279801645989888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"98822537480471677254848641970995200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3936032787273409620392264545075200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"145778992121237393347861649817600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5019649656972306227186053939200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"160512052984579559590251724800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4755912681024579543414865920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"130100954800064485990072320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3267841878808527120629760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"74754552783201600798720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1538687192793171886080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"27976130778057670656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"436274943907332096", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5545867931025408", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"51951924412416", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"7516959999570194001289189192251439828368192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"3758479999785097000644594596125719914184096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"3758479999785097000644594596125719914184096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"517039576690013344004018304228935014649664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"517039576690013344004018304228935014649664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"128297661709680730522088909237949135148800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"13685083915699277922356150318714574415872000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1276904381586545201680289887750244265984000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"105608633063548851266790892971824713728000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7822861708411026019762288368283312128000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"523268341699734181923898887510589440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"31814715175343838260973052360643837952000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1767484176407991014498502908924657664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"90096644674470306586130583063625728000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4227408547775732860346303017648128000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"183004699037910513434904892538880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7320187961516420537396195701555200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"270732413939440873360314492518400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"9255809023570628149070580940800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"292148921834367029095484620800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8492701216115320613240832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"226472032429741883019755520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"5506918721695851258839040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"121031180696612115578880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2373160405815923834880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"40706010391353753600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"592087423874236416", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"6924999109640192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"58686433132544", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"128297661709680730522088909237949135148800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"64148830854840365261044454618974567574400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"64148830854840365261044454618974567574400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"7211109791644818577353943376371848345600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"7211109791644818577353943376371848345600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1474271335180718464703472868058244550656000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"131577969062782175348788653538666856448000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"10387734399693329632799104226736857088000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"732820768937801032296233102415298560000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"46567206052903744527185381089935360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2682271068647255684765877950780276736000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"140736444959886872348826929516249088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"6751973371388875435026179527016448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"297007626307428538197632530513920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"12000308133633476290813435576320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"445725730677814833658784749977600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"15216810151162953069432196300800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"476880090207385993628929228800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"13683790249853256632107008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"358006140257788690956288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"8486071472777213415260160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"180554712186749221601280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3401344656579263201280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"55577527068288614400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"762641880868454400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"8319729609474048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"64871186038784", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"1474271335180718464703472868058244550656000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"737135667590359232351736434029122275328000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"737135667590359232351736434029122275328000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"68716036809270775897195769273901229056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"68716036809270775897195769273901229056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"11708209111518752891205770018271203328000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"880316474550282172271110527689564160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"58998282244992455989950970109706240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"3551736054882488989361596862791680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"193214441385607401021270869335867392000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"9541453895585550667717079967203328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"429150849876411574260138529259520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"17619096475864404808334133166080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"661033922615403355002435010560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"22664020203956686457226343219200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"709258100266069846456585420800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"20206783483363813289361408000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"521839458680844532580352000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"12135801364670803083264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"251705509785764804689920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4590374038646166650880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"72062386791933542400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"941991984208281600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"9694600180531200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"70506183131136", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"11708209111518752891205770018271203328000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"5854104555759376445602885009135601664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"5854104555759376445602885009135601664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"456460394211257422659094347690885120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"456460394211257422659094347690885120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"65208627744465346094156335384412160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"4140230332981926736136910183137280000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"235397711239775098710125328138240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"12052362815476485053958416800677888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"557979759975763196942519296327680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"23423438199882113214978321285120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"892975649848878216406798172160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"30925563631129981520581754880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"971946285549799419218283724800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"27651387924603112922284032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"709009946784695203135488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"16275694617726145265664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"331191460244427374592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"5887848182123153326080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"89480975412205977600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1123779910985318400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"11017450107699200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"75591424409600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"65208627744465346094156335384412160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"32604313872232673047078167692206080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"32604313872232673047078167692206080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"2134100544364320417626934612580761600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2134100544364320417626934612580761600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"255941511493428198233918084048486400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"13695866835768733015861837273497600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"657401608116899184761368189127884800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"28406242326038853662528255085772800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1107289805812608988344429733478400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"38966210175223776715933011148800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1237022545245199260823270195200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"35343501292719978880664862720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"904954513896101877456568320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"20625743906463860454850560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"414290408451210970398720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"7225995496242051809280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"107051785129511878656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1301541460541177856", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"12259417210748928", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"80126909874176", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"255941511493428198233918084048486400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"127970755746714099116959042024243200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"127970755746714099116959042024243200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"7024123814570928253417992015052800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"7024123814570928253417992015052800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"704761586746246981948293513216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"31573319086231864791283549392076800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1266830704077204451502117722521600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"45583113789884418045053711155200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1470423025480142517582377779200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"42436450951807864865292288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1091223024475059382250373120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"24835801410527667305840640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"495300882831036100116480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"8527418355771066286080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"123945034240858521600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1468978183595360256", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"13394937844334592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"84112639524864", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"704761586746246981948293513216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"352380793373123490974146756608000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"352380793373123490974146756608000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"16121997082430486515157041152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"16121997082430486515157041152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1341350157258216478061065823846400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"49679635454008017705965400883200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1638608665649439864364675891200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"48053040048370670509228032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1248130910347290143096832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"28528706522223774699356160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"568139247953247291310080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"9711782016294825492480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"139336901238089318400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1620196526024294400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"14401746897993728", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"87548613361664", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"1341350157258216478061065823846400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"670675078629108239030532911923200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"670675078629108239030532911923200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"25268762774095129884980831846400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"25268762774095129884980831846400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1715780188364484127992525619200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"51447681810029509085233152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1357856704663535430402048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"31350226947498653515776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"627004538949973070315520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"10702780181222868910080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"152461256142775910400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1749913987291545600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"15260877796147200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"90434831384576", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"1715780188364484127992525619200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"857890094182242063996262809600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"857890094182242063996262809600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"26075686753259637203533824000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"26075686753259637203533824000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1407383392979530643668992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"33017792210663475511296000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"667026105265928798208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"11434733233130207969280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"162656233757186457600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1853632293529190400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"15956662498099200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"92771293593600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"1407383392979530643668992000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"703691696489765321834496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"703691696489765321834496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"16680099472349992813854720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"16680099472349992813854720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"684813468073020232826880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"11858241871394289745920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"169403455305632710656", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"1927777585270358016", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"16476731498037248", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"94557999988736", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"684813468073020232826880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"342406734036510116413440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"342406734036510116413440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"5972210477380990402560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"5972210477380990402560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"172358166735382118400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"1969807619832938496", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"16812013825032192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"95794950569984", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "+", 
        RowBox[{"172358166735382118400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"86179083367691059200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"86179083367691059200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"989142994177228800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"989142994177228800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"16956737043038208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"96482145337344", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "+", 
        RowBox[{"16956737043038208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"8478368521519104", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"8478368521519104", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"48309792145408", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"48309792145408", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "+", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"174865344543353986303948473285124243127671456831640625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"349730689086707972607896946570248486255342913663281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"344939857729355808599569591137779328909379312106250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"223572130009767653721943253515227342811634739328125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"107062710145522538402057332669263797966134945593750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "40377936397739928768775908320979489518656608052500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "12483999659204615657979024794892209319777888480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3252134365002883070565964442366878058093399520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"728089783209600687440141293067211505543298400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"142185883589753669601105033662957129028657600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"24499721480080632300498098108078766848014848000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3758479999785097000644594596125719914184096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"517039576690013344004018304228935014649664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"64148830854840365261044454618974567574400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7211109791644818577353943376371848345600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"737135667590359232351736434029122275328000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"68716036809270775897195769273901229056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5854104555759376445602885009135601664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"456460394211257422659094347690885120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"32604313872232673047078167692206080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2134100544364320417626934612580761600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"127970755746714099116959042024243200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7024123814570928253417992015052800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"352380793373123490974146756608000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"16121997082430486515157041152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"670675078629108239030532911923200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"25268762774095129884980831846400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"857890094182242063996262809600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"26075686753259637203533824000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"703691696489765321834496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"16680099472349992813854720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"342406734036510116413440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5972210477380990402560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"86179083367691059200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"989142994177228800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"8478368521519104", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"48309792145408", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"174865344543353986303948473285124243127671456831640625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"349730689086707972607896946570248486255342913663281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"344939857729355808599569591137779328909379312106250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"223572130009767653721943253515227342811634739328125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"107062710145522538402057332669263797966134945593750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "40377936397739928768775908320979489518656608052500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "12483999659204615657979024794892209319777888480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"3252134365002883070565964442366878058093399520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"728089783209600687440141293067211505543298400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"142185883589753669601105033662957129028657600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"24499721480080632300498098108078766848014848000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"3758479999785097000644594596125719914184096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"517039576690013344004018304228935014649664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"64148830854840365261044454618974567574400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7211109791644818577353943376371848345600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"737135667590359232351736434029122275328000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"68716036809270775897195769273901229056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"5854104555759376445602885009135601664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"456460394211257422659094347690885120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"32604313872232673047078167692206080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2134100544364320417626934612580761600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"127970755746714099116959042024243200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"7024123814570928253417992015052800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"352380793373123490974146756608000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"16121997082430486515157041152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"670675078629108239030532911923200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"25268762774095129884980831846400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"857890094182242063996262809600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"26075686753259637203533824000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"703691696489765321834496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"16680099472349992813854720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"342406734036510116413440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5972210477380990402560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"86179083367691059200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"989142994177228800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"8478368521519104", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"48309792145408", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"137438953472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"1099511627776", " ", 
        SuperscriptBox["T", 
         RowBox[{"77", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
        "13114900840751548972796135496384318234575359262373046875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{
        "13114900840751548972796135496384318234575359262373046875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{
        "52459603363006195891184541985537272938301437049492187500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{
        "34973068908670797260789694657024848625534291366328125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{
        "13989227563468318904315877862809939450213716546531250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{
        "3996922160990948258375965103659982700061061870437500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"888204924664655168527992245257773933346902637875000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"161491804484482757914180408228686169699436843250000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{
        "24844892997612731986796985881336333799913360500000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"3312652399681697598239598117511511173321781400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"389723811727258540969364484413118961567268400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"41023559129185109575722577306644101217607200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"3907005631350962816735483553013723925486400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"339739620117475027542215961131628167433600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"27179169609398002203377276890530253394688000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"2013271822918370533583501991891129881088000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"138846332615060036798862206337319302144000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"8957827910649034632184658473375438848000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"542898661251456644374827786265178112000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"31022780642940379678561587786581606400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"1676907061780561063706031772247654400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"85995233937464669933642654987059200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"4194889460364130240665495365222400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"195111137691354894914674203033600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"8671606119615773107318853468160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"369004515728330770524206530560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"15061408805237990633641082880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"590643482558352573868277760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"22288433304088776372387840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"810488483785046413541376000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"28438192413510400475136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"964006522491877982208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"31606771229241901056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"1003389562833076224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "-", 
        RowBox[{"30873525010248499200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]]}], "-", 
        RowBox[{"921597761499955200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]]}], "-", 
        RowBox[{"26712978594201600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]]}], "-", 
        RowBox[{"752478270259200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]]}], "-", 
        RowBox[{"20615843020800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"75", "/", "2"}]]}], "+", 
        RowBox[{
        "52459603363006195891184541985537272938301437049492187500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{
        "26229801681503097945592270992768636469150718524746093750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{
        "26229801681503097945592270992768636469150718524746093750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{
        "25880070992416389972984374046198387982895375611082812500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{
        "25880070992416389972984374046198387982895375611082812500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{
        "33574146152323965370358106870743854680512919711675000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "13056612392570430977361486005289276820199468776762500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "3623876092631793087594208360651717648055362762530000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"781620333704896548304633175826841061345274321330000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"137806339826758620086767281688478864810186106240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "20538444878026525109085508328571369274595044680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2650121919745358078591678494009208938657425120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"301386414402413271682975201279478663612020896000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"30630924149791548483206191055627595575813376000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2813044054572693228049548158169881226350208000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"235552803281449352429269733051262196087296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"18119446406265334802251517927020168929792000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1288493966667757141493441274810323123896320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"85159084003903489236635486553555838648320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5255259040914100317548332971046924124160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"304023250300815720849903560308499742720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"16545483009568202495232846819510190080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"849632911302150938944389431272144896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"41277712289983041568148474393788416000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1901683222031739042435024565567488000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"83247418748311421830260993294336000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3468642447846309242927541387264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"137761685871910154329037104742400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5221288385815836752995575398400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"189005914418672823637848883200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6537940435866041069233766400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"216130262342679043611033600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6825166179242496114032640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"205654724798267302871040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5899930629458488197120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"160542330053292195840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4116470001366466560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"98303761226661888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2137038287536128", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"40132174413824", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{
        "33574146152323965370358106870743854680512919711675000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{
        "16787073076161982685179053435371927340256459855837500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{
        "16787073076161982685179053435371927340256459855837500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{
        "8048596680351635533989957126548184341218850615812500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "8048596680351635533989957126548184341218850615812500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "6081161936265680181236856495614183724476464909725000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "1638190562422591395761765423308310717614068098130000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"342628091487077938982852898992587862507517510720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "58520500474376948256024462086888285056380401280000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8440456799188982921541989724070425729285634800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1052788159898840880536420223647493961932401760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"115600268537911939823606926518156199741597056000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"11329245918416052178720098061670480555437824000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1001906101628630464784770576882423450480896000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"80668768247071696037421141455911710988800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"5957078270552986784301868907513480196096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"405963852511759099374645881104622354104320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"25664381480628448811040831564085321236480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1511786847386248036554999895780622008320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"83294041178305676945179057618767052800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4306358591531449964512658761242378240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"209498526074502971246561777573953536000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"9612617930543995981623617324580864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"416807281541203077793977986973696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"17105633989379059280190615060480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"665219099586963416451857252352000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"24532902963490849401061402214400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"858293981230000562136258969600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"28480343268567137808442982400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"895608278885759050579968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"26646196727179608116428800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"747963416903287245373440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"19720316076546179727360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"484925805160971632640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"10996050003650150400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"225560000074874880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4039880598355968", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"58548994179072", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{
        "6081161936265680181236856495614183724476464909725000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{
        "3040580968132840090618428247807091862238232454862500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
        "3040580968132840090618428247807091862238232454862500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{"942151849280598337938104527489521422101987521225000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"942151849280598337938104527489521422101987521225000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"492226272277210560228887263341464253179813888640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "99732120526755080830689576232584260448197585280000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "16484648020951253029866045658278390156726873600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2298340349074934316664015981202275550697496800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"276789375372465208028354612789951464170021120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"29307110333555139673590488413053684441531648000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2765825294636782691518521592520492905552896000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"235189225734420296897833468751742594009600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"18178877351452776571813214975980103884800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1286505166410504188159089059838591967232000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"83861077514166198931851731307997106012160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5060582263785891314853121716861894328320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"283903633311971462263849745686501785600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"14859969787678947060642273190202572800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"727835254906723937664111339928289280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"33441079279498126865648358861570048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1444149172663886720243923729514496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"58705250921296208139996899573760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2248627942265791830259799162880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"81200453470709149426048303104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2764270756449673171950580531200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"88650082568356865572759142400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2674210635546210122858496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"75685206666402173288448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2001592242417247558041600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"49161914726037659320320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1111003722622319984640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"22766469725867212800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"412997183235686400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6353802819010560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"75866302316544", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{"492226272277210560228887263341464253179813888640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{"246113136138605280114443631670732126589906944320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{"246113136138605280114443631670732126589906944320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{
        "55286284205049012199621395520236926987587791840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "55286284205049012199621395520236926987587791840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "21680895766685887137106429615779187053955996800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3464165163823089404826922638333864598152748800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"466329925899262035265162662852635618982100800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"54154443007656236353373728589338329946308480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5521629483133577039951831150285476778839296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"501055306999417154260601737775451613324800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"40902474040768747286579733695955233740800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3029812891908796095302202495996683980800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"205095026529210812605072168959775531008000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"12761468317373117228760046068608255262720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"733417719389259610848278509690129612800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"39088181398025056398645979478576332800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1938256928827688747040296503069900800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"89660864734886282176013715788267520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3877226583130217607611403925979136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"156972736159118121765643883642880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5955605165928600825796786913280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"211827269923589085459256442880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"7060908997452969515308548096000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"220340422615553658633741926400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"6423919026692526490779648000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"174405041448665877577728000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4387548212545053523968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"101530041282034296422400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2137474553305985187840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"40253758066026086400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"659897673213542400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"8978199635558400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"92084098826240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{
        "21680895766685887137106429615779187053955996800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{
        "10840447883342943568553214807889593526977998400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{
        "10840447883342943568553214807889593526977998400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"1876853663384748438734586444351034103178280320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1876853663384748438734586444351034103178280320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"579084325892814945284500500736407216407623680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"75169599995701940012891891922514398283681920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8406062795218281463807265333270427334949376000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"824123803452772692530124052281414444602880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"71792999211856786282116069890213962506240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5616459122016007090097515671683405230080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"397945573862647845353125103951803269120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"25713406311124937699740391332270365081600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1523757411029625937762393560430836449280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"83193651751617508096222636920074403840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4200520986056423971197776899190292480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"196718613672063932535433077923512320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8564619914974212028753548970819584000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"347214320877332920084603336654848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"13120109290911365401307548483584000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"462226072579533198420049133568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"15175685009451158361260163072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"463701486399896505482949427200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"13154652096450964694551756800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"345165798449150677116518400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8329793024413892660428800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"183360223807852983091200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3636897001147497185280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"63805210546447319040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"961283774711070720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"11819062803824640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"107202383708160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{"579084325892814945284500500736407216407623680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{"289542162946407472642250250368203608203811840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"289542162946407472642250250368203608203811840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"40090453331041034673542342358674345751297024000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"40090453331041034673542342358674345751297024000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"10022613332760258668385585589668586437824256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1077700358361318136385546837598772735249920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"101430621963418177542169114126943316258816000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8467892214731826074300869781922672500736000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"633651798381293107600745357830948282368000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"42855677185208229499567318887117275136000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2637272442166660276896450393053370777600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"148468670818271245217874244349671243776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7679414007841616131959012638776098816000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"366199265451072859027498498903769088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"16141014455143707284958611521929216000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"658816916536477848365657613139968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"24928207652731594262484342118809600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"874673952727424360087169898905600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"28444681389509735287387638988800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"856064282584424317814675865600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"23779563405122897717074329600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"607137789066967601287004160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"14160648141503617522728960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"299018211132806403194880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"5641853040241630248960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"93253769260192235520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1308824831721996288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"14788981149401088", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"121221156962304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"10022613332760258668385585589668586437824256000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"5011306666380129334192792794834293218912128000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"5011306666380129334192792794834293218912128000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"568175359000014663740679455196631884230400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"568175359000014663740679455196631884230400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"117300719277422382191624145588982066421760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"10580064876002803099636687641359166775296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"844869064508390810134327143774597709824000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"60347790322027915009594795983899836416000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3887136252626596780006106021507235840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"227247965538170273292664659718884556800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"12119891495369081242275448518340509696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"592063665003662014708858117275254784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"26572282300304606550748190396645376000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1098028194227463080609429355233280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"41829645494379545927978261151744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1469690247099821883955992959385600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"47601303549791801909505844838400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1419009048909782712749496729600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"38823776987955751374815232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"970594424698893784370380800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"22027674886783405035356160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"449544385444559286435840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"8136549962797453148160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"127933175515683225600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1691678353926389760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"17807140567646208", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"134140418588672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"117300719277422382191624145588982066421760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"58650359638711191095812072794491033210880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"58650359638711191095812072794491033210880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"5528517506927694242638023255218417064960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"5528517506927694242638023255218417064960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"953940275705170771278717738155334709248000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"72714140797853307429593729587157999616000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4946540190330156967999573441303265280000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"302686839343874339426704977084579840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"16764194179045348029786737192376729600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"844418669759321234092961577097494528000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"38823846885486033751400532280344576000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1633541944690856960086978917826560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"63001617701575750526770536775680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2228628653389074168293923749888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"72279848218024027079802932428800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2145960405933236971330181529600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"58156108561876340686454784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1432024561031154763825152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"31822768022914550307225600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"631941492653622275604480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"11054370133882605404160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"166732581204865843200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2097265172388249600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"20799324023685120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"145960168587264", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"953940275705170771278717738155334709248000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"476970137852585385639358869077667354624000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"476970137852585385639358869077667354624000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"37726451581560425982774147836651655168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"37726451581560425982774147836651655168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"5477524730535089071909132172290621440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"353989693469954735939705820658237440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"20521141650432158605200337429463040000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1073413563253374450118171496310374400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"50887754109789603561157759825084416000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2193437677146103601774041371770880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"86137804993114867951855762145280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"3084824972205215656678030049280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"100728978684251939809894858752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2994645312234517129483360665600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"80827133933455253157445632000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1971393510572079345303552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"43149515963273966518272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"839018365952549348966400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"14281163675788074024960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"208180228510030233600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2511978624555417600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"23697911552409600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"156680406958080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"5477524730535089071909132172290621440000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"2738762365267544535954566086145310720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"2738762365267544535954566086145310720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"182584157684502969063637739076354048000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"182584157684502969063637739076354048000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"22357243798102404375139314988941312000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1224068098446830513292651706318848000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"60261814077382425269792084003389440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2678302847883663345324092622372864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"107747815719457720788900277911552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3929092859335064152189911957504000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"129887367250745922386443370496000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"3887785142199197676873134899200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"105075274113491829104679321600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2552435808424902731287756800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"55337361700268893903257600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1059812672782167598694400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"17663544546369459978240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"250546731154176737280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2921827768561827840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"26441880258478080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"166301133701120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"22357243798102404375139314988941312000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"11178621899051202187569657494470656000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"11178621899051202187569657494470656000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"628220073665687395665071660846284800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"628220073665687395665071660846284800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"64744097769088556074983230747443200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"2988189127804087203460764496035840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"123954511968169543254668749465190400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"4630484642489092133076706158182400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"155864840700895106863732044595200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"4723176990936215359507031654400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"128521822882618105020599500800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"3126206502550170122122690560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"67502434602972634215874560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1280533989758288453959680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"21021077807249605263360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"291959413989577850880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"3313014626832089088", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"28976804316315648", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"174822348816384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"64744097769088556074983230747443200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"32372048884544278037491615373721600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"32372048884544278037491615373721600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"1526983437950201794221302611968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1526983437950201794221302611968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"131555496192632769963681455800320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"5067322816308817806008470890086400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"174735269527890269172705892761600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"5391551093427189231135385190400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"148527578331327527028523008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"3637410081583531274167910400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"78646704466670946468495360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1485902648493108300349440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"24161018674684687810560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"330520091308956057600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"3672445458988400640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"31254854970114048", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"182244052303872", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"131555496192632769963681455800320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"65777748096316384981840727900160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"65777748096316384981840727900160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"2579519533188877842425126584320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"2579519533188877842425126584320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"183432500137875757683564557107200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"5798153739990325673905776230400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"162641058625254577108156416000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"4032422941122014308466688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"87780635452996229844172800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1660714724786415159214080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"26894165583585670594560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"364419587853464371200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"3988176064059801600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"33234800533831680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"188566244163584", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"183432500137875757683564557107200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"91716250068937878841782278553600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"91716250068937878841782278553600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"2941337465767687076558615347200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"2941337465767687076558615347200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"169042383090096958422908928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"4267549643228254209835008000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"94050680842495960547328000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1791441539857065915187200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"29050403349033501327360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"392043230081423769600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"4249791111993753600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"34882006391193600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"193788924395520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"169042383090096958422908928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"84521191545048479211454464000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"84521191545048479211454464000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"2157987869235280320292454400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"2157987869235280320292454400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"96852190484612861499801600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"1867673094744600634982400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"30492621955013887918080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"412062458851539025920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"4448717504470056960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"36168434995691520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"197912092999680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"96852190484612861499801600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"48426095242306430749900800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"48426095242306430749900800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"941618518600402820136960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"941618518600402820136960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"31127884912410010583040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"423508638264081776640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"4578471765017100288", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"37072645870583808", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"200935749976064", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "+", 
        RowBox[{"31127884912410010583040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"15563942456205005291520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"15563942456205005291520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"212913029496648499200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"212913029496648499200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"4634841458430443520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"37579795608895488", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"202859895324672", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "+", 
        RowBox[{"4634841458430443520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"2317420729215221760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"2317420729215221760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"18840818936709120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"18840818936709120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"203684529045504", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "+", 
        RowBox[{"203684529045504", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"101842264522752", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"101842264522752", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"]}], "-", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"]}], "+", 
        RowBox[{
        "13114900840751548972796135496384318234575359262373046875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "26229801681503097945592270992768636469150718524746093750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "25880070992416389972984374046198387982895375611082812500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "16787073076161982685179053435371927340256459855837500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "8048596680351635533989957126548184341218850615812500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "3040580968132840090618428247807091862238232454862500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"942151849280598337938104527489521422101987521225000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"246113136138605280114443631670732126589906944320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "55286284205049012199621395520236926987587791840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "10840447883342943568553214807889593526977998400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1876853663384748438734586444351034103178280320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"289542162946407472642250250368203608203811840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"40090453331041034673542342358674345751297024000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5011306666380129334192792794834293218912128000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"568175359000014663740679455196631884230400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"58650359638711191095812072794491033210880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5528517506927694242638023255218417064960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"476970137852585385639358869077667354624000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"37726451581560425982774147836651655168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2738762365267544535954566086145310720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"182584157684502969063637739076354048000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"11178621899051202187569657494470656000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"628220073665687395665071660846284800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"32372048884544278037491615373721600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1526983437950201794221302611968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"65777748096316384981840727900160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2579519533188877842425126584320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"91716250068937878841782278553600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2941337465767687076558615347200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"84521191545048479211454464000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2157987869235280320292454400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"48426095242306430749900800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"941618518600402820136960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"15563942456205005291520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"212913029496648499200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2317420729215221760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"18840818936709120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"101842264522752", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "13114900840751548972796135496384318234575359262373046875", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "26229801681503097945592270992768636469150718524746093750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "25880070992416389972984374046198387982895375611082812500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "16787073076161982685179053435371927340256459855837500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "8048596680351635533989957126548184341218850615812500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "3040580968132840090618428247807091862238232454862500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"942151849280598337938104527489521422101987521225000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"246113136138605280114443631670732126589906944320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "55286284205049012199621395520236926987587791840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "10840447883342943568553214807889593526977998400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1876853663384748438734586444351034103178280320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"289542162946407472642250250368203608203811840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"40090453331041034673542342358674345751297024000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"5011306666380129334192792794834293218912128000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"568175359000014663740679455196631884230400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"58650359638711191095812072794491033210880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5528517506927694242638023255218417064960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"476970137852585385639358869077667354624000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"37726451581560425982774147836651655168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2738762365267544535954566086145310720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"182584157684502969063637739076354048000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"11178621899051202187569657494470656000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"628220073665687395665071660846284800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"32372048884544278037491615373721600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1526983437950201794221302611968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"65777748096316384981840727900160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2579519533188877842425126584320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"91716250068937878841782278553600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2941337465767687076558615347200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"84521191545048479211454464000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2157987869235280320292454400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"48426095242306430749900800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"941618518600402820136960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"15563942456205005291520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"212913029496648499200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2317420729215221760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"18840818936709120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"101842264522752", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"274877906944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2199023255552", " ", 
        SuperscriptBox["T", 
         RowBox[{"79", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
        "1009847364737869270905302433221592504062302663202724609375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{
        "1009847364737869270905302433221592504062302663202724609375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{
        "4039389458951477083621209732886370016249210652810898437500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{
        "2692926305967651389080806488590913344166140435207265625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{
        "1077170522387060555632322595436365337666456174082906250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{
        "307763006396303015894949312981818667904701764023687500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{
        "68391779199178447976655402884848592867711503116375000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{
        "12434868945305172359391891433608835066856636930250000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{
        "1913056760816180362983367912862897702593328758500000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"255074234775490715064449055048386360345777167800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{
        "30008733502998907654641065299810160040679666800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"3158814052947253437330638452611595793755754400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"300839433614024136888632233582056742262452800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"26159950749045577120750629007135368892387200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"2092796059923646169660050320570829511390976000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"155021930364714531085929653375617000843776000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"10691167611359622833512389887973586265088000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"689752749119975666678218702449908791296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"41803196916362161616861739542418714624000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"2388754109506409235249242259566783692800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"129121843757103201905364446463069388800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"6621633013184779584890484434003558400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"323006488448038028531243143122124800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"15023557602234326908429913633587200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"667713671210414529263551717048320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"28413347711081469330363902853120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"1159728478003325278790363381760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"45479548156993148187857387520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"1716209364414835780673863680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"62407613251448573842685952000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"2189740815840300836585472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"74228502231874604630016000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"2433721384651626381312000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"77260996338146869248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "-", 
        RowBox[{"2377261425789134438400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]]}], "-", 
        RowBox[{"70963027635496550400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]]}], "-", 
        RowBox[{"2056899351753523200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]]}], "-", 
        RowBox[{"57940826809958400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]]}], "-", 
        RowBox[{"1587419912601600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]]}], "-", 
        RowBox[{"42331197669376", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"75", "/", "2"}]]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"77", "/", "2"}]]}], "+", 
        RowBox[{
        "4039389458951477083621209732886370016249210652810898437500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{
        "2019694729475738541810604866443185008124605326405449218750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{
        "2019694729475738541810604866443185008124605326405449218750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{
        "1993464927794235443865012595450416371655454607880703125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{
        "1993464927794235443865012595450416371655454607880703125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{
        "2588007099241638997298437404619838798289537561108281250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "1007224384569718961110743206122315640415387591350250000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "279784551269366378086317557256198789004274330930625000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "60397934877196551459903472677528627467589379375500000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "10658459095975862022335906943093287200162831654500000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "1590073151847214847155007096405525363194455072000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"205384448780265251090855083285713692745950446800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "23383428703635512458161869064787137694036104000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2379366429492736355391909483785357870621217600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"218792315355653917737187078968768539827238400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"18345939486343651487279661901107921041414400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1413316819688696114575618398307573176523776000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"100663591145918526679175099594556494054400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6664623965522881766345385904191326502912000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"412060083889855593080494289775270187008000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"23887541095064092352492422595667836928000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1302956787003495946499586687036427468800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"67076282471222442548241270889906176000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"3267818889623657457478420889508249600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"151016020573108688663957833148006400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"6633778681506066427098922903142400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"277491395827704739434203310981120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"11070135471849923115726195916800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"421719446546663737741950320640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"15356730546517166920575221760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"534922399298130632937308160000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"17830746643271021097910272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"568763848270208009502720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"17352117404853803679744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"505708339667870416896000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"14047453879663067136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"370482300122981990400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9215977614999552000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"213703828753612800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"4514869621555200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"82463372083200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"75", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{
        "2588007099241638997298437404619838798289537561108281250000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{
        "1294003549620819498649218702309919399144768780554140625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{
        "1294003549620819498649218702309919399144768780554140625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{
        "621121703817993359351624977108761311589489014665987500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "621121703817993359351624977108761311589489014665987500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "470038046132535515185013496190413965527180875963450000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "126835663242112758065797292622810117681937696688550000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "26575091345966482642357527978112596085739326925220000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "4547609214283034462863320295719802538736141505920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"657230236096848803490736266514283816787041429760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "82153779512106100436342033314285477098380178720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"9041592432072398150489256038384359908360626880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"888296800343954906012979540613200271698587904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"78765233528035410385387348428756674337805824000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6359925688599132515590282792384079294356992000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"471105606562898704858539466102524392174592000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"32212349166693928537336031870258078097408000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2043818016093683741679251677285340127559680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"120870957941024307303611658334079254855680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6688511506617945858697878326786994339840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"347455143200932252399889783209713991680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"16992658226043018778887788625442897920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"784276533509677789794821013481979904000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"34230297996571302763830442180214784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1415206118721294171114436886003712000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"55498279165540947886840662196224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2066425288078652314935556571136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"73098037401421714541938055577600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2457076887442746707292035481600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"78455285230392492830805196800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2377432885769469479721369600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"68251661792424961140326400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1850892523184405725839360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"47199445035667905576960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1123796310373045370880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"24698820008198799360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"491518806133309440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"8548153150144512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"120396523241472", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{
        "470038046132535515185013496190413965527180875963450000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{
        "235019023066267757592506748095206982763590437981725000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
        "235019023066267757592506748095206982763590437981725000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
        "72973943235188162174842277947370204693717578916700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "72973943235188162174842277947370204693717578916700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "38224446456527132567774526543860583410994922289700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "7766236740373766616944665710498658216837063576320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "1287451010436292861632538165911542271240368828160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"180063078382698302326229114113502415558093542400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "21757621971242711531086017955381541879936303040000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2312005370758238796472138530363123994831941120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"219032087756043675455255229192295957405131264000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"18702247230401102009315717435138571075643392000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1452037828447290528673580546206410797798400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"103256023356251770927899061063566990065664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"6766064208529318322910764685077039235072000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"410630103690055180976653305025365139783680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"23180731659922469893843331735302870794240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1221645937281816595195959511741916774400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"60289020281440299503177222657393295360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2793313680993372949954157034319380480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"121759827120223949100565819444690944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5001687378494436933527735843684352000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"193863851879629338508826970685440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7095670395594276442153144025088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"245329029634908494010614022144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8010743824813338579938417049600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"246829641660915194339839180800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"7164866231086072404639744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"195405442665983792853811200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"4986422779355248302489600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"118321896459277078364160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2586270960858515374080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"51314900017034035200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"902240000299499520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"13466268661186560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"156130651144192", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{
        "38224446456527132567774526543860583410994922289700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{
        "19112223228263566283887263271930291705497461144850000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{
        "19112223228263566283887263271930291705497461144850000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{
        "4306979882425592402002763554237812215323371525600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "4306979882425592402002763554237812215323371525600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "1695446048954836374121722795953932427619358949760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"271996692345695674992789753361593437585993414400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "36773445585198949066624255699236408811159948800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4290235318273210724439496498244247694635327360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"439606655003327095103857326195805266622974720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"40104466772233349027018563091547147130516992000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3292649160281884156569668562524396316134400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"245414844244612483719478402175731402444800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"16724567163336554446068157777901695574016000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1048263468927077486648146641349963825152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"60726987165430695778237460602342731939840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3264891783087671816034272075394770534400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"163459667664468417667065005092228300800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"7642270176520601345473169069247037440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"334410792794981268656483588615700480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"13719417140306923842317275430387712000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"528347258291665873259972096163840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"19113337509259230557208292884480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"649603627765673195408386424832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"20732030673372548789629353984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"620550577978498059009313996800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"17382369131050365798580224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"454111239998413039730688000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"11008757333294861569228800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"245809573630188296601600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"4999516751800439930880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"91065878903468851200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1445490141324902400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"19061408457031680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"189665755791360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{
        "1695446048954836374121722795953932427619358949760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{"847723024477418187060861397976966213809679474880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"847723024477418187060861397976966213809679474880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{"147430091213464032532323721387298471966900778240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"147430091213464032532323721387298471966900778240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{
        "45726980162464780143715378826007012695616284160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5969023051510554051394082084513735922970890240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"671515093294937330781834234507795291334225152000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"66259553797602924479421973803425721346071552000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5812241561193238989422980158195238714567680000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"458107709256609969609693017394698617896960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"32721979232614997829263786956764186992640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2132988275903792451092750557181665522483200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"127614683173731172287600460686082552627200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"7040810106136892264143473693025244282880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"359611268861830518867543011202902261760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"17056660973683660973954609227015127040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"753151263773044770278515212621447168000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"31017812665041740860891231407833088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1192992794809297725418893515685888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"42880357194685925945736865775616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1440425435480405781122943811584000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"45189817583699004897974707814400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1322042535693321951802451558400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"35973946549478148348366028800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"906906215533062563404185600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"21060231420216256915046400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"446732181640950904258560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"8549898213223940751360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"144913529037693911040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2111672554283335680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"25138958979563520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"221001837182976", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{
        "45726980162464780143715378826007012695616284160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{
        "22863490081232390071857689413003506347808142080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{
        "22863490081232390071857689413003506347808142080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"3184963792410482199064752754050239690241930240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3184963792410482199064752754050239690241930240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"801809066620820693470846847173486915025940480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"86862648883922241792675075110461082461143552000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8241238034527726925301240522814144446028800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"693998992381282267393788675605401637560320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"52420285138816066174243479602378448814080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"3581510164763830608178125935566229422080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"222849521363082793397750058213009830707200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"12697978425246882814686613003590303744000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"665549214012940064769781095360595230720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"32203994226432583779182956227125575680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1442603166928468838593175904772423680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"59952339404819484201274842795737088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2314762139182219467230688911032320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"83094025509105314208281140396032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2773356435477199190520294801408000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"85995548386889897380474257408000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2473074594132781362575730278400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"65773260482254823472758784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1610773726096036493210419200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"36095769772460201528524800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"733440895231411932364800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"13335289004207489679360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"212684035154824396800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2883851324133212160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"31517500810199040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"250138895319040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{"801809066620820693470846847173486915025940480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{"400904533310410346735423423586743457512970240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"400904533310410346735423423586743457512970240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"45817660949761182484048391267056395144339456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"45817660949761182484048391267056395144339456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"9545346031200246350843414847303415655070720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"869405331115012950361449549659514139361280000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"70162535493492273187064349621645000720384000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"5069214387050344860805962862647586258944000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"330600938285892056139519317129190408192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"19591166713238047771230774348396468633600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1060490505844794608699101745354794598400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"52658838910913939190576086665893249024000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2406452315821335930752132992796196864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"101457805146617588648311272423555072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3952901499218867090193945678839808000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"142446900872751967214196240678912000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4748230029091732240473208022630400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"146286932860335781477993571942400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4158026515410060972242711347200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"108706575566276103849482649600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2602019096001289719801446400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"56642592566014470090915840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1110639069921852354723840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"19343496137971303710720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"293083274817747025920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3739499519205703680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"38028808669888512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"277076930199552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"9545346031200246350843414847303415655070720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"4772673015600123175421707423651707827535360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"4772673015600123175421707423651707827535360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"454540287200011730992543564157305507384320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"454540287200011730992543564157305507384320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"79350486570021023247275157310193750814720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6125300717685833373473871792365833396224000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"422434532254195405067163571887298854912000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"26238169705229528265041215645173841920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1477111775998106776402320288172749619200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"75749321846056757764221553239628185600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"3552381990021972088253148703651528704000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"152790623226751487666802094780710912000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6039155068251046943351861453783040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"219605638845492616121885871046656000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"7348451235499109419779964796928000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"226106191861511059070152762982400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6385540720094022207372735283200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"165001052198811943342964736000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"3882377698795575137481523200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"82603780825437768882585600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1573405349055957502525440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"26443787379091722731520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"383799526547049676800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"4652115473297571840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"44517851419115520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"301815941824512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"79350486570021023247275157310193750814720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"39675243285010511623637578655096875407360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"39675243285010511623637578655096875407360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"3179800919017235904262392460517782364160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"3179800919017235904262392460517782364160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"468602240697276870101826257339462664192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"30778472295387643356441790301442539520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1816121036063246036560229862507479040000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"96859788590039788616545592667065548800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"4691214831996229078294230983874969600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"207060516722592180007469505495171072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"8349214383975491129333447802224640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"308007908763259224797544846458880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"10400267049149012785371644166144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"321243769857884564799124144128000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"9060721713940333878949655347200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"232624434247505362745819136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"5409870563895473552228352000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"113147619637029512203468800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2106471642178740918681600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"34391373749856994590720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"481671901258501324800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"5592707126368665600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"50842792057896960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"324355930193920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"468602240697276870101826257339462664192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"234301120348638435050913128669731332096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"234301120348638435050913128669731332096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"15884821718551758308536483299642802176000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"15884821718551758308536483299642802176000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1982342283431746521262352595686129664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"110814164912333656468081822119100416000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"5581750528917547140614491780813946880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"254438770548948017805788799125422080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"10528500850301297288515398584500224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"396233902968328392578536505868288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"13573229877702948889383332216832000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"423061710473858147201558406758400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"11978581248938068517933442662400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"307143108947129961998293401600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"7097016638059485643092787200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"146708354275131486162124800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2684858771048157916692480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"42843491027364222074880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"582904639828084654080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"6531144423844085760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"56874987725783040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"344696895307776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"1982342283431746521262352595686129664000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"991171141715873260631176297843064832000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"991171141715873260631176297843064832000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"56909347849715211136718256335486976000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"56909347849715211136718256335486976000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"6009061574193531610709381103747072000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"284874030183989646729926215288750080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"12174103854016651569654966465331200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"470172286775815508897019394523136000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"16430751957219359181885086367744000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"519549469002983689545773481984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"14844270542942391129879242342400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"382091905867243014926106624000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"8817505520013300344448614400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"181104092837243652774297600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"3275784624963063486873600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"51384856862165701754880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"683309266784118374400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"7437379774521016320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"62498989701857280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"362838837166080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"6009061574193531610709381103747072000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"3004530787096765805354690551873536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"3004530787096765805354690551873536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"145674219980449251168712269181747200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"145674219980449251168712269181747200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"12948819553817711214996646149488640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"516477133200706430227786456104960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"18521938569956368532306824632729600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"597481889353431242977639504281600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"17318315633432789651525782732800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"449826380089163367572098252800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"10420688341833900407075635200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"213757709576080008350269440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"3841601969274865361879040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"59559720453873881579520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"778558437305540935680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"8282536567080222720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"67612543404736512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"378781755768832", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"12948819553817711214996646149488640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"6474409776908855607498323074744320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"6474409776908855607498323074744320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"263110992385265539927362911600640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"263110992385265539927362911600640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"19489703139649299253878734192640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"645176379795287147714606373273600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"19077796176742361894786747596800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"502708726659877783788847104000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"11751632571269870270388633600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"241989859897449066056908800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"4343407741749085801021440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"66907436329896058552320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"864437161884961996800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"9039865745202216960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"72126588392570880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"392525651116032", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"19489703139649299253878734192640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"9744851569824649626939367096320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"9744851569824649626939367096320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"327558035960492424434936709120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"327558035960492424434936709120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"19879384251395402310534089932800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"534392049768693610498228224000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"12673329243526330683752448000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"263341906358988689532518400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"4744899213675471883468800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"72998449441161105899520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"937078940194622668800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"9685570441288089600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"75965258363043840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"404070523207680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"19879384251395402310534089932800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"9939692125697701155267044966400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"9939692125697701155267044966400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"270467812944155133476654284800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"270467812944155133476654284800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"13087152239233312910160691200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"275881997137988150938828800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"5016036311599784562524160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"77467742264089336872960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"993176182872940216320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"10199498668785008640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"79065881153372160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"413416372043776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"13087152239233312910160691200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"6543576119616656455080345600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"6543576119616656455080345600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"139225023821630988405964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"139225023821630988405964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"5136101010547651746201600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"80043132631911455784960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"1030156147128847564800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"10565704073116385280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"81378978740305920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"420563197624320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "+", 
        RowBox[{"5136101010547651746201600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"2568050505273825873100800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"2568050505273825873100800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"40283145180765896048640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"40283145180765896048640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"1046315459240672624640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"10772874741216706560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"82868267240128512", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"425510999949312", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "+", 
        RowBox[{"1046315459240672624640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"523157729620336312320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"523157729620336312320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"5407315034835517440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"5407315034835517440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"83510656908656640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"428259779018752", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "+", 
        RowBox[{"83510656908656640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"41755328454328320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"41755328454328320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"214404767416320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"]}], "-", 
        RowBox[{"214404767416320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "19"]}], "+", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]]}], "+", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]]}], "+", 
        RowBox[{
        "1009847364737869270905302433221592504062302663202724609375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "2019694729475738541810604866443185008124605326405449218750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "1993464927794235443865012595450416371655454607880703125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "1294003549620819498649218702309919399144768780554140625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "621121703817993359351624977108761311589489014665987500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "235019023066267757592506748095206982763590437981725000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "72973943235188162174842277947370204693717578916700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "19112223228263566283887263271930291705497461144850000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "4306979882425592402002763554237812215323371525600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"847723024477418187060861397976966213809679474880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"147430091213464032532323721387298471966900778240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "22863490081232390071857689413003506347808142080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3184963792410482199064752754050239690241930240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"400904533310410346735423423586743457512970240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"45817660949761182484048391267056395144339456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"4772673015600123175421707423651707827535360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"454540287200011730992543564157305507384320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"39675243285010511623637578655096875407360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3179800919017235904262392460517782364160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"234301120348638435050913128669731332096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"15884821718551758308536483299642802176000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"991171141715873260631176297843064832000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"56909347849715211136718256335486976000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3004530787096765805354690551873536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"145674219980449251168712269181747200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6474409776908855607498323074744320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"263110992385265539927362911600640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"9744851569824649626939367096320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"327558035960492424434936709120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"9939692125697701155267044966400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"270467812944155133476654284800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6543576119616656455080345600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"139225023821630988405964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"2568050505273825873100800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"40283145180765896048640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"523157729620336312320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5407315034835517440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"41755328454328320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"214404767416320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "1009847364737869270905302433221592504062302663202724609375", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "2019694729475738541810604866443185008124605326405449218750", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "1993464927794235443865012595450416371655454607880703125000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "1294003549620819498649218702309919399144768780554140625000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "621121703817993359351624977108761311589489014665987500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "235019023066267757592506748095206982763590437981725000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "72973943235188162174842277947370204693717578916700000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "19112223228263566283887263271930291705497461144850000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "4306979882425592402002763554237812215323371525600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"847723024477418187060861397976966213809679474880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"147430091213464032532323721387298471966900778240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "22863490081232390071857689413003506347808142080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3184963792410482199064752754050239690241930240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"400904533310410346735423423586743457512970240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"45817660949761182484048391267056395144339456000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"4772673015600123175421707423651707827535360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"454540287200011730992543564157305507384320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"39675243285010511623637578655096875407360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3179800919017235904262392460517782364160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"234301120348638435050913128669731332096000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"15884821718551758308536483299642802176000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"991171141715873260631176297843064832000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"56909347849715211136718256335486976000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"3004530787096765805354690551873536000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"145674219980449251168712269181747200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"6474409776908855607498323074744320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"263110992385265539927362911600640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"9744851569824649626939367096320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"327558035960492424434936709120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"9939692125697701155267044966400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"270467812944155133476654284800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"6543576119616656455080345600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"139225023821630988405964800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"2568050505273825873100800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"40283145180765896048640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"523157729620336312320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5407315034835517440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"41755328454328320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"214404767416320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"549755813888", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"4398046511104", " ", 
        SuperscriptBox["T", 
         RowBox[{"81", "/", "2"}]]}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "T"}], "-", 
        RowBox[{"2", " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{"2", " ", 
         SqrtBox[
          RowBox[{"T", " ", "U"}]]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
        "79777941814291672401518892224505807820921910393015244140625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{
        "79777941814291672401518892224505807820921910393015244140625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"]}], "-", 
        RowBox[{
        "319111767257166689606075568898023231283687641572060976562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["T"]}], "-", 
        RowBox[{
        "212741178171444459737383712598682154189125094381373984375000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{
        "85096471268577783894953485039472861675650037752549593750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{
        "24313277505307938255700995725563674764471439357871312500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{
        "5402950556735097390155776827903038836549208746193625000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{
        "982354646679108616391959423255097970281674317489750000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{
        "151131484104478248675686065116168918504872971921500000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{
        "20150864547263766490091475348822522467316396256200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{
        "2370689946736913704716644158685002643213693677200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"249546310182833021549120437756316067706704597600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{
        "23766315255507906814201946452982482638733771200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"2066636109174600592539299691563694142498588800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"165330888733968047403143975325095531399887104000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"12246732498812447955788442616673743066658304000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"844602241297410203847478801149913314941952000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"54490467180478077667579277493542794512384000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"3302452556392610767732077423851078455296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"188711574651006329584690138505775911731200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"10200625656811152950523791270582481715200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"523109008041597587206348270286281113600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"25517512587395004253968208306647859200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]]}], "-", 
        RowBox[{"1186861050576511825765963177053388800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]]}], "-", 
        RowBox[{"52749380025622747811820585646817280000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]]}], "-", 
        RowBox[{"2244654469175436077098748325396480000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]]}], "-", 
        RowBox[{"91618549762262697024438707159040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]]}], "-", 
        RowBox[{"3592884304402458706840733614080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]]}], "-", 
        RowBox[{"135580539788772026673235230720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]]}], "-", 
        RowBox[{"4930201446864437333572190208000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]]}], "-", 
        RowBox[{"172989524451383766090252288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]]}], "-", 
        RowBox[{"5864051676318093765771264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]]}], "-", 
        RowBox[{"192263989387478484123648000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]]}], "-", 
        RowBox[{"6103618710713602670592000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]]}], "-", 
        RowBox[{"187803652637341620633600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]]}], "-", 
        RowBox[{"5606079183204227481600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]]}], "-", 
        RowBox[{"162495048788528332800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]]}], "-", 
        RowBox[{"4577325317986713600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]]}], "-", 
        RowBox[{"125406173095526400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]]}], "-", 
        RowBox[{"3344164615880704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"75", "/", "2"}]]}], "-", 
        RowBox[{"86861418594304", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"77", "/", "2"}]]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"79", "/", "2"}]]}], "+", 
        RowBox[{
        "319111767257166689606075568898023231283687641572060976562500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "-", 
        RowBox[{
        "159555883628583344803037784449011615641843820786030488281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{
        "159555883628583344803037784449011615641843820786030488281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"]}], "+", 
        RowBox[{
        "157536188899107606261227179582568430633719215459625039062500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{
        "157536188899107606261227179582568430633719215459625039062500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U"}], "-", 
        RowBox[{
        "204662399253541505570141293132909414156626673075752187500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "79710618656642481116791872062291034987317756882135062500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "22158936460533817144436350534690944089138527009705500000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "4787424543942491358365878201939401500739805218146250000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "845571088280751720438648617485400784546251311257000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "126261746213867903956902282248951248371159698061000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "16324751025631405764124739523096727062129738739200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "1860541477185932274587746048588229922522139341600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"189528843176835206239838307156695747625345264000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{
        "17448687149613399939540669547759291051222262400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1464957241946552318762035224399580657973683200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"113010987235876893161642717310824793615112704000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"8061140378965155616468341975532084043876352000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"534558380567981141675619494398679313254400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"33108131957758832000554497717595621982208000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1922947058152659434375640018951260872704000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"105105180818282006350966659420938482483200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"5423117437798334480025306751448914329600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"264865320527391183395619377360142336000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"12274246561025445084187239438640742400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"540848073680435768703476890809139200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"22702264821154093994960758379642880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"909227126754607018571644891299840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"34791854340099758363710901452800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1273427348395808149260006850560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"44621443474785730297520455680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1497782718034765772224462848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"48174297948486618404880384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1484570044637492092600320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"43806984923729274863616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"1236175941410349907968000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"33281659961047882137600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"851556331625958604800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"20568993517535232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"463526614479667200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"9524519475609600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"169324790677504", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"75", "/", "2"}]], " ", "U"}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"77", "/", "2"}]], " ", "U"}], "+", 
        RowBox[{
        "204662399253541505570141293132909414156626673075752187500000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "-", 
        RowBox[{
        "102331199626770752785070646566454707078313336537876093750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{
        "102331199626770752785070646566454707078313336537876093750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]]}], "+", 
        RowBox[{
        "49172134885591140948670310687776937167501213661057343750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "49172134885591140948670310687776937167501213661057343750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "37267302229079601561097498626525678695369340879959250000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "10072243845697189611107432061223156404153875913502500000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "2113927720701879301096621543713501961365628278142500000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "362387609263179308759420836065171764805536276253000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "52472414010958089956115234181382336985417017376000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "6572302360968488034907362665142838167870414297600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"724886289812700886203017941008401268515119224000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{
        "71380992884782090661757284513560736118636528000000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6344977145313963614378425290094287654989913600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"513686305617622241643830533231021789159603200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"38159554131594795093541696754304475766141952000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2617253369793881693658552589458468845414400000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"166615599138072044158634647604783162572800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"9889442013356534233931862954606484488192000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"549413445186474124107325719700360249344000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"28665049314076910822990907114801404313600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1408601931895671293513066688688029696000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"65356377792473149149568417790164992000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2869304390889065084615198829812121600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"119408016267109195687780612256563200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4717353729070980570381456286679040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"177122167549598769851619134668800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6325791698199956066129254809600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"214994227651240336888053104640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6953991190875698228185006080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"213968959719252253174923264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"6256402330972288104529920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"173521174048538036797440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"4551375057010833752064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"112379631037304537088000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2593376100860873932800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"55295865689997312000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"1068519143768064000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"18059478486220800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"247390116249600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"75", "/", "2"}]], " ", 
         SuperscriptBox["U", "2"]}], "+", 
        RowBox[{
        "37267302229079601561097498626525678695369340879959250000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "-", 
        RowBox[{
        "18633651114539800780548749313262839347684670439979625000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
        "18633651114539800780548749313262839347684670439979625000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]]}], "+", 
        RowBox[{
        "5797135902301271353948499786348438908168564136882550000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "5797135902301271353948499786348438908168564136882550000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "3044055917810706193579135022947442824366504720525200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "620085464739217928321675652822627242000584294921800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "103079142190415447824901926702982190878019207467520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "14459065194130673676796197863314243969314911454720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "1752613962924930142641963377371423511432110479360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"186859576929496228443444624793276771439452955520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{
        "17765936006879098120259590812264005433971758080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1522794514875351267450822069622629037197579264000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"118718612853850473624351945457836146827997184000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"8479900918132176687453710389845439059142656000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"558347385556028094647157885751140020355072000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"34063633601561395694654194621422335459328000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1933935327056388916857786533345268077690880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"102557176434808503166700801010733913210880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5096008766947006368531716820409138544640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"237897215164602262904429040756200570880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"10457020446795703863930946846426398720000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"433583774623236501675185600949387264000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"16982473424655530053373242632044544000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"628980497209464076050860838223872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"22041869739505624692645936758784000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"730980374014217145419380555776000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"22932717616132302601392331161600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"679945805330068271200311705600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"19019463086155755837770956800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"500512186477783048362393600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"12339283487896038172262400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"283196670214007433461760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"5993580321989575311360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"115261160038261063680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"1966075224533237760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"28493843833815040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"321057395310592", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"73", "/", "2"}]], " ", 
         SuperscriptBox["U", "3"]}], "+", 
        RowBox[{
        "3044055917810706193579135022947442824366504720525200000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "-", 
        RowBox[{
        "1522027958905353096789567511473721412183252360262600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{
        "1522027958905353096789567511473721412183252360262600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]]}], "+", 
        RowBox[{
        "344020018108744193109970738894745250698954300607300000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "344020018108744193109970738894745250698954300607300000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "135909142956540915796531649933726518794648612585600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "21886667177416978647753148820496218611086270078720000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "2971040793314521988382780382872789856708543449600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"348121951539883384497376287286104670078980848640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{
        "35836083246752701345318147220628421919895087360000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3285481316340655131828828437884439361076968960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"271182584840815979135077902809509280596829184000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"20328529598262067401430127646889751169177600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1393956315309398907526637324358154365886464000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"87958834710881138197839940906001510055936000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"5132876296125689762208166312817064247296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"278168779919069638726119980823634449530880000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"14048928278740890844753534385032042905600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"663179223095843294534949449231326248960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"29329793650430415974518648860353495040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1217598271202239491005658194446909440000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"47516030095697150868513490515001344000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1744774666916664046579442736168960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"60313198362551349758301724213248000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1962632237079267952084912177152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"60080578686100039349538127872000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1727807491626406360378874265600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"46571630502059470630158336000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"1172432655995902757122867200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"27425325286453865663692800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"591609482296385391820800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"11638219323863319183360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"205259600068136140800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"3157840001048248320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"40398805983559680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"390326627860480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"71", "/", "2"}]], " ", 
         SuperscriptBox["U", "4"]}], "+", 
        RowBox[{
        "135909142956540915796531649933726518794648612585600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "-", 
        RowBox[{
        "67954571478270457898265824966863259397324306292800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{
        "67954571478270457898265824966863259397324306292800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]]}], "+", 
        RowBox[{
        "11868122342683854618852059571677526993335512648320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{
        "11868122342683854618852059571677526993335512648320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{
        "3699155015901461179901940645717670751169510435840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"485409481724626127679440175229920596307311324160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{
        "54915012073897097272825555177526370491332190208000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"5451122522041255979287830844827985306124886528000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"481253601266800188324222757098565765566203904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"38194730259269856216208155325282997267159040000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2748646255539659817658158104368191707381760000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"180625325364034788017536104001338312199372800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"10901940076841605861140725070039623781580800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"607269871654306957782374606023427319398400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"31342961117641649433929011923789797130240000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1503828942513109442536998046848500367360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"67251977553381291840163887809373929472000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2809050659477842656714462144371884032000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"109755337122455390738538203443101696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4015439163016660636775787930845184000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"137616030066666460011899708768256000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4417304668806577728777027688857600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"132684996309584312253627865497600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"3723303467870988354055883980800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"97341267133882048472049254400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2361378447991747806599577600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"52842035199815335532298240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"1081562123972828505047040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"19998067007201759723520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"327837164052487864320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"4625568452239687680", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"53371943679688704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"455197813899264", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"69", "/", "2"}]], " ", 
         SuperscriptBox["U", "5"]}], "+", 
        RowBox[{
        "3699155015901461179901940645717670751169510435840000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "-", 
        RowBox[{
        "1849577507950730589950970322858835375584755217920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{
        "1849577507950730589950970322858835375584755217920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]]}], "+", 
        RowBox[{"259119554253967087481053813347373071941825610240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"259119554253967087481053813347373071941825610240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{
        "65659253566616094565334902929651095152679792640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7162827661812664861672898501416483107565068288000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"684682055908563552954027062635399120576072704000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"58122415611932389894229801581952387145676800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4428374522813896372893699168148753306337280000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"305405139504406646406462011596465745264640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"19196894483134132059834755014634989702348800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1105993920839003493159203992612715456102400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"58673417551140768867862280775210369024000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2876890150894644150940344089623218094080000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"130767734131574734133652004073782640640000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"5523109267668994982042444892557279232000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"217124688655292186026238619854831616000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7953285298728651502792623437905920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"271575595566344197656333483245568000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"8642552612882434686737662869504000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"256075632974294361088523344281600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"7050893523697717076279741644800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"179869732747390741741830144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"4232229005820958629219532800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"91261002820937113298534400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"1786928726563803617034240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"31349626781821116088320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"483045096792313036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"6335017662850007040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"67037223945502720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"515670953426944", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"67", "/", "2"}]], " ", 
         SuperscriptBox["U", "6"]}], "+", 
        RowBox[{
        "65659253566616094565334902929651095152679792640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "-", 
        RowBox[{
        "32829626783308047282667451464825547576339896320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{
        "32829626783308047282667451464825547576339896320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]]}], "+", 
        RowBox[{"3779957028355297554933992279532152599408005120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"3779957028355297554933992279532152599408005120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"794172789795860496390172115295644182501883904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"72993822591531295624096701773496707950540800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"5948562791839562291946760076617728321945600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"434339505435904548300874545276850004459520000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"28652081318110644865425007484529835376640000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"1719124879086638691925500449071790122598400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"94327839730405415194814839455242256384000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"4753922957235286176927007824004251648000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"220827388981252003057254556986003947520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"9479963668387080939326584517075927040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"376843276258865329265156154716061696000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"13888572835093316803384133466193920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"474823002909173224047320802263040000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"15055363506876224177110171779072000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"442262820275433757956724752384000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"12012076600073509475367832780800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"300677762204593478732611584000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"6903315968983013542330368000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"144383079089840806114099200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2724209039430958605926400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"45720990871568536043520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"668435539058019532800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"8239575211809177600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"81045002083368960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"571746046443520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"65", "/", "2"}]], " ", 
         SuperscriptBox["U", "7"]}], "+", 
        RowBox[{"794172789795860496390172115295644182501883904000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "-", 
        RowBox[{"397086394897930248195086057647822091250941952000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"397086394897930248195086057647822091250941952000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]]}], "+", 
        RowBox[{"38181384124800985403373659389213662620282880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"38181384124800985403373659389213662620282880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6737891316141350365301234009861234580049920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"526219016201192048902982622162337505402880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"36751804306115000240843230754195000377344000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2314206568001244392976635219904332857344000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"132240375314356822455807726851676163276800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"6893188287991164956544161344806164889600000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"329117743193212119941100541661832806400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"14438713894928015584512797956777181184000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"583382379593051134727789816435441664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"21740958245703768996066701233618944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"747846229581947827874530263564288000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"23741150145458661202366040113152000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"694862931086594962020469466726400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"18711119319345274375092201062400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"462002946156673441360301260800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"10408076384005158879205785600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"212409722122554262840934400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"3887236744726483241533440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"62866362448406737059840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"879249824453241077760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"10283623677815685120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"95072021674721280", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"623423092948992", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"63", "/", "2"}]], " ", 
         SuperscriptBox["U", "8"]}], "+", 
        RowBox[{"6737891316141350365301234009861234580049920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "-", 
        RowBox[{"3368945658070675182650617004930617290024960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"3368945658070675182650617004930617290024960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]]}], "+", 
        RowBox[{"273318342630072413407281097401778475028480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"273318342630072413407281097401778475028480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"40835338117905555823159145282438889308160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2722355874527037054877276352162592620544000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"163259722610317064760256452903303905280000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"8862670655988640658413921729036497715200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"437662748443883489304391196495629516800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"19735455500122067156961937242508492800000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"814883323876007934222944505497124864000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"30866792571060906599353958541557760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1073627567689075012151442036228096000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"34292772432329177292306502385664000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1004916408273382484756234502144000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"26961171929285871542240437862400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"660004208795247773371858944000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"14666760195449950519374643200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"293702331823778733804748800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"5244684496853191675084800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"82269560734952026275840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"1108754187802587955200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"12405641262126858240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"108821414580060160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"670702092943360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"61", "/", "2"}]], " ", 
         SuperscriptBox["U", "9"]}], "+", 
        RowBox[{"40835338117905555823159145282438889308160000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "-", 
        RowBox[{"20417669058952777911579572641219444654080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"20417669058952777911579572641219444654080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]]}], "+", 
        RowBox[{"1405806722091830610305478772018387992576000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1405806722091830610305478772018387992576000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"178515139313248331467362383748366729216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"10170277801954177804737287230041882624000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"523042858386214858529346200402153963520000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"24394317126380391207130001116149841920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1035302583612960900037347527475855360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"40076229043082357420800549450678272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1416836380310992434068706293710848000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"45761175016255656255635234331033600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1349223833403115172156321405337600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"36242886855761335515798621388800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"883972850140520378434112716800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"19475534030023704788022067200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"384701906765900341491793920", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"6740709254971970939781120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"103174121249570983772160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"1348681323523803709440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"14541038528558530560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"122022700938952704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"713583046426624", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"59", "/", "2"}]], " ", 
         SuperscriptBox["U", "10"]}], "+", 
        RowBox[{"178515139313248331467362383748366729216000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "-", 
        RowBox[{"89257569656624165733681191874183364608000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"89257569656624165733681191874183364608000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]]}], "+", 
        RowBox[{"5226175110865513556055293206808887296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"5226175110865513556055293206808887296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"564144839553698614746598367151783936000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"27401320778322504144834777833086648320000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1202801460776845175081910686774722560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"47856822046824078584160902656819200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1729020667498160258524522934697984000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"56760779488575968082875752906752000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1692246841895432588806233627033600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"45736401132308988886654962892800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1116884032535018043630157824000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"24516966567841859494320537600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"480136432173157591076044800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"8298654383239760833413120", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"124635610261423191490560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"1589739926803867238400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"16624731260694036480", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"134431789170032640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"752065953398784", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"57", "/", "2"}]], " ", 
         SuperscriptBox["U", "11"]}], "+", 
        RowBox[{"564144839553698614746598367151783936000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "-", 
        RowBox[{"282072419776849307373299183575891968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"282072419776849307373299183575891968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]]}], "+", 
        RowBox[{"14021143673118240424988555908743168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"14021143673118240424988555908743168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1281933135827953410284667968799375360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"52754450034072156801838188016435200000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1959051194899231287070914143846400000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"65723007828877436727540345470976000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1991606297844770809925465014272000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"54428991990788767476223888588800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1337321670535350552241373184000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"29391685066711001148162048000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"573496293984604900451942400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"9827353874889190460620800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"145590427776136154972160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"1822158044757648998400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"18593449436302540800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"145830975971000320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"786150813859840", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"55", "/", "2"}]], " ", 
         SuperscriptBox["U", "12"]}], "+", 
        RowBox[{"1281933135827953410284667968799375360000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "-", 
        RowBox[{"640966567913976705142333984399687680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"640966567913976705142333984399687680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]]}], "+", 
        RowBox[{"26893702150236784831146880464322560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"26893702150236784831146880464322560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"2065908532802825720911145824419840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"71238225269062955893487787048960000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"2206086976074207666378976631193600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"61280193779839101843860461977600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"1522489286455629859474794086400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"33666839258232601315167436800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"657716029464861564154675200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"11229298064034221827031040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"164934610487650748989440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"2036229759106799370240", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"20387782318966702080", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"156028946318622720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"815837627809792", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"53", "/", "2"}]], " ", 
         SuperscriptBox["U", "13"]}], "+", 
        RowBox[{"2065908532802825720911145824419840000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "-", 
        RowBox[{"1032954266401412860455572912209920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"1032954266401412860455572912209920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]]}], "+", 
        RowBox[{"36195162973634412900060506357760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"36195162973634412900060506357760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"2304201356411739813266451333120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"65409586891688097924983134617600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"1651757244739598432449069056000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"36933702366848163706935705600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"725969579692347198170726400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"12409736404997388002918400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"181605898609717873213440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"2222838416275616563200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"21953959666919669760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"164860773468733440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"841126395248640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"51", "/", "2"}]], " ", 
         SuperscriptBox["U", "14"]}], "+", 
        RowBox[{"2304201356411739813266451333120000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "-", 
        RowBox[{"1152100678205869906633225666560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"1152100678205869906633225666560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]]}], "+", 
        RowBox[{"33132307085659003850890149888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"33132307085659003850890149888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"1710054559259819553594330316800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"38864876346814080763507507200", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"772469591986366822628720640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"13285717798291321273712640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"194662531843096282398720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"2373933315159710760960", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"23245369059091415040", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"172187918956232704", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"862017116176384", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"49", "/", "2"}]], " ", 
         SuperscriptBox["U", "15"]}], "+", 
        RowBox[{"1710054559259819553594330316800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "-", 
        RowBox[{"855027279629909776797165158400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"855027279629909776797165158400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]]}], "+", 
        RowBox[{"19630728358849969365241036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"19630728358849969365241036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"793160741771715933949132800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"13794099856899407546941440", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"203352823443234509291520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"2482940457182350540800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"24223809338364395520", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"177898232595087360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"878509790593024", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"47", "/", "2"}]], " ", 
         SuperscriptBox["U", "16"]}], "+", 
        RowBox[{"793160741771715933949132800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "-", 
        RowBox[{"396580370885857966974566400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"396580370885857966974566400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]]}], "+", 
        RowBox[{"6948842543682117068390400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"6948842543682117068390400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"207170460929653179678720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"2545091657612446924800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"24860480172038553600", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"181905952478330880", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"890604418498560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"45", "/", "2"}]], " ", 
         SuperscriptBox["U", "17"]}], "+", 
        RowBox[{"207170460929653179678720", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "-", 
        RowBox[{"103585230464826589839360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"103585230464826589839360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]]}], "+", 
        RowBox[{"1278830005738599874560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"1278830005738599874560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"25136707729505648640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"184151704978063360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"898300999892992", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"43", "/", "2"}]], " ", 
         SuperscriptBox["U", "18"]}], "+", 
        RowBox[{"25136707729505648640", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "-", 
        RowBox[{"12568353864752824320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"12568353864752824320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]]}], "+", 
        RowBox[{"92301252372725760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"]}], "-", 
        RowBox[{"92301252372725760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"]}], "-", 
        RowBox[{"901599534776320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", "19"]}], "-", 
        RowBox[{"2199023255552", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SuperscriptBox["T", 
          RowBox[{"41", "/", "2"}]], " ", 
         SuperscriptBox["U", "19"]}], "+", 
        RowBox[{"901599534776320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"2", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]]}], "-", 
        RowBox[{"450799767388160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]]}], "+", 
        RowBox[{"450799767388160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]]}], "+", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "20"], " ", 
         SuperscriptBox["U", "20"]}], "-", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "20"], " ", 
         SuperscriptBox["U", "20"]}], "+", 
        RowBox[{
        "79777941814291672401518892224505807820921910393015244140625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "159555883628583344803037784449011615641843820786030488281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "157536188899107606261227179582568430633719215459625039062500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "102331199626770752785070646566454707078313336537876093750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "49172134885591140948670310687776937167501213661057343750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "18633651114539800780548749313262839347684670439979625000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "5797135902301271353948499786348438908168564136882550000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "1522027958905353096789567511473721412183252360262600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "344020018108744193109970738894745250698954300607300000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "67954571478270457898265824966863259397324306292800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "11868122342683854618852059571677526993335512648320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "1849577507950730589950970322858835375584755217920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"259119554253967087481053813347373071941825610240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "32829626783308047282667451464825547576339896320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3779957028355297554933992279532152599408005120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"397086394897930248195086057647822091250941952000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"38181384124800985403373659389213662620282880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3368945658070675182650617004930617290024960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"273318342630072413407281097401778475028480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"20417669058952777911579572641219444654080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1405806722091830610305478772018387992576000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"89257569656624165733681191874183364608000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5226175110865513556055293206808887296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"282072419776849307373299183575891968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"14021143673118240424988555908743168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"640966567913976705142333984399687680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"26893702150236784831146880464322560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1032954266401412860455572912209920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"36195162973634412900060506357760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1152100678205869906633225666560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"33132307085659003850890149888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"855027279629909776797165158400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"19630728358849969365241036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"396580370885857966974566400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6948842543682117068390400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"103585230464826589839360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1278830005738599874560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"12568353864752824320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"92301252372725760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"450799767388160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "20"], " ", 
         SuperscriptBox["U", "20"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "-", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "79777941814291672401518892224505807820921910393015244140625", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "159555883628583344803037784449011615641843820786030488281250", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SqrtBox["T"], " ", 
         SqrtBox["U"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "157536188899107606261227179582568430633719215459625039062500", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", "T", " ", "U", " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "102331199626770752785070646566454707078313336537876093750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"3", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "49172134885591140948670310687776937167501213661057343750000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "2"], " ", 
         SuperscriptBox["U", "2"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "18633651114539800780548749313262839347684670439979625000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"5", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"5", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "5797135902301271353948499786348438908168564136882550000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "3"], " ", 
         SuperscriptBox["U", "3"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "1522027958905353096789567511473721412183252360262600000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"7", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"7", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "344020018108744193109970738894745250698954300607300000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "4"], " ", 
         SuperscriptBox["U", "4"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "67954571478270457898265824966863259397324306292800000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"9", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"9", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{
        "11868122342683854618852059571677526993335512648320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "5"], " ", 
         SuperscriptBox["U", "5"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "1849577507950730589950970322858835375584755217920000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"11", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"11", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"259119554253967087481053813347373071941825610240000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "6"], " ", 
         SuperscriptBox["U", "6"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{
        "32829626783308047282667451464825547576339896320000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"13", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"13", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"3779957028355297554933992279532152599408005120000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "7"], " ", 
         SuperscriptBox["U", "7"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"397086394897930248195086057647822091250941952000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"15", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"15", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"38181384124800985403373659389213662620282880000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "8"], " ", 
         SuperscriptBox["U", "8"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"3368945658070675182650617004930617290024960000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"17", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"17", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"273318342630072413407281097401778475028480000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "9"], " ", 
         SuperscriptBox["U", "9"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"20417669058952777911579572641219444654080000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"19", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"19", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1405806722091830610305478772018387992576000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "10"], " ", 
         SuperscriptBox["U", "10"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"89257569656624165733681191874183364608000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"21", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"21", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"5226175110865513556055293206808887296000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "11"], " ", 
         SuperscriptBox["U", "11"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"282072419776849307373299183575891968000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"23", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"23", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"14021143673118240424988555908743168000000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "12"], " ", 
         SuperscriptBox["U", "12"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"640966567913976705142333984399687680000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"25", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"25", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"26893702150236784831146880464322560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "13"], " ", 
         SuperscriptBox["U", "13"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1032954266401412860455572912209920000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"27", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"27", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"36195162973634412900060506357760000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "14"], " ", 
         SuperscriptBox["U", "14"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"1152100678205869906633225666560000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"29", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"29", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"33132307085659003850890149888000", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "15"], " ", 
         SuperscriptBox["U", "15"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"855027279629909776797165158400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"31", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"31", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"19630728358849969365241036800", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "16"], " ", 
         SuperscriptBox["U", "16"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"396580370885857966974566400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"33", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"33", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"6948842543682117068390400", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "17"], " ", 
         SuperscriptBox["U", "17"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"103585230464826589839360", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"35", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"35", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1278830005738599874560", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "18"], " ", 
         SuperscriptBox["U", "18"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"12568353864752824320", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"37", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"37", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"92301252372725760", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "19"], " ", 
         SuperscriptBox["U", "19"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "-", 
        RowBox[{"450799767388160", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", 
          RowBox[{"39", "/", "2"}]], " ", 
         SuperscriptBox["U", 
          RowBox[{"39", "/", "2"}]], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}], "+", 
        RowBox[{"1099511627776", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"T", "+", 
           RowBox[{"4", " ", 
            SqrtBox["T"], " ", 
            SqrtBox["U"]}], "+", "U", "+", 
           RowBox[{"2", " ", 
            SqrtBox[
             RowBox[{"T", " ", "U"}]]}]}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         SuperscriptBox["T", "20"], " ", 
         SuperscriptBox["U", "20"], " ", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox["T"], "+", 
           SqrtBox["U"]}], "]"}]}]}], ")"}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.917364974835726*^9, 3.9173649866382227`*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"4850b16f-1c9d-422f-846f-d775b843b59a"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interpolate", "Section",
 CellChangeTimes->{{3.631785592207478*^9, 3.631785605336968*^9}, {
  3.7431522982904387`*^9, 
  3.743152362020149*^9}},ExpressionUUID->"7b1fb80d-9d07-4632-9327-\
1d84f97ddc75"],

Cell[CellGroupData[{

Cell["basic formulas", "Subsection",
 CellChangeTimes->{{3.631785592207478*^9, 3.631785605336968*^9}, {
  3.7431522982904387`*^9, 3.743152362020149*^9}, {3.743152769742394*^9, 
  3.743152781571897*^9}},ExpressionUUID->"32fe1c87-ee80-4124-9946-\
b0e6f3d7ecdd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "roots", " ", "of", " ", "Chebyshev", " ", "polynomial", " ", "on", " ", 
    RowBox[{"interval", " ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "/", "2"}], ",", 
      RowBox[{"1", "/", "2"}]}], "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"chebnodes", "[", "n_", "]"}], ":=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "k"}], "-", "1"}], ")"}], 
          RowBox[{"\[Pi]", "/", 
           RowBox[{"(", 
            RowBox[{"2", "n"}], ")"}]}]}], "]"}], "/", "2"}], " ", ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "1", ",", "n"}], "}"}]}], "]"}]}], ";"}], " ", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{" ", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"To", " ", "compute", " ", 
         RowBox[{"Gm", "[", 
          RowBox[{"T", ",", "U"}], "]"}], " ", "on", " ", 
         RowBox[{"{", 
          RowBox[{"T", ",", "U"}], "}"}]}], "\[Element]", 
        RowBox[{
         RowBox[{"[", 
          RowBox[{"0", ",", "Tmax"}], "]"}], 
         RowBox[{"x", "[", 
          RowBox[{"Umin", ",", "Umax"}], "]"}], " ", "map", " ", "T", " ", 
         "and", " ", "U", " ", 
         RowBox[{"onto", " ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "1"}], "/", "2"}], ",", 
           RowBox[{"1", "/", "2"}]}], "]"}], " ", "as", " ", 
         RowBox[{"follows", ":", "\[IndentingNewLine]", "x1"}]}]}], "=", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Log2", "[", "T", "]"}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"b1", "+", "a1"}], ")"}], "/", "2"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"b1", "-", "a1"}], ")"}]}], " ", "for", " ", "T"}], 
        "\[Element]", 
        RowBox[{
         RowBox[{
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", "^", "a1"}], ",", 
            RowBox[{"2", "^", 
             RowBox[{"(", 
              RowBox[{"a1", "+", "1"}], ")"}]}]}], "]"}], " ", "for", " ", 
          "a"}], ">=", "1"}]}]}], ",", " ", 
      RowBox[{"x1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"T", "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"b1", "+", "a1"}], ")"}], "/", "2"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"b1", "-", "a1"}], ")"}]}], " ", "for", " ", "T"}], 
        "\[Element]", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"a1", "=", "0"}], ",", 
          RowBox[{"b1", "=", "2"}]}], "]"}]}]}], ",", "\[IndentingNewLine]", 
      "     ", 
      RowBox[{"x2", "=", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Log10", "[", "U", "]"}], "-", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"b2", "+", "a2"}], ")"}], "/", "2"}]}], ")"}], "/", 
           RowBox[{"(", 
            RowBox[{"b2", "-", "a2"}], ")"}]}], " ", "for", " ", "U"}], 
         "\[Element]", 
         RowBox[{
          RowBox[{"[", 
           RowBox[{
            RowBox[{"10", "^", "a2"}], ",", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"a2", "+", "1"}], ")"}]}]}], "]"}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "these", " ", 
          "functions", " ", "define", " ", "the", " ", "x1"}]}], "->", 
        "T"}]}], ",", " ", 
      RowBox[{"x2", "->", 
       RowBox[{"U", " ", "maps"}]}]}], "\[IndentingNewLine]", "]"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"x2T", "[", 
      RowBox[{"x_", ",", "a_Integer"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "b", "}"}], ",", 
       RowBox[{
        RowBox[{"b", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"a", "==", "0"}], ",", "2", ",", 
           RowBox[{"a", "+", "1"}]}], "]"}]}], ";", 
        RowBox[{"Return", "[", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"a", "==", "0"}], ",", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"b", "-", "a"}], ")"}], "x"}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"b", "+", "a"}], ")"}], "/", "2"}]}], ")"}], ",", 
           RowBox[{"2", "^", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"b", "-", "a"}], ")"}], "x"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"b", "+", "a"}], ")"}], "/", "2"}]}], ")"}]}]}], 
          "]"}], "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"x2U", "[", 
      RowBox[{"x_", ",", "a_Integer"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "b", "}"}], ",", 
       RowBox[{
        RowBox[{"b", "=", 
         RowBox[{"a", "+", "1"}]}], ";", 
        RowBox[{"Return", "[", 
         RowBox[{"10", "^", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"b", "-", "a"}], ")"}], "x"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"b", "+", "a"}], ")"}], "/", "2"}]}], ")"}]}], 
         "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "coefficients", " ", "of", " ", "the", " ", "interpolating", " ", 
     "polynomial", " ", "product", " ", "P_", 
     RowBox[{
      RowBox[{"{", "n1", "}"}], "[", "x1", "]"}], " ", "P_", 
     RowBox[{
      RowBox[{"{", "n2", "}"}], "[", "x2", "]"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"chebcoeffs", "[", 
      RowBox[{
      "a1_Integer", ",", "a2_Integer", ",", "n_Integer", ",", "m_Integer"}], 
      "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "x", ",", "f", ",", "A1", ",", "A2", ",", "A", ",", "c", ",", "cc", 
         ",", "nnodes", ",", "y1", ",", "y2", ",", "t"}], "}"}], ",", 
       RowBox[{"(*", " ", 
        RowBox[{"WARNING", ":", " ", 
         RowBox[{
         "cannot", " ", "define", " ", "T", " ", "and", " ", "U", " ", "as", 
          " ", "local", " ", "to", " ", "be", " ", "able", " ", "to", " ", 
          "use", " ", "them", " ", "for", " ", "replacements"}]}], " ", 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nnodes", "=", 
         RowBox[{"n", "+", "1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"x", "=", 
         RowBox[{"chebnodes", "[", "nnodes", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"t", ",", "f"}], "}"}], "=", 
         RowBox[{"Timing", "[", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Block", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"$MaxExtraPrecision", "=", "tprecmax"}], "}"}], ",", 
              RowBox[{"N", "[", 
               RowBox[{
                RowBox[{"Limit", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"GmTable", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", "+", "2"}], "]"}], "]"}], "/.", 
                   RowBox[{"U", "->", 
                    RowBox[{"x2U", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "k2", "]"}], "]"}], ",", "a2"}], "]"}]}]}], 
                  ",", 
                  RowBox[{"T", "->", 
                   RowBox[{"x2T", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "k1", "]"}], "]"}], ",", "a1"}], "]"}]}]}], 
                 "]"}], ",", "tprec"}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"k1", ",", "1", ",", "nnodes"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"k2", ",", "1", ",", "nnodes"}], "}"}]}], "]"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"printDebug", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<evaluated G[m=\>\"", ",", "m", ",", "\"\<] in \>\"", ",", "t",
             ",", "\"\< s\>\""}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"f", "=", 
         RowBox[{"Flatten", "[", "f", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "evaluate", " ", "Chebyshev", " ", "polynomials", " ", "at", " ", 
          "the", " ", "nodes"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"A1", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ChebyshevT", "[", 
            RowBox[{"ord1", ",", 
             RowBox[{"x", "[", 
              RowBox[{"[", "k1", "]"}], "]"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"k1", ",", "1", ",", "nnodes"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"ord1", ",", "0", ",", "n"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"A", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", 
             RowBox[{"nnodes", "^", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"ord", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"n", "+", "1"}], ")"}], "^", "2"}]}], "}"}]}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"A", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"k1", "-", "1"}], ")"}], "*", "nnodes"}], "+", 
               "k2"}], ",", 
              RowBox[{
               RowBox[{"ord1", "*", 
                RowBox[{"(", 
                 RowBox[{"n", "+", "1"}], ")"}]}], "+", "ord2", "+", "1"}]}], 
             "]"}], "]"}], "=", 
           RowBox[{
            RowBox[{"A1", "[", 
             RowBox[{"[", 
              RowBox[{"k1", ",", 
               RowBox[{"ord1", "+", "1"}]}], "]"}], "]"}], 
            RowBox[{"A1", "[", 
             RowBox[{"[", 
              RowBox[{"k2", ",", 
               RowBox[{"ord2", "+", "1"}]}], "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"k1", ",", "1", ",", "nnodes"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k2", ",", "1", ",", "nnodes"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ord1", ",", "0", ",", "n"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ord2", ",", "0", ",", "n"}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"t", ",", "cc"}], "}"}], "=", 
         RowBox[{"Timing", "[", 
          RowBox[{"LinearSolve", "[", 
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{"A", ",", "$MachinePrecision"}], "]"}], ",", "f"}], 
           "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"printDebug", ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<linsolve in \>\"", ",", "t", ",", "\"\< s\>\""}], 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"c", "=", 
         RowBox[{"CoefficientList", "[", 
          RowBox[{
           RowBox[{"Sum", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"cc", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"ord1", "*", 
                  RowBox[{"(", 
                   RowBox[{"n", "+", "1"}], ")"}]}], "+", "ord2", "+", "1"}], 
                "]"}], "]"}], 
              RowBox[{"ChebyshevT", "[", 
               RowBox[{"ord1", ",", "y1"}], "]"}], 
              RowBox[{"ChebyshevT", "[", 
               RowBox[{"ord2", ",", "y2"}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"ord1", ",", "0", ",", "n"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"ord2", ",", "0", ",", "n"}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"y1", ",", "y2"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", "c", "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Lagrange", " ", "interpolating", " ", "polynomials", " ", "in", " ", 
      "mapped", " ", "coordinates"}], ",", " ", 
     RowBox[{"x1", " ", "and", " ", "x2"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"iPow", "[", 
      RowBox[{"x_", ",", "i_Integer"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "==", "0"}], ",", "1", ",", 
       RowBox[{"x", "^", "i"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Pn", "[", 
      RowBox[{"x1_", ",", "x2_", ",", "c_", ",", "n_Integer"}], "]"}], ":=", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"c", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"i", "+", "1"}], ",", 
           RowBox[{"j", "+", "1"}]}], "]"}], "]"}], 
        RowBox[{"iPow", "[", 
         RowBox[{"x1", ",", "i"}], "]"}], " ", 
        RowBox[{"iPow", "[", 
         RowBox[{"x2", ",", "j"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "n"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "0", ",", "n"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.631724847966943*^9, 3.631724849282702*^9}, {
   3.631725025728188*^9, 3.631725082719846*^9}, {3.631725277124423*^9, 
   3.631725474937468*^9}, {3.631725519887945*^9, 3.631725520539823*^9}, {
   3.631725558869402*^9, 3.63172559377052*^9}, {3.631725631762908*^9, 
   3.631725679180015*^9}, {3.631726301325945*^9, 3.631726306768448*^9}, {
   3.631726511418322*^9, 3.6317265196294527`*^9}, {3.631727105386652*^9, 
   3.631727124427184*^9}, {3.631727160412551*^9, 3.63172716168251*^9}, {
   3.6317288643434467`*^9, 3.631728924278867*^9}, {3.742753354373749*^9, 
   3.7427533651021233`*^9}, {3.742753750440608*^9, 3.742753842082946*^9}, {
   3.7427543757100286`*^9, 3.742754380253879*^9}, {3.7427544314466133`*^9, 
   3.742754688102932*^9}, 3.742755432315812*^9, {3.742755625633939*^9, 
   3.742755645778689*^9}, {3.742755723585278*^9, 3.742755872417356*^9}, {
   3.742755903250635*^9, 3.742755908749509*^9}, {3.7427568524002542`*^9, 
   3.742756884816918*^9}, {3.7427570186889057`*^9, 3.7427571659762287`*^9}, {
   3.742757255063735*^9, 3.74275734442767*^9}, {3.742757383030265*^9, 
   3.742757387860334*^9}, {3.742757476000267*^9, 3.742757476439623*^9}, {
   3.742758285412916*^9, 3.742758306170966*^9}, {3.742758608299591*^9, 
   3.742758635220738*^9}, {3.742760771042169*^9, 3.7427607715568027`*^9}, {
   3.742761649666996*^9, 3.742761659645108*^9}, {3.742761717799102*^9, 
   3.742761718531191*^9}, {3.742761775564724*^9, 3.742761784131337*^9}, {
   3.7427638562939777`*^9, 3.742764185275682*^9}, {3.7427650007312183`*^9, 
   3.742765003922306*^9}, {3.7427650640987043`*^9, 3.7427650753786697`*^9}, {
   3.742765261380588*^9, 3.7427652618591623`*^9}, {3.742765429951522*^9, 
   3.742765490987946*^9}, {3.74276554488976*^9, 3.7427655878971367`*^9}, {
   3.7427656240468597`*^9, 3.742765624765911*^9}, {3.742765791961375*^9, 
   3.742765802409178*^9}, {3.742765958677652*^9, 3.742765977856213*^9}, {
   3.917363788256171*^9, 3.917363859382024*^9}, {3.9173639124721737`*^9, 
   3.917363976439556*^9}, {3.917364012415576*^9, 3.917364014600195*^9}, {
   3.917364053208453*^9, 3.917364062896603*^9}, {3.917364100059535*^9, 
   3.917364371752699*^9}, {3.917364772334914*^9, 3.917364776695718*^9}, {
   3.917365152944417*^9, 3.9173651771808233`*^9}, {3.917365794841916*^9, 
   3.91736588634006*^9}, {3.9173659350568447`*^9, 3.917365936004755*^9}, {
   3.917365977543872*^9, 3.917366010230549*^9}, {3.917366059408124*^9, 
   3.917366131828134*^9}, {3.917366404254436*^9, 3.917366583404024*^9}, {
   3.9173666149155817`*^9, 3.91736668217332*^9}, {3.917366715925776*^9, 
   3.917366858598296*^9}, {3.91736693415876*^9, 3.917367099548869*^9}, {
   3.917367246298929*^9, 3.917367250734868*^9}, {3.9173673048615017`*^9, 
   3.917367332806731*^9}, {3.917367384997861*^9, 3.91736738683956*^9}, {
   3.9173675328092546`*^9, 3.917367555007156*^9}, {3.917367771531518*^9, 
   3.917367802822905*^9}, {3.917367840208617*^9, 3.917367840734269*^9}, 
   3.917367956008398*^9, {3.9173680377248774`*^9, 3.9173680820686913`*^9}, {
   3.91736821340709*^9, 3.917368371423876*^9}, {3.9173684056905527`*^9, 
   3.917368406570125*^9}, {3.917368522943102*^9, 3.9173685318287373`*^9}, {
   3.9173686085336742`*^9, 3.9173686102476482`*^9}, {3.917368748276449*^9, 
   3.9173687805333633`*^9}, 3.917368814658184*^9, {3.917369044549548*^9, 
   3.917369053414958*^9}, {3.9173691097720327`*^9, 3.917369123495871*^9}, {
   3.917369224691555*^9, 3.9173692795338907`*^9}, {3.91736952471766*^9, 
   3.917369574963706*^9}, {3.917392160987195*^9, 3.917392196121152*^9}, {
   3.91739265647861*^9, 3.917392656890435*^9}, {3.917393261356125*^9, 
   3.917393494353611*^9}, {3.917393708071533*^9, 3.9173937265693398`*^9}, {
   3.917393813689145*^9, 3.917393880556202*^9}, {3.917394974536269*^9, 
   3.917394995964864*^9}, {3.917395940754994*^9, 3.917396022787138*^9}, {
   3.9173963456798763`*^9, 3.917396347430027*^9}, 3.9173963840000963`*^9, 
   3.917422810128208*^9, {3.917422897624463*^9, 3.917423288221567*^9}, {
   3.91742338683812*^9, 3.91742343165779*^9}, {3.917423581083187*^9, 
   3.91742358406004*^9}, {3.9174236173573227`*^9, 3.91742361835594*^9}, {
   3.917423675118107*^9, 3.917423750157572*^9}, {3.9174238454192266`*^9, 
   3.917423951391427*^9}, {3.917423997387402*^9, 3.917424000065024*^9}, {
   3.917424226490456*^9, 3.917424232457655*^9}, 3.917424271554844*^9, {
   3.91742431329313*^9, 3.917424339158613*^9}, 3.917424376129965*^9, {
   3.917424753563325*^9, 3.9174247804207706`*^9}, {3.917424858344721*^9, 
   3.917424895205595*^9}, {3.917425526450377*^9, 3.917425527832665*^9}, {
   3.917425573553035*^9, 3.917425616997641*^9}, {3.917425740756913*^9, 
   3.917425756929037*^9}, {3.917427051365293*^9, 3.917427052179639*^9}, 
   3.917427306300949*^9, {3.917428027001644*^9, 3.917428150710391*^9}, {
   3.9174282534007874`*^9, 3.917428262728177*^9}, {3.917428328153927*^9, 
   3.917428340503031*^9}, {3.917433949168846*^9, 3.917433950316862*^9}},
 CellLabel->
  "In[1670]:=",ExpressionUUID->"9e44fe3c-39f7-44f1-b8bb-c35a8eac1dad"]
}, Open  ]],

Cell[CellGroupData[{

Cell["OK, let\[CloseCurlyQuote]s do it", "Subsection",
 CellChangeTimes->{{3.631785592207478*^9, 3.631785605336968*^9}, {
  3.7431522982904387`*^9, 3.743152362020149*^9}, {3.743152769742394*^9, 
  3.743152808820547*^9}},ExpressionUUID->"4cd50976-ce15-4592-949d-\
9b79ee96815a"],

Cell["This will take awhile ... run overnight", "Text",
 CellChangeTimes->{{3.743152374115336*^9, 3.743152426360208*^9}, {
  3.743152598504655*^9, 3.743152601398768*^9}, {3.7431527270104237`*^9, 
  3.7431527353163843`*^9}, {3.74315283427241*^9, 3.743152868517215*^9}, {
  3.9174332387148447`*^9, 
  3.917433240648777*^9}},ExpressionUUID->"ff637b08-7129-465b-9795-\
b90ad336ddbe"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToCString", "[", "x_", "]"}], ":=", 
     RowBox[{"ToString", "[", 
      RowBox[{"CForm", "[", "x", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ofile", "=", 
     RowBox[{"OpenWrite", "[", 
      RowBox[{"\"\<tenno_cheb\>\"", "<>", 
       RowBox[{"ToString", "[", "order", "]"}], "<>", "\"\<.h\>\""}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", "\"\<#ifndef LIBINT2_STATICS_INITIALIZATION\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", 
      RowBox[{"\"\<static constexpr std::size_t interpolation_order=\>\"", "<>", 
       RowBox[{"ToCString", "[", "order", "]"}], "<>", "\"\<;\>\""}]}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", 
      RowBox[{"\"\<static constexpr long cheb_table_tminlog2=\>\"", "<>", 
       RowBox[{"ToString", "[", "TminLog2", "]"}], "<>", "\"\<;\>\""}]}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", 
      RowBox[{"\"\<static constexpr long cheb_table_tmaxlog2=\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"TmaxLog2", "+", "1"}], "]"}], "<>", "\"\<;\>\""}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", 
      RowBox[{"\"\<static constexpr long cheb_table_uminlog10=\>\"", "<>", 
       RowBox[{"ToString", "[", "UminLog10", "]"}], "<>", "\"\<;\>\""}]}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", 
      RowBox[{"\"\<static constexpr long cheb_table_umaxlog10=\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"UmaxLog10", "+", "1"}], "]"}], "<>", "\"\<;\>\""}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", 
      RowBox[{"\"\<static constexpr std::size_t cheb_table_mmax=\>\"", "<>", 
       RowBox[{"ToCString", "[", "mmax", "]"}], "<>", "\"\<;\>\""}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", 
      RowBox[{"\"\<static constexpr std::size_t cheb_table_nintervals=\>\"", "<>", 
       RowBox[{"ToCString", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"TmaxLog2", "-", "TminLog2", "+", "2"}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"UmaxLog10", "-", "UminLog10", "+", "1"}], ")"}]}], "]"}], 
       "<>", "\"\<;\>\""}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", " ", "\"\<#if LIBINT2_CONSTEXPR_STATICS\>\""}], 
     "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", 
      "\"\<static constexpr double \
cheb_table[cheb_table_nintervals][(cheb_table_mmax+2)*(interpolation_order+1)*\
(interpolation_order+1)]=\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", "\"\<#else   // LIBINT2_CONSTEXPR_STATICS\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", 
      "\"\<static double \
cheb_table[cheb_table_nintervals][(cheb_table_mmax+2)*(interpolation_order+1)*\
(interpolation_order+1)];\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", "\"\<#endif   // LIBINT2_CONSTEXPR_STATICS\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", "\"\<#else   // LIBINT2_STATICS_INITIALIZATION\>\""}],
      "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", 
      "\"\<template<> double \
libint2::TennoGmEval<double>::cheb_table[cheb_table_nintervals][(cheb_table_\
mmax+2)*(interpolation_order+1)*(interpolation_order+1)]=\>\""}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", 
      "\"\<#endif   // LIBINT2_STATICS_INITIALIZATION\>\""}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", 
      "\"\<#if defined(LIBINT2_STATICS_INITIALIZATION) || \
LIBINT2_CONSTEXPR_STATICS\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", "\"\<{\>\""}], "]"}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tabmaxabserror", "=", "0"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"tabmaxrelerror", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Do", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"WriteLine", "[", 
        RowBox[{"ofile", ",", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"t", "\[Equal]", 
              RowBox[{"TminLog2", "-", "1"}]}], "&&", 
             RowBox[{"u", "==", "UminLog10"}]}], ",", "\"\<\>\"", ",", 
            "\"\<,\>\""}], "]"}], "<>", "\"\<{\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{"printDebug", ",", 
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<{t,u,m}={\>\"", ",", "t", ",", "\"\<,\>\"", ",", "u", ",", 
              "\"\<,\>\"", ",", "m", ",", "\"\<}\>\""}], "]"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"c", "=", 
           RowBox[{"chebcoeffs", "[", 
            RowBox[{"t", ",", "u", ",", "order", ",", "m"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"testPrec", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"values", "=", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Pn", "[", 
                  RowBox[{
                   RowBox[{"N", "[", 
                    RowBox[{"x1", ",", "$MachinePrecision"}], "]"}], ",", 
                   RowBox[{"N", "[", 
                    RowBox[{"x2", ",", "$MachinePrecision"}], "]"}], ",", 
                   RowBox[{"N", "[", 
                    RowBox[{"c", ",", "$MachinePrecision"}], "]"}], ",", 
                   "order"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"x1", ",", 
                   RowBox[{
                    RowBox[{"-", "1"}], "/", "2"}], ",", 
                   RowBox[{"1", "/", "2"}], ",", 
                   RowBox[{"1", "/", "20"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"x2", ",", 
                   RowBox[{
                    RowBox[{"-", "1"}], "/", "2"}], ",", 
                   RowBox[{"1", "/", "2"}], ",", 
                   RowBox[{"1", "/", "20"}]}], "}"}]}], "]"}], "//", 
               "Flatten"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"refvalues", "=", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Block", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"$MaxExtraPrecision", "=", "tprecmax"}], "}"}], 
                   ",", 
                   RowBox[{"N", "[", 
                    RowBox[{
                    RowBox[{"Limit", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"GmTable", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", "+", "2"}], "]"}], "]"}], "/.", 
                    RowBox[{"U", "->", 
                    RowBox[{"x2U", "[", 
                    RowBox[{"x2", ",", "u"}], "]"}]}]}], ",", 
                    RowBox[{"T", "->", 
                    RowBox[{"x2T", "[", 
                    RowBox[{"x1", ",", "t"}], "]"}]}]}], "]"}], ",", 
                    "tprec"}], "]"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"x1", ",", 
                   RowBox[{
                    RowBox[{"-", "1"}], "/", "2"}], ",", 
                   RowBox[{"1", "/", "2"}], ",", 
                   RowBox[{"1", "/", "20"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"x2", ",", 
                   RowBox[{
                    RowBox[{"-", "1"}], "/", "2"}], ",", 
                   RowBox[{"1", "/", "2"}], ",", 
                   RowBox[{"1", "/", "20"}]}], "}"}]}], "]"}], "//", 
               "Flatten"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"abserror", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"refvalues", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "-", 
                  RowBox[{"values", "[", 
                   RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", 
                  RowBox[{"Length", "[", "refvalues", "]"}]}], "}"}]}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"relerror", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"abserror", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "/", 
                 RowBox[{"Abs", "[", 
                  RowBox[{"refvalues", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", 
                  RowBox[{"Length", "[", "refvalues", "]"}]}], "}"}]}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"maxabserror", "=", 
              RowBox[{"Max", "[", "abserror", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"maxrelerror", "=", 
              RowBox[{"Max", "[", "relerror", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"tabmaxabserror", "=", 
              RowBox[{"Max", "[", 
               RowBox[{"maxabserror", ",", "tabmaxabserror"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"tabmaxrelerror", "=", 
              RowBox[{"Max", "[", 
               RowBox[{"maxrelerror", ",", "tabmaxrelerror"}], "]"}]}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"WriteLine", "[", 
           RowBox[{"ofile", ",", 
            RowBox[{"\"\<// [{\>\"", "<>", 
             RowBox[{"ToCString", "[", 
              RowBox[{"N", "[", 
               RowBox[{
                RowBox[{"x2T", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "1"}], "/", "2"}], ",", "t"}], "]"}], ",", 
                "5"}], "]"}], "]"}], "<>", "\"\<,\>\"", "<>", 
             RowBox[{"ToCString", "[", 
              RowBox[{"N", "[", 
               RowBox[{
                RowBox[{"x2U", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "1"}], "/", "2"}], ",", "u"}], "]"}], ",", 
                "5"}], "]"}], "]"}], "<>", "\"\<},{\>\"", "<>", 
             RowBox[{"ToCString", "[", 
              RowBox[{"N", "[", 
               RowBox[{
                RowBox[{"x2T", "[", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], ",", "t"}], "]"}], ",", "5"}], 
               "]"}], "]"}], "<>", "\"\<,\>\"", "<>", 
             RowBox[{"ToCString", "[", 
              RowBox[{"N", "[", 
               RowBox[{
                RowBox[{"x2U", "[", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], ",", "u"}], "]"}], ",", "5"}], 
               "]"}], "]"}], "<>", "\"\<}]: m=\>\"", "<>", 
             RowBox[{"ToCString", "[", "m", "]"}], "<>", 
             RowBox[{"If", "[", 
              RowBox[{"testPrec", ",", 
               RowBox[{"\"\< maxabserror=\>\"", "<>", 
                RowBox[{"ToCString", "[", 
                 RowBox[{"N", "[", 
                  RowBox[{"maxabserror", ",", "5"}], "]"}], "]"}], "<>", 
                "\"\< maxrelerror=\>\"", "<>", 
                RowBox[{"ToCString", "[", 
                 RowBox[{"N", "[", 
                  RowBox[{"maxrelerror", ",", "5"}], "]"}], "]"}]}], ",", 
               "\"\<\>\""}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"WriteLine", "[", 
             RowBox[{"ofile", ",", 
              RowBox[{
               RowBox[{"ToCString", "[", 
                RowBox[{"N", "[", 
                 RowBox[{
                  RowBox[{"c", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", 
                    RowBox[{"j", "+", "1"}]}], "]"}], "]"}], ",", "tprec"}], 
                 "]"}], "]"}], "<>", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"i", "\[Equal]", "order"}], "&&", 
                  RowBox[{"j", "\[Equal]", "order"}], "&&", 
                  RowBox[{"m", "\[Equal]", "mmax"}]}], ",", "\"\<\>\"", ",", 
                 "\"\<,\>\""}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", "order"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"j", ",", "0", ",", "order"}], "}"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"printDebug", ",", 
            RowBox[{"Print", "[", 
             RowBox[{"\"\<done with [{\>\"", "<>", 
              RowBox[{"ToCString", "[", 
               RowBox[{"N", "[", 
                RowBox[{
                 RowBox[{"x2T", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "1"}], "/", "2"}], ",", "t"}], "]"}], ",", 
                 "5"}], "]"}], "]"}], "<>", "\"\<,\>\"", "<>", 
              RowBox[{"ToCString", "[", 
               RowBox[{"N", "[", 
                RowBox[{
                 RowBox[{"x2U", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "1"}], "/", "2"}], ",", "u"}], "]"}], ",", 
                 "5"}], "]"}], "]"}], "<>", "\"\<},{\>\"", "<>", 
              RowBox[{"ToCString", "[", 
               RowBox[{"N", "[", 
                RowBox[{
                 RowBox[{"x2T", "[", 
                  RowBox[{
                   RowBox[{"1", "/", "2"}], ",", "t"}], "]"}], ",", "5"}], 
                "]"}], "]"}], "<>", "\"\<,\>\"", "<>", 
              RowBox[{"ToCString", "[", 
               RowBox[{"N", "[", 
                RowBox[{
                 RowBox[{"x2U", "[", 
                  RowBox[{
                   RowBox[{"1", "/", "2"}], ",", "u"}], "]"}], ",", "5"}], 
                "]"}], "]"}], "<>", "\"\<}]: m=\>\"", "<>", 
              RowBox[{"ToCString", "[", "m", "]"}]}], "]"}]}], "]"}], ";"}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{"-", "1"}], ",", "mmax"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"WriteLine", "[", 
        RowBox[{"ofile", ",", "\"\<}\>\""}], "]"}], ";"}], 
      "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"t", ",", 
        RowBox[{"TminLog2", "-", "1"}], ",", "TmaxLog2", ",", "1"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"u", ",", "UminLog10", ",", "UmaxLog10", ",", "1"}], "}"}]}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{"ofile", ",", "\"\<};\>\""}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteLine", "[", 
     RowBox[{
     "ofile", ",", " ", 
      "\"\<#endif  // defined(LIBINT2_STATICS_INITIALIZATION) || \
LIBINT2_CONSTEXPR_STATICS\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{"testPrec", ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"WriteLine", "[", 
        RowBox[{
        "ofile", ",", " ", "\"\<#ifndef LIBINT2_STATICS_INITIALIZATION\>\""}],
         "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"WriteLine", "[", 
        RowBox[{"ofile", ",", 
         RowBox[{"\"\<const double cheb_table_maxrelerror=\>\"", "<>", 
          RowBox[{"ToCString", "[", "tabmaxrelerror", "]"}], "<>", 
          "\"\<;\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"WriteLine", "[", 
        RowBox[{"ofile", ",", 
         RowBox[{"\"\<const double cheb_table_maxabserror=\>\"", "<>", 
          RowBox[{"ToCString", "[", "tabmaxabserror", "]"}], "<>", 
          "\"\<;\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"WriteLine", "[", 
        RowBox[{"ofile", ",", " ", "\"\<#endif\>\""}], "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Close", "[", "ofile", "]"}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.7427573679767227`*^9, 3.742757374075623*^9}, {
   3.742757438979693*^9, 3.742757492885439*^9}, {3.742757576058577*^9, 
   3.7427576201999683`*^9}, {3.7427577176277018`*^9, 3.742757910363515*^9}, {
   3.7427579522840567`*^9, 3.7427580365757236`*^9}, {3.742758083865858*^9, 
   3.742758212661593*^9}, {3.742758331858076*^9, 3.742758345702737*^9}, {
   3.742758436245517*^9, 3.742758445882161*^9}, {3.742758587378112*^9, 
   3.742758603947413*^9}, {3.742758669741765*^9, 3.7427587052499943`*^9}, {
   3.742758912986974*^9, 3.742758972940493*^9}, {3.74275904715978*^9, 
   3.742759061365098*^9}, {3.742759845539733*^9, 3.742759851593454*^9}, {
   3.7427598934353743`*^9, 3.742760001362019*^9}, {3.74276003208508*^9, 
   3.742760042415318*^9}, {3.7427600798214912`*^9, 3.742760158414194*^9}, {
   3.74276020162818*^9, 3.7427603711613913`*^9}, {3.742760403813476*^9, 
   3.742760548992937*^9}, {3.7427605811837873`*^9, 3.742760936080447*^9}, {
   3.742761006905792*^9, 3.742761114293366*^9}, {3.742761168588739*^9, 
   3.742761310767078*^9}, {3.742761413704504*^9, 3.742761488597238*^9}, 
   3.742761567750045*^9, {3.742761667872896*^9, 3.7427616707970743`*^9}, {
   3.742761811788107*^9, 3.742761880777269*^9}, {3.7427619476633167`*^9, 
   3.7427619496385937`*^9}, {3.742761990841506*^9, 3.7427620024337463`*^9}, {
   3.7427620914098787`*^9, 3.742762094943954*^9}, {3.742762149420899*^9, 
   3.74276215196068*^9}, {3.742762324056232*^9, 3.7427623431525173`*^9}, {
   3.742762423982316*^9, 3.7427624674659967`*^9}, {3.7427625270075703`*^9, 
   3.7427625271618843`*^9}, {3.742762578398473*^9, 3.742762696251594*^9}, {
   3.742762727613008*^9, 3.742762749490137*^9}, {3.742762799953483*^9, 
   3.74276280055379*^9}, {3.7427628598190393`*^9, 3.7427628664742937`*^9}, {
   3.742762956745989*^9, 3.742762973394842*^9}, {3.742763419229825*^9, 
   3.74276348150344*^9}, {3.742763518663391*^9, 3.74276351910662*^9}, {
   3.742763557199409*^9, 3.7427635586694117`*^9}, {3.7427636830882683`*^9, 
   3.7427636880829773`*^9}, {3.742763723776568*^9, 3.742763724184744*^9}, {
   3.742765241968861*^9, 3.7427652523065367`*^9}, 3.74276573418829*^9, {
   3.7427662083321466`*^9, 3.742766214859387*^9}, {3.742780297167734*^9, 
   3.742780316008504*^9}, {3.742780403247016*^9, 3.742780478483376*^9}, {
   3.742780540307354*^9, 3.7427805433457613`*^9}, {3.742780648796072*^9, 
   3.742780678995001*^9}, {3.7427807194965143`*^9, 3.7427807555509253`*^9}, {
   3.7427812568568*^9, 3.742781283060403*^9}, {3.742781633572447*^9, 
   3.7427816643497677`*^9}, {3.7428076305658827`*^9, 
   3.7428076395109787`*^9}, {3.7428078750102654`*^9, 3.742807982278513*^9}, {
   3.7428080151004057`*^9, 3.742808016619052*^9}, {3.742808707987739*^9, 
   3.742808731560231*^9}, {3.7429114657811813`*^9, 3.742911879591343*^9}, {
   3.742912333836804*^9, 3.742912503232954*^9}, {3.917369656004133*^9, 
   3.9173697814203987`*^9}, {3.917390957337389*^9, 3.917391092353067*^9}, {
   3.917391157056032*^9, 3.917391177919897*^9}, {3.91739121877771*^9, 
   3.917391384296852*^9}, {3.917391490433791*^9, 3.91739155597591*^9}, 
   3.917391594806157*^9, {3.917392471260742*^9, 3.917392476850285*^9}, {
   3.91739276851237*^9, 3.917392937431354*^9}, {3.917392976853485*^9, 
   3.9173930037681503`*^9}, {3.917393113398563*^9, 3.9173932187163973`*^9}, {
   3.917393521122818*^9, 3.917393550309623*^9}, {3.917393640378655*^9, 
   3.91739367340707*^9}, {3.917393936967669*^9, 3.917394008364624*^9}, {
   3.9173940622428637`*^9, 3.9173941959507017`*^9}, {3.917394229744135*^9, 
   3.917394350746695*^9}, {3.917394751762217*^9, 3.9173947593418627`*^9}, {
   3.917394928722415*^9, 3.917394929208722*^9}, {3.917395290633037*^9, 
   3.917395316648387*^9}, {3.9173953797359343`*^9, 3.917395381194911*^9}, {
   3.9173954234856377`*^9, 3.91739542397558*^9}, {3.917395529719077*^9, 
   3.917395533275313*^9}, {3.91739707268111*^9, 3.917397099133761*^9}, {
   3.91739728295645*^9, 3.9173973053018007`*^9}, {3.917423786937221*^9, 
   3.917423793757908*^9}, {3.9174240205775433`*^9, 3.917424101567459*^9}, {
   3.917424439880743*^9, 3.917424460639633*^9}, {3.917424561465901*^9, 
   3.917424588084375*^9}, {3.91742517133582*^9, 3.917425180475285*^9}, {
   3.917425293662827*^9, 3.917425309233594*^9}, {3.917426542895648*^9, 
   3.917426557691381*^9}, {3.917426827966776*^9, 3.917426849217939*^9}, {
   3.917426936143958*^9, 3.917426939177878*^9}, {3.917427254723955*^9, 
   3.917427296576551*^9}, {3.917427377657939*^9, 3.917427400352631*^9}, {
   3.917427499444573*^9, 3.917427537935934*^9}, {3.917427598485031*^9, 
   3.917427600754137*^9}, {3.9174276369627953`*^9, 3.917427638400963*^9}, 
   3.917428661668666*^9, {3.917428929619852*^9, 3.9174289938615437`*^9}, {
   3.9174290439655113`*^9, 3.917429086828171*^9}, {3.9174293188266907`*^9, 
   3.9174293231295547`*^9}, {3.917429928383953*^9, 3.9174299507751207`*^9}, {
   3.917430014998805*^9, 3.917430017834208*^9}, 3.917430130759831*^9, {
   3.917433333833529*^9, 3.917433355865095*^9}, {3.917433956613502*^9, 
   3.9174339712011423`*^9}, {3.917434532902986*^9, 3.9174345998808823`*^9}, {
   3.917434688921452*^9, 3.917434726012994*^9}},
 CellLabel->
  "In[1806]:=",ExpressionUUID->"1eec5c14-359b-4b33-b345-0baf9bdacabe"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reference data for test-core-ints.cc", "Section",
 CellChangeTimes->{{3.917509113908716*^9, 
  3.9175091287349787`*^9}},ExpressionUUID->"c25b4a72-14f5-45fb-ab9a-\
9bf6abff3ffd"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Zeta]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]", "=", 
   RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tt", "=", 
   RowBox[{"3", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"uu", "=", 
   RowBox[{
    RowBox[{"\[Zeta]", "^", "2"}], "/", 
    RowBox[{"(", 
     RowBox[{"4", " ", "\[Rho]"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<T=10^(-300),U:\>\"", ",", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"$MaxExtraPrecision", "=", "tprecmax"}], "}"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{"Limit", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"GmTable", "[", 
               RowBox[{"[", 
                RowBox[{"m", "+", "2"}], "]"}], "]"}], "/.", 
              RowBox[{"U", "->", "uu"}]}], ",", 
             RowBox[{"T", "->", 
              RowBox[{"10", "^", 
               RowBox[{"(", 
                RowBox[{"-", "300"}], ")"}]}]}]}], "]"}], ",", "tprec"}], 
          "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "0", ",", "mmax"}], "}"}]}], "]"}], "//", 
     "CForm"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<T=10^(-300),U=10^3:\>\"", ",", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"$MaxExtraPrecision", "=", "tprecmax"}], "}"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{"Limit", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"GmTable", "[", 
               RowBox[{"[", 
                RowBox[{"m", "+", "2"}], "]"}], "]"}], "/.", 
              RowBox[{"U", "->", 
               RowBox[{"10", "^", "3"}]}]}], ",", 
             RowBox[{"T", "->", 
              RowBox[{"10", "^", 
               RowBox[{"(", 
                RowBox[{"-", "300"}], ")"}]}]}]}], "]"}], ",", "tprec"}], 
          "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "0", ",", "mmax"}], "}"}]}], "]"}], "//", 
     "CForm"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<T=1023,U=10^(-3):\>\"", ",", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"$MaxExtraPrecision", "=", "tprecmax"}], "}"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{"Limit", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"GmTable", "[", 
               RowBox[{"[", 
                RowBox[{"m", "+", "2"}], "]"}], "]"}], "/.", 
              RowBox[{"U", "->", 
               RowBox[{"10", "^", 
                RowBox[{"(", 
                 RowBox[{"-", "3"}], ")"}]}]}]}], ",", 
             RowBox[{"T", "->", "1023"}]}], "]"}], ",", "tprec"}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "0", ",", "mmax"}], "}"}]}], "]"}], "//", 
     "CForm"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<T=1024,U=10^(-5):\>\"", ",", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"$MaxExtraPrecision", "=", "tprecmax"}], "}"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{"Limit", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"GmTable", "[", 
               RowBox[{"[", 
                RowBox[{"m", "+", "2"}], "]"}], "]"}], "/.", 
              RowBox[{"U", "->", 
               RowBox[{"10", "^", 
                RowBox[{"(", 
                 RowBox[{"-", "5"}], ")"}]}]}]}], ",", 
             RowBox[{"T", "->", "1024"}]}], "]"}], ",", "tprec"}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "0", ",", "mmax"}], "}"}]}], "]"}], "//", 
     "CForm"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<T=1025,U=10^(-3):\>\"", ",", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"$MaxExtraPrecision", "=", "tprecmax"}], "}"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{"Limit", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"GmTable", "[", 
               RowBox[{"[", 
                RowBox[{"m", "+", "2"}], "]"}], "]"}], "/.", 
              RowBox[{"U", "->", 
               RowBox[{"10", "^", 
                RowBox[{"(", 
                 RowBox[{"-", "3"}], ")"}]}]}]}], ",", 
             RowBox[{"T", "->", "1025"}]}], "]"}], ",", "tprec"}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "0", ",", "mmax"}], "}"}]}], "]"}], "//", 
     "CForm"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<T,U:\>\"", ",", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Block", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"$MaxExtraPrecision", "=", "tprecmax"}], "}"}], ",", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{"Limit", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"GmTable", "[", 
              RowBox[{"[", 
               RowBox[{"m", "+", "2"}], "]"}], "]"}], "/.", 
             RowBox[{"U", "->", "uu"}]}], ",", 
            RowBox[{"T", "->", "tt"}]}], "]"}], ",", "tprec"}], "]"}]}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", "0", ",", "mmax"}], "}"}]}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.917509190710669*^9, 3.917509336179401*^9}, {
  3.9175095219051933`*^9, 3.917509612209928*^9}, {3.9175097274367533`*^9, 
  3.91750977134052*^9}, {3.9175100331128893`*^9, 3.917510038114689*^9}, {
  3.917510075497849*^9, 3.917510128838769*^9}, {3.917510159511899*^9, 
  3.917510168366888*^9}, {3.917510507773616*^9, 3.917510586426119*^9}, {
  3.917510634611197*^9, 3.917510672603198*^9}, {3.917523748909737*^9, 
  3.9175237555591307`*^9}, {3.917524001401414*^9, 3.91752400396526*^9}, {
  3.917524075753633*^9, 3.91752408451799*^9}},
 CellLabel->
  "In[1970]:=",ExpressionUUID->"9a81e95f-016f-466e-956a-6569dd2c5e91"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T=10^(-300),U:\"\>", "\[InvisibleSpace]", 
   InterpretationBox["\<\"List(0.3443204575812015284561287692691887166007,0.\
2185598474729328238479570769102704277998,0.\
15628803050541343523040858461794591444,0.\
1205302813563695092527987736260077265086,0.\
09771885762707005452746680293044358594349,0.\
08202555839753908595204847246086876491423,0.\
07061341858480468569599627134916394116044,0.\
0619591054276796876202669152433890705893,0.\
05517887615131295955174900498568299584769,0.\
04972742757098352844464478921127984232381,0.\
04525107487757221293120739098993905512744,0.\
04151082283140990378559967865261134542924,0.\
03833956708674360384857601285389554618283,0.\
03561705307086134800560829582022609088212,0.\
03325458437686685006877212773033703134889,0.\
03118533598784300483649122168611816027907,0.\
02935802012158051500495481146405702544609,0.\
02773262799652627099985843395816979927297,0.\
02627749654063442510811193421734676218181,0.\
02496724367844527115107405296878598045688,0.\
02378128673955011533777868163490765901325,0.\
02270276077349883452702840275267656606946,0.\
02171771642725558145495492438327385408735,0.\
02081451667176051954351159735354736480665,0.\
01998337721078039756033649801319291092231,0.\
01921601221155332553803261768601582527603,0.\
01850535826015937121626353551535819197592,0.\
01784535712254255688697702662699348741862,0.\
01723078320837644637040391181356151776459,0.\
01665710536934955175643383200315997427518,0.\
01612037532181394177448469127863672173319,0.\
01561713689965374695596056045589465521058,0.\
01514435174000532696990829906990931299676,0.\
01469933803373126377656853284970284607468,0.\
01427971973864157588729610821956952396993,0.\
01388338422903321724102399847578071093,0.\
0135084467913831066131366575551262916311)\"\>",
    CForm[{
     0.3443204575812015284561287692691887166007176671295379728073`40., 
      0.2185598474729328238479570769102704277997607776234873015265`40., 
      0.1562880305054134352304085846179459144400478444753025314591`40., 
      0.1205302813563695092527987736260077265085645936463853526481`40., 
      0.0977188576270700545274668029304435859434928229281794052613`40., 
      0.0820255583975390859520484724608687649142279251883473267944`40., 
      0.0706134185848046856959962713491639411604440057547425133267`40., 
      0.0619591054276796876202669152433890705893037329496838484253`40., 
      0.0551788761513129595517490049856829958476880157088421273339`40., 
      0.0497274275709835284446447892112798423238058939100609408098`40., 
      0.0452510748775722129312073909899390551274378145757113837782`40., 
      0.0415108228314099037855996786526113454292418341488821137495`40., 
      0.0383395670867436038485760128538955461828303266340447154501`40., 
      0.035617053070861348005608295820226090882117395309850195724`40., 
      0.0332545843768668500687721277303370313488925036100051656646`40., 
      0.031185335987843004836491221686118160279067983754515962398`40., 
      0.0293580201215805150049548114640570254460888489771358845854`40., 
      0.0277326279965262709998584339581697992729688900292246885269`40., 
      0.0262774965406344251081119342173467621818116516208317651443`40., 
      0.0249672436784452711510740529687859804568766243174145701242`40., 
      0.0237812867395501153377786816349076590132469116020142787774`40., 
      0.0227027607734988345270284027526765660694593741487903656098`40., 
      0.0217177164272555814549549243832738540873453472411379918754`40., 
      0.0208145166717605195435115973535473648066522266544438725133`40., 
      0.01998337721078039756033649801319291092231321986419502301`40., 
      0.0192160122115533255380326176860158252760330741203099015097`40., 
      0.0185053582601593712162635355153581919759239042618809452545`40., 
      0.0178453571225425568869770266269934874186195653770567100863`40., 
      0.0172307832083764463704039118135615177645856216600516366651`40., 
      0.0166571053693495517564338320031599742751765148871177688701`40., 
      0.0161203753218139417744846912786367217331938276248013480514`40., 
      0.0156171368996537469559605604558946552105842249583364865389`40., 
      0.0151443517400053269699082990699093129967602426929486694378`40., 
      0.0146993380337312637765685328497028460746752202583141989578`40., 
      0.0142797197386415758872961082195695239699322431846621106672`40., 
      0.0138833842290332172410239984757807109300009543213427868206`40., 
      0.0135084467913831066131366575551262916310958773380637974343`40.}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["T=10^(-300),U:", 
   CForm[{
    0.3443204575812015284561287692691887166007176671295379728073`40., 
     0.2185598474729328238479570769102704277997607776234873015265`40., 
     0.1562880305054134352304085846179459144400478444753025314591`40., 
     0.1205302813563695092527987736260077265085645936463853526481`40., 
     0.0977188576270700545274668029304435859434928229281794052613`40., 
     0.0820255583975390859520484724608687649142279251883473267944`40., 
     0.0706134185848046856959962713491639411604440057547425133267`40., 
     0.0619591054276796876202669152433890705893037329496838484253`40., 
     0.0551788761513129595517490049856829958476880157088421273339`40., 
     0.0497274275709835284446447892112798423238058939100609408098`40., 
     0.0452510748775722129312073909899390551274378145757113837782`40., 
     0.0415108228314099037855996786526113454292418341488821137495`40., 
     0.0383395670867436038485760128538955461828303266340447154501`40., 
     0.035617053070861348005608295820226090882117395309850195724`40., 
     0.0332545843768668500687721277303370313488925036100051656646`40., 
     0.031185335987843004836491221686118160279067983754515962398`40., 
     0.0293580201215805150049548114640570254460888489771358845854`40., 
     0.0277326279965262709998584339581697992729688900292246885269`40., 
     0.0262774965406344251081119342173467621818116516208317651443`40., 
     0.0249672436784452711510740529687859804568766243174145701242`40., 
     0.0237812867395501153377786816349076590132469116020142787774`40., 
     0.0227027607734988345270284027526765660694593741487903656098`40., 
     0.0217177164272555814549549243832738540873453472411379918754`40., 
     0.0208145166717605195435115973535473648066522266544438725133`40., 
     0.01998337721078039756033649801319291092231321986419502301`40., 
     0.0192160122115533255380326176860158252760330741203099015097`40., 
     0.0185053582601593712162635355153581919759239042618809452545`40., 
     0.0178453571225425568869770266269934874186195653770567100863`40., 
     0.0172307832083764463704039118135615177645856216600516366651`40., 
     0.0166571053693495517564338320031599742751765148871177688701`40., 
     0.0161203753218139417744846912786367217331938276248013480514`40., 
     0.0156171368996537469559605604558946552105842249583364865389`40., 
     0.0151443517400053269699082990699093129967602426929486694378`40., 
     0.0146993380337312637765685328497028460746752202583141989578`40., 
     0.0142797197386415758872961082195695239699322431846621106672`40., 
     0.0138833842290332172410239984757807109300009543213427868206`40., 
     0.0135084467913831066131366575551262916310958773380637974343`40.}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.917509612971449*^9, {3.917510042462212*^9, 3.91751013051343*^9}, 
   3.9175105360460577`*^9, {3.917510567359405*^9, 3.9175105881155643`*^9}, 
   3.9175106781907263`*^9, 3.917523757633593*^9, 3.917524006025263*^9, 
   3.917524086851453*^9},
 CellLabel->
  "During evaluation of \
In[1970]:=",ExpressionUUID->"5f9e710e-43f4-4213-9245-f8daecdf3511"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T=10^(-300),U=10^3:\"\>", "\[InvisibleSpace]", 
   InterpretationBox["\<\"List(0.0004992518684668698760157919116180007421591,\
0.0004987543554200826561387255879995052272495,0.\
0004982578319669375445097648001979091002148,0.\
0004977622951607015686386285148831142243323,0.\
0004972677420663180803047744704190612594879,0.\
0004967741697603490354955508328979528203838,0.\
000496281575330917616069102631084181479419,0.\
0004957899558776511907863158554424694107981,0.\
000495299308511624613374605242062422259045,0.\
000494809630355303855304711361850288521582,0.\
000494320918542489970979870299972521754099,0.\
0004938331702182633930547565241285431218218,0.\
0004933463825389285556194780697165502542594,0.\
0004928605526719588430016244654407219067124,0.\
0004923756777959418619569334178812478129392,0.\
0004918917551005250350365536850807862619847,0.\
0004914087817863615129361402981341659403214,0.\
0004909267550650564036491258209048034102075,0.\
000490445672159113316263469140280896745543,0.\
000489965530301881217257992806107859202924,0.\
0004894863267375015971710826288849169305349,0.\
0004890080587208559455310405169806078820973,0.\
0004885307235175135319537548008618719067855,0.\
0004880543184036794913295829420480039665733,0.\
0004875788406661432110374309368161646296632,0.\
0004871042876022270181399632621111909935993,0.\
0004866306565197351645296882222192077887056,0.\
000486157944736903108011337373846989501614,0.\
0004856861495823470873214956544915964345953,0.\
0004852152683950139891018422206238496747354,0.\
0004847452985241315048576321106934532873623,0.\
0004842762373291585759481869621125940519902,0.\
0004838080821797361246711703965355676310694,0.\
0004833408304556380695173015959532050427031,0.\
0004828744795467226226869102622259407912157,0.\
0004824090268528838679743588105368791206835,0.\
0004819444697840036171408545058389282004521)\"\>",
    CForm[{
     0.0004992518684668698760157919116180007421591258056385034581`40., 
      0.0004987543554200826561387255879995052272494629076643615784`40., 
      0.0004982578319669375445097648001979091002148369342553686362`40., 
      0.0004977622951607015686386285148831142243323044984661039395`40., 
      0.0004972677420663180803047744704190612594878892297546800861`40., 
      0.0004967741697603490354955508328979528203837764082399843229`40., 
      0.0004962815753309176160691026310841814794190141169254887834`40., 
      0.0004957899558776511907863158554424694107981177432681625811`40., 
      0.000495299308511624613374605242062422259044971380216181979`40., 
      0.0004948096303553038553047113618502885215819599772440022096`40., 
      0.000494320918542489970979870299972521754099049786285503999`40., 
      0.0004938331702182633930547565241285431218217577143040000828`40., 
      0.0004933463825389285556194780697165502542593828556799933768`40., 
      0.000492860552671958843001624465440721906712381060741231341`40., 
      0.0004923756777959418619569334178812478129392371902599075187`40., 
      0.0004918917551005250350365536850807862619846974025866116893`40., 
      0.0004914087817863615129361402981341659403213695402053521822`40., 
      0.0004909267550650564036491258209048034102074548454084510955`40., 
      0.0004904456721591133162634691402808967455429813292729087819`40., 
      0.0004899655303018812172579928061078592029240343962610880893`40., 
      0.0004894863267375015971710826288849169305349074994591175998`40., 
      0.0004890080587208559455310405169806078820973256065526697798`40., 
      0.0004885307235175135319537548008618719067855285976591208986`40., 
      0.0004880543184036794913295829420480039665732511634416638884`40., 
      0.0004875788406661432110374309368161646296632178187075963913`40., 
      0.0004871042876022270181399632621111909935993012271530826916`40., 
      0.0004866306565197351645296882222192077887056140696949927709`40., 
      0.000486157944736903108011337373846989501614033829272990148`40., 
      0.0004856861495823470873214956544915964345953042360354334051`40., 
      0.0004852152683950139891018422206238496747354496259175116936`40., 
      0.0004847452985241315048576321106934532873623073469668297169`40., 
      0.0004842762373291585759481869621125940519902429534339772389`40., 
      0.0004838080821797361246711703965355676310694475866468541878`40., 
      0.0004833408304556380695173015959532050427030571150192779781`40., 
      0.0004828744795467226226869102622259407912157357965426672066`40., 
      0.0004824090268528838679743588105368791206834986889389496502`40., 
      0.0004819444697840036171408545058389282004520907140013794481`40.}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["T=10^(-300),U=10^3:", 
   CForm[{
    0.0004992518684668698760157919116180007421591258056385034581`40., 
     0.0004987543554200826561387255879995052272494629076643615784`40., 
     0.0004982578319669375445097648001979091002148369342553686362`40., 
     0.0004977622951607015686386285148831142243323044984661039395`40., 
     0.0004972677420663180803047744704190612594878892297546800861`40., 
     0.0004967741697603490354955508328979528203837764082399843229`40., 
     0.0004962815753309176160691026310841814794190141169254887834`40., 
     0.0004957899558776511907863158554424694107981177432681625811`40., 
     0.000495299308511624613374605242062422259044971380216181979`40., 
     0.0004948096303553038553047113618502885215819599772440022096`40., 
     0.000494320918542489970979870299972521754099049786285503999`40., 
     0.0004938331702182633930547565241285431218217577143040000828`40., 
     0.0004933463825389285556194780697165502542593828556799933768`40., 
     0.000492860552671958843001624465440721906712381060741231341`40., 
     0.0004923756777959418619569334178812478129392371902599075187`40., 
     0.0004918917551005250350365536850807862619846974025866116893`40., 
     0.0004914087817863615129361402981341659403213695402053521822`40., 
     0.0004909267550650564036491258209048034102074548454084510955`40., 
     0.0004904456721591133162634691402808967455429813292729087819`40., 
     0.0004899655303018812172579928061078592029240343962610880893`40., 
     0.0004894863267375015971710826288849169305349074994591175998`40., 
     0.0004890080587208559455310405169806078820973256065526697798`40., 
     0.0004885307235175135319537548008618719067855285976591208986`40., 
     0.0004880543184036794913295829420480039665732511634416638884`40., 
     0.0004875788406661432110374309368161646296632178187075963913`40., 
     0.0004871042876022270181399632621111909935993012271530826916`40., 
     0.0004866306565197351645296882222192077887056140696949927709`40., 
     0.000486157944736903108011337373846989501614033829272990148`40., 
     0.0004856861495823470873214956544915964345953042360354334051`40., 
     0.0004852152683950139891018422206238496747354496259175116936`40., 
     0.0004847452985241315048576321106934532873623073469668297169`40., 
     0.0004842762373291585759481869621125940519902429534339772389`40., 
     0.0004838080821797361246711703965355676310694475866468541878`40., 
     0.0004833408304556380695173015959532050427030571150192779781`40., 
     0.0004828744795467226226869102622259407912157357965426672066`40., 
     0.0004824090268528838679743588105368791206834986889389496502`40., 
     0.0004819444697840036171408545058389282004520907140013794481`40.}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.917509612971449*^9, {3.917510042462212*^9, 3.91751013051343*^9}, 
   3.9175105360460577`*^9, {3.917510567359405*^9, 3.9175105881155643`*^9}, 
   3.9175106781907263`*^9, 3.917523757633593*^9, 3.917524006025263*^9, 
   3.917524116015424*^9},
 CellLabel->
  "During evaluation of \
In[1970]:=",ExpressionUUID->"ffd7d418-4d80-4cf1-a132-c623333c33ac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T=1023,U=10^(-3):\"\>", "\[InvisibleSpace]", 
   InterpretationBox["\<\"List(0.003668769827513450049304087206872065121708,5.\
420435725593595129051675074500856589402e-6,1.\
153413823646514442119413472006192571438e-8,3.\
348561223534355443014370662234180926232e-11,1.\
258394731770944134180812393922368114687e-13,5.\
862788284772907280659914798508381826701e-16,3.\
275046949953268248075302422846380074442e-18,2.\
138229130319993581676975291139033105234e-20,1.\
59963080864078970551171504651294098697e-22,1.\
350018063194399985827690657328827145627e-24,1.\
269319128173106435573238782920347212332e-26,1.\
316016877041745608221092501114030150933e-28,1.\
491801172902970199227750502551650191297e-30,1.\
835690747701984560231572877029035230332e-32,2.\
437048407748493507629424133934226845417e-34,3.\
472216127773543921471144401735013957144e-36,5.\
284756092010242437298698009803141644211e-38,8.\
557741655028969169850990381419876688679e-40,1.\
469100240197536507488975576498808956171e-41,2.\
665095978514634905204746634314972087591e-43,5.\
094455679868537077442957666353063206612e-45,1.\
02348827991355301640372538439559426143e-46,2.\
15600611680743648323113639698619816743e-48,4.\
751953710279440486250336409641155248614e-50,1.\
093709802573290274439941537304650715144e-51,2.\
623989218000821713454650149370513594673e-53,6.\
55142678780823878011119970309663360075e-55,1.\
699659910055898434450559698406626019348e-56,4.\
575382384595824959451759892787212303821e-58,1.\
276328093372303041914176079318438057291e-59,3.\
684988521830781816819424431947389522298e-61,1.\
099900124390772978662598854177196717848e-62,3.\
390391378643954706357776945347132991928e-64,1.\
078178981606721458988211247401755052878e-65,3.\
534007800353040901580513641975783538743e-67,1.\
192874750834218800101921229451658920742e-68,4.\
142951489014496364871359607229095749925e-70)\"\>",
    CForm[{
     0.0036687698275134500493040872068720651217078779941438117291`40., 
      5.4204357255935951290516750745008565894015376787817388`40.*^-6, 
      1.15341382364651444211941347200619257143794570012869`40.*^-8, 
      3.348561223534355443014370662234180926231689167350810923130148250875`40.\
*^-11, 1.2583947317709441341808123939223681146870828725177439407102849747`40.*\
^-13, 5.8627882847729072806599147985083818267009206677076528108509666`40.*^-\
16, 3.27504694995326824807530242284638007444204756059724676435703`40.*^-18, 
      2.13822913031999358167697529113903310523395906262491402054`40.*^-20, 
      1.5996308086407897055117150465129409869695892205030868979`40.*^-22, 
      1.35001806319439998582769065732882714562706786711033529`40.*^-24, 
      1.269319128173106435573238782920347212331779438865933`40.*^-26, 
      1.31601687704174560822109250111403015093317604054773391358772990225217`\
40.*^-28, 
      1.491801172902970199227750502551650191296647351924295778752837330421`40.\
*^-30, 1.8356907477019845602315728770290352303324935975668109004446192341`40.*\
^-32, 2.43704840774849350762942413393422684541723639319104315420813442`40.*^-\
34, 3.472216127773543921471144401735013957144005577812982051450518`40.*^-36, 
      5.2847560920102424372986980098031416442105386212532087659472`40.*^-38, 
      8.55774165502896916985099038141987668867920701939973048284`40.*^-40, 
      1.4691002401975365074889755764988089561711356471321662196`40.*^-41, 
      2.66509597851463490520474663431497208759069418789238378`40.*^-43, 
      5.094455679868537077442957666353063206611500511106029`40.*^-45, 
      1.02348827991355301640372538439559426143005698823522`40.*^-46, 
      2.1560061168074364832311363969861981674303362905345310702492490797546`\
40.*^-48, 
      4.75195371027944048625033640964115524861442543849955727314608911532`40.*\
^-50, 1.0937098025732902744399415373046507151435193688542820040949039299`40.*^\
-51, 2.62398921800082171345465014937051359467276332270917934259377179`40.*^-\
53, 6.551426787808238780111199703096633600749737699508260139167162`40.*^-55, 
      1.69965991005589843445055969840662601934834140145884468805922`40.*^-56, 
      4.575382384595824959451759892787212303820809962572171229298`40.*^-58, 
      1.27632809337230304191417607931843805729059548458898108039`40.*^-59, 
      3.684988521830781816819424431947389522298218464809449032`40.*^-61, 
      1.09990012439077297866259885417719671784774900024581647`40.*^-62, 
      3.390391378643954706357776945347132991928355395118842`40.*^-64, 
      1.0781789816067214589882112474017550528783609505613`40.*^-65, 
      3.53400780035304090158051364197578353874334070359287788748827157357022`\
40.*^-67, 
      1.1928747508342188001019212294516589207422589478886653565368539739523`\
40.*^-68, 
      4.14295148901449636487135960722909574992547664292116786988417144119`40.*\
^-70}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["T=1023,U=10^(-3):", 
   CForm[{
    0.0036687698275134500493040872068720651217078779941438117291`40., 
     5.4204357255935951290516750745008565894015376787817388`40.*^-6, 
     1.15341382364651444211941347200619257143794570012869`40.*^-8, 
     3.348561223534355443014370662234180926231689167350810923130148250875`40.*\
^-11, 1.2583947317709441341808123939223681146870828725177439407102849747`40.*^\
-13, 5.8627882847729072806599147985083818267009206677076528108509666`40.*^-16,
      3.27504694995326824807530242284638007444204756059724676435703`40.*^-18, 
     2.13822913031999358167697529113903310523395906262491402054`40.*^-20, 
     1.5996308086407897055117150465129409869695892205030868979`40.*^-22, 
     1.35001806319439998582769065732882714562706786711033529`40.*^-24, 
     1.269319128173106435573238782920347212331779438865933`40.*^-26, 
     1.31601687704174560822109250111403015093317604054773391358772990225217`\
40.*^-28, 
     1.491801172902970199227750502551650191296647351924295778752837330421`40.*\
^-30, 1.8356907477019845602315728770290352303324935975668109004446192341`40.*^\
-32, 2.43704840774849350762942413393422684541723639319104315420813442`40.*^-\
34, 3.472216127773543921471144401735013957144005577812982051450518`40.*^-36, 
     5.2847560920102424372986980098031416442105386212532087659472`40.*^-38, 
     8.55774165502896916985099038141987668867920701939973048284`40.*^-40, 
     1.4691002401975365074889755764988089561711356471321662196`40.*^-41, 
     2.66509597851463490520474663431497208759069418789238378`40.*^-43, 
     5.094455679868537077442957666353063206611500511106029`40.*^-45, 
     1.02348827991355301640372538439559426143005698823522`40.*^-46, 
     2.1560061168074364832311363969861981674303362905345310702492490797546`40.\
*^-48, 4.75195371027944048625033640964115524861442543849955727314608911532`40.\
*^-50, 1.0937098025732902744399415373046507151435193688542820040949039299`40.*\
^-51, 2.62398921800082171345465014937051359467276332270917934259377179`40.*^-\
53, 6.551426787808238780111199703096633600749737699508260139167162`40.*^-55, 
     1.69965991005589843445055969840662601934834140145884468805922`40.*^-56, 
     4.575382384595824959451759892787212303820809962572171229298`40.*^-58, 
     1.27632809337230304191417607931843805729059548458898108039`40.*^-59, 
     3.684988521830781816819424431947389522298218464809449032`40.*^-61, 
     1.09990012439077297866259885417719671784774900024581647`40.*^-62, 
     3.390391378643954706357776945347132991928355395118842`40.*^-64, 
     1.0781789816067214589882112474017550528783609505613`40.*^-65, 
     3.53400780035304090158051364197578353874334070359287788748827157357022`\
40.*^-67, 
     1.1928747508342188001019212294516589207422589478886653565368539739523`40.\
*^-68, 4.14295148901449636487135960722909574992547664292116786988417144119`40.\
*^-70}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.917509612971449*^9, {3.917510042462212*^9, 3.91751013051343*^9}, 
   3.9175105360460577`*^9, {3.917510567359405*^9, 3.9175105881155643`*^9}, 
   3.9175106781907263`*^9, 3.917523757633593*^9, 3.917524006025263*^9, 
   3.917524116253235*^9},
 CellLabel->
  "During evaluation of \
In[1970]:=",ExpressionUUID->"fb71d274-195b-4636-b901-ff9b482d3b1c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T=1024,U=10^(-5):\"\>", "\[InvisibleSpace]", 
   InterpretationBox["\<\"List(0.02262060843208498576572581793629832479017,0.\
00001328061410798521010109505192413038336352,1.\
967492895146354004814437115777202958319e-8,4.\
816418800755732638805847501335095487461e-11,1.\
648158274569973415612169006428770140205e-13,7.\
247586576528941506731998414483203834384e-16,3.\
894356225942859181756065719699405155324e-18,2.\
472711235859874377238394450826232100922e-20,1.\
811448107927246160983370551456683609577e-22,1.\
503884924669673070579676570491468448584e-24,1.\
395382639889630997721475663107461615738e-26,1.\
430959140992753432533796302656136565791e-28,1.\
607170459380522861829724507442253707834e-30,1.\
962017744277102395146883802669026121532e-32,2.\
58680143732424441966257432231829051703e-34,3.\
663142857318927850342038530997839992486e-36,5.\
545048934558662687961060527811409977934e-38,8.\
935251031550317703047640697990162351163e-40,1.\
527074590830714047519742903079645044486e-41,2.\
758962251510875479578666842875315658127e-43,5.\
254032322173135016194484685446458493996e-45,1.\
051859585613288854565102682797805414478e-46,2.\
208545556046672625649543664904429790736e-48,4.\
852863952210522203707939215139889462594e-50,1.\
113715931860383969333615440424338933601e-51,2.\
664699767282678545009174715265411900603e-53,6.\
635835720863297195478836802217619902765e-55,1.\
717307727564889241784513519858224539406e-56,4.\
611975204258451218632194304666152011294e-58,1.\
28362315067474047480721994332524600143e-59,3.\
697982826408717758978012846438010122791e-61,1.\
10146249832633365614554881871389291007e-62,3.\
388324071832241312535223202223854537911e-64,1.\
075406580049278994053231441612245960694e-65,3.\
518208912505666945792432306282271686395e-67,1.\
185344559453374598719071951154101420182e-68,4.\
109383172020121955197425147382932484728e-70)\"\>",
    CForm[{
     0.0226206084320849857657258179362983247901734289440002853133`40., 
      0.0000132806141079852101010950519241303833635213311845103847`40., 
      1.96749289514635400481443711577720295831872373693414`40.*^-8, 
      4.816418800755732638805847501335095487461260423359239899005410445689`40.\
*^-11, 1.6481582745699734156121690064287701402048436249147149464410979419`40.*\
^-13, 7.2475865765289415067319984144832038343840405981831801746913765`40.*^-\
16, 3.89435622594285918175606571969940515532365934826724982121972`40.*^-18, 
      2.472711235859874377238394450826232100921696269954619822328`40.*^-20, 
      1.8114481079272461609833705514566836095769575863288980388`40.*^-22, 
      1.50388492466967307057967657049146844858447863086578008`40.*^-24, 
      1.39538263988963099772147566310746161573848866707141`40.*^-26, 
      1.43095914099275343253379630265613656579128080887506539217571353015044`\
40.*^-28, 
      1.607170459380522861829724507442253707833541776438508335864982376925`40.\
*^-30, 1.9620177442771023951468838026690261215317444810830295026092412845`40.*\
^-32, 2.58680143732424441966257432231829051702992031605442839585641117`40.*^-\
34, 3.663142857318927850342038530997839992485876594459989812494441`40.*^-36, 
      5.5450489345586626879610605278114099779343864389107320828792`40.*^-38, 
      8.93525103155031770304764069799016235116307247252163470467`40.*^-40, 
      1.5270745908307140475197429030796450444856611587457765436`40.*^-41, 
      2.75896225151087547957866684287531565812693825625430842`40.*^-43, 
      5.254032322173135016194484685446458493996072427550563`40.*^-45, 
      1.05185958561328885456510268279780541447829698928753`40.*^-46, 
      2.2085455560466726256495436649044297907356235231371669824205781387987`\
40.*^-48, 
      4.85286395221052220370793921513988946259433667652104928043604107058`40.*\
^-50, 1.113715931860383969333615440424338933601148901579763624219911009`40.*^-\
51, 2.66469976728267854500917471526541190060296948460662704548421098`40.*^-53,
       6.635835720863297195478836802217619902764582324840875689366738`40.*^-\
55, 1.71730772756488924178451351985822453940587924392351385046343`40.*^-56, 
      4.611975204258451218632194304666152011294136295520421387714`40.*^-58, 
      1.28362315067474047480721994332524600142990517872632747133`40.*^-59, 
      3.697982826408717758978012846438010122791341033794551996`40.*^-61, 
      1.10146249832633365614554881871389291006970049936456699`40.*^-62, 
      3.38832407183224131253522320222385453791092235890555`40.*^-64, 
      1.07540658004927899405323144161224596069350631220292`40.*^-65, 
      3.51820891250566694579243230628227168639514185068860582549636866434456`\
40.*^-67, 
      1.1853445594533745987190719511541014201815731187018606584891443325897`\
40.*^-68, 
      4.10938317202012195519742514738293248472797707305674998025698548246`40.*\
^-70}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["T=1024,U=10^(-5):", 
   CForm[{
    0.0226206084320849857657258179362983247901734289440002853133`40., 
     0.0000132806141079852101010950519241303833635213311845103847`40., 
     1.96749289514635400481443711577720295831872373693414`40.*^-8, 
     4.816418800755732638805847501335095487461260423359239899005410445689`40.*\
^-11, 1.6481582745699734156121690064287701402048436249147149464410979419`40.*^\
-13, 7.2475865765289415067319984144832038343840405981831801746913765`40.*^-16,
      3.89435622594285918175606571969940515532365934826724982121972`40.*^-18, 
     2.472711235859874377238394450826232100921696269954619822328`40.*^-20, 
     1.8114481079272461609833705514566836095769575863288980388`40.*^-22, 
     1.50388492466967307057967657049146844858447863086578008`40.*^-24, 
     1.39538263988963099772147566310746161573848866707141`40.*^-26, 
     1.43095914099275343253379630265613656579128080887506539217571353015044`\
40.*^-28, 
     1.607170459380522861829724507442253707833541776438508335864982376925`40.*\
^-30, 1.9620177442771023951468838026690261215317444810830295026092412845`40.*^\
-32, 2.58680143732424441966257432231829051702992031605442839585641117`40.*^-\
34, 3.663142857318927850342038530997839992485876594459989812494441`40.*^-36, 
     5.5450489345586626879610605278114099779343864389107320828792`40.*^-38, 
     8.93525103155031770304764069799016235116307247252163470467`40.*^-40, 
     1.5270745908307140475197429030796450444856611587457765436`40.*^-41, 
     2.75896225151087547957866684287531565812693825625430842`40.*^-43, 
     5.254032322173135016194484685446458493996072427550563`40.*^-45, 
     1.05185958561328885456510268279780541447829698928753`40.*^-46, 
     2.2085455560466726256495436649044297907356235231371669824205781387987`40.\
*^-48, 4.85286395221052220370793921513988946259433667652104928043604107058`40.\
*^-50, 1.113715931860383969333615440424338933601148901579763624219911009`40.*^\
-51, 2.66469976728267854500917471526541190060296948460662704548421098`40.*^-\
53, 6.635835720863297195478836802217619902764582324840875689366738`40.*^-55, 
     1.71730772756488924178451351985822453940587924392351385046343`40.*^-56, 
     4.611975204258451218632194304666152011294136295520421387714`40.*^-58, 
     1.28362315067474047480721994332524600142990517872632747133`40.*^-59, 
     3.697982826408717758978012846438010122791341033794551996`40.*^-61, 
     1.10146249832633365614554881871389291006970049936456699`40.*^-62, 
     3.38832407183224131253522320222385453791092235890555`40.*^-64, 
     1.07540658004927899405323144161224596069350631220292`40.*^-65, 
     3.51820891250566694579243230628227168639514185068860582549636866434456`\
40.*^-67, 
     1.1853445594533745987190719511541014201815731187018606584891443325897`40.\
*^-68, 4.10938317202012195519742514738293248472797707305674998025698548246`40.\
*^-70}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.917509612971449*^9, {3.917510042462212*^9, 3.91751013051343*^9}, 
   3.9175105360460577`*^9, {3.917510567359405*^9, 3.9175105881155643`*^9}, 
   3.9175106781907263`*^9, 3.917523757633593*^9, 3.917524006025263*^9, 
   3.917524116492856*^9},
 CellLabel->
  "During evaluation of \
In[1970]:=",ExpressionUUID->"26122da3-bfab-4b81-b7da-45a346a23cd8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T=1025,U=10^(-3):\"\>", "\[InvisibleSpace]", 
   InterpretationBox["\<\"List(0.003657951979774989740547145195094265598956,5.\
397434252949152394251250558614863241027e-6,1.\
146741791141338373846245954440640044927e-8,3.\
323510149412937730771453601915206279433e-11,1.\
246734372106011749419154493770132880287e-13,5.\
797712867725216239476429836250847404132e-16,3.\
232600501911678152833123765185345717367e-18,2.\
106504834068139474864677800715105551541e-20,1.\
572882566409972085538380086037251337395e-22,1.\
32489290711137333410367790355006311444e-24,1.\
243294719434053061711100301690665826431e-26,1.\
286544765343287266475797166644585120875e-28,1.\
455570173013776475184661214300662972947e-30,1.\
787637233093320455263984867846121529164e-32,2.\
368649723323044272544610910961239701561e-34,3.\
368213142584729170480317726411959787859e-36,5.\
116504261697132348263354717120146407997e-38,8.\
269184549488893333013988741963279191292e-40,1.\
416803707729027771342157448351896590131e-41,2.\
565225408632380751527810017749240947252e-43,4.\
894007398937007554334293764970281768822e-45,9.\
813041387226526140390810066699092717618e-47,2.\
063119907953795246574008251810024601031e-48,4.\
538373496861722761884789635745614092719e-50,1.\
042517943093130384672682509904418864771e-51,2.\
496299838121981624595079940391777397835e-53,6.\
220477821114131167379688461559099076222e-55,1.\
610656509691089503395329290003466373265e-56,4.\
327342321435717332199546571679113781029e-58,1.\
204783627433044418712454733871756969723e-59,3.\
471647847072113904911161962432548462893e-61,1.\
034202319009197839430845710512974671368e-62,3.\
181667270952239324987390390320295378802e-64,1.\
00983030768632875947349533908742338808e-65,3.\
303525071239174227864582220812866971167e-67,1.\
112903395009952621827077425872708808235e-68,3.\
857668855957630226062428725920906474347e-70)\"\>",
    CForm[{
     0.0036579519797749897405471451950942655989556731038907293279`40., 
      5.3974342529491523942512505586148632410273601197849057`40.*^-6, 
      1.14674179114133837384624595444064004492650861303104`40.*^-8, 
      3.323510149412937730771453601915206279433178092249827362785117816133`40.\
*^-11, 1.2467343721060117494191544937701328802870860425273589028958017559`40.*\
^-13, 5.7977128677252162394764298362508474041319073176566807798133915`40.*^-\
16, 3.23260050191167815283312376518534571736708061362332714081665`40.*^-18, 
      2.106504834068139474864677800715105551541386801982175121626`40.*^-20, 
      1.5728825664099720855383800860372513373948399098759654398`40.*^-22, 
      1.32489290711137333410367790355006311444002711357501695`40.*^-24, 
      1.243294719434053061711100301690665826431194299507342`40.*^-26, 
      1.2865447653432872664757971666445851208752724737741065572763393935373`\
40.*^-28, 
      1.455570173013776475184661214300662972947195402766142705828605306206`40.\
*^-30, 1.7876372330933204552639848678461215291636555884833356772713302812`40.*\
^-32, 2.36864972332304427254461091096123970156137268144406339022043983`40.*^-\
34, 3.368213142584729170480317726411959787859148238028024766667466`40.*^-36, 
      5.116504261697132348263354717120146407997359508056467364355`40.*^-38, 
      8.26918454948889333301398874196327919129193626407165990228`40.*^-40, 
      1.4168037077290277713421574483518965901308158104591189756`40.*^-41, 
      2.56522540863238075152781001774924094725200115669604123`40.*^-43, 
      4.894007398937007554334293764970281768822156501133532`40.*^-45, 
      9.8130413872265261403908100666990927176175032574544`40.*^-47, 
      2.0631199079537952465740082518100246010308149822964071251626718378154`\
40.*^-48, 
      4.53837349686172276188478963574561409271897679358475158514543460088`40.*\
^-50, 1.0425179430931303846726825099044188647707223038777688091293051007`40.*^\
-51, 2.49629983812198162459507994039177739783511085004304227767166256`40.*^-\
53, 6.22047782111413116737968846155909907622169745429125411969417`40.*^-55, 
      1.61065650969108950339532929000346637326496091340217110797032`40.*^-56, 
      4.32734232143571733219954657167911378102913581396123103654`40.*^-58, 
      1.20478362743304441871245473387175696972348162721205172355`40.*^-59, 
      3.471647847072113904911161962432548462892975547404403717`40.*^-61, 
      1.03420231900919783943084571051297467136788392544932213`40.*^-62, 
      3.181667270952239324987390390320295378801685210451482`40.*^-64, 
      1.00983030768632875947349533908742338807991763641188`40.*^-65, 
      3.30352507123917422786458222081286697116734221189293879911021506743392`\
40.*^-67, 
      1.1129033950099526218270774258727088082349394934043667113107278193775`\
40.*^-68, 
      3.85766885595763022606242872592090647434653906711940928354710054705`40.*\
^-70}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["T=1025,U=10^(-3):", 
   CForm[{
    0.0036579519797749897405471451950942655989556731038907293279`40., 
     5.3974342529491523942512505586148632410273601197849057`40.*^-6, 
     1.14674179114133837384624595444064004492650861303104`40.*^-8, 
     3.323510149412937730771453601915206279433178092249827362785117816133`40.*\
^-11, 1.2467343721060117494191544937701328802870860425273589028958017559`40.*^\
-13, 5.7977128677252162394764298362508474041319073176566807798133915`40.*^-16,
      3.23260050191167815283312376518534571736708061362332714081665`40.*^-18, 
     2.106504834068139474864677800715105551541386801982175121626`40.*^-20, 
     1.5728825664099720855383800860372513373948399098759654398`40.*^-22, 
     1.32489290711137333410367790355006311444002711357501695`40.*^-24, 
     1.243294719434053061711100301690665826431194299507342`40.*^-26, 
     1.2865447653432872664757971666445851208752724737741065572763393935373`40.\
*^-28, 1.455570173013776475184661214300662972947195402766142705828605306206`\
40.*^-30, 
     1.7876372330933204552639848678461215291636555884833356772713302812`40.*^-\
32, 2.36864972332304427254461091096123970156137268144406339022043983`40.*^-34,
      3.368213142584729170480317726411959787859148238028024766667466`40.*^-36,
      5.116504261697132348263354717120146407997359508056467364355`40.*^-38, 
     8.26918454948889333301398874196327919129193626407165990228`40.*^-40, 
     1.4168037077290277713421574483518965901308158104591189756`40.*^-41, 
     2.56522540863238075152781001774924094725200115669604123`40.*^-43, 
     4.894007398937007554334293764970281768822156501133532`40.*^-45, 
     9.8130413872265261403908100666990927176175032574544`40.*^-47, 
     2.0631199079537952465740082518100246010308149822964071251626718378154`40.\
*^-48, 4.53837349686172276188478963574561409271897679358475158514543460088`40.\
*^-50, 1.0425179430931303846726825099044188647707223038777688091293051007`40.*\
^-51, 2.49629983812198162459507994039177739783511085004304227767166256`40.*^-\
53, 6.22047782111413116737968846155909907622169745429125411969417`40.*^-55, 
     1.61065650969108950339532929000346637326496091340217110797032`40.*^-56, 
     4.32734232143571733219954657167911378102913581396123103654`40.*^-58, 
     1.20478362743304441871245473387175696972348162721205172355`40.*^-59, 
     3.471647847072113904911161962432548462892975547404403717`40.*^-61, 
     1.03420231900919783943084571051297467136788392544932213`40.*^-62, 
     3.181667270952239324987390390320295378801685210451482`40.*^-64, 
     1.00983030768632875947349533908742338807991763641188`40.*^-65, 
     3.30352507123917422786458222081286697116734221189293879911021506743392`\
40.*^-67, 
     1.1129033950099526218270774258727088082349394934043667113107278193775`40.\
*^-68, 3.85766885595763022606242872592090647434653906711940928354710054705`40.\
*^-70}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.917509612971449*^9, {3.917510042462212*^9, 3.91751013051343*^9}, 
   3.9175105360460577`*^9, {3.917510567359405*^9, 3.9175105881155643`*^9}, 
   3.9175106781907263`*^9, 3.917523757633593*^9, 3.917524006025263*^9, 
   3.917524116724842*^9},
 CellLabel->
  "During evaluation of \
In[1970]:=",ExpressionUUID->"1175a6a9-1c56-4c5e-a28f-9e769dd0b76e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T,U:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.285274466437520321029061802822794043390669156424561564904`40.", ",", 
     "0.1766838802450110751782118990187381894650973165107321985131`40.", ",", 
     "0.124179810818059467494706200935319566006183123296323777448`40.", ",", 
     "0.0946078560893175776414485406291985788562695016764870910467`40.", ",", 
     "0.0760276379359410748632870100364879096963640050586174208953`40.", ",", 
     "0.0633972947184489755735964193996214899021571921355787939017`40.", ",", 
     "0.0542994319286032335099564068575123773964031443459225480336`40.", ",", 
     "0.0474528151809552418935932153824425397885780610649453846568`40.", ",", 
     "0.0421223982686899930783014304605560034047047138700366924778`40.", ",", 
     "0.0378589417782787635964062564901295424771782747610682133065`40.", ",", 
     "0.0343734522904477255719108740920007304814011705522137979599`40.", ",", 
     "0.0314720319932718908994347218405466840072527072642527825818`40.", ",", 
     "0.0290199457566389169867261618445959841099370093850357506721`40.", ",", 
     "0.0269207587125449158345249810627156909557111831519003345093`40.", ",", 
     "0.025103683856056297420044785366837946219812870812230723433`40.", ",", 
     "0.0235156164274327915815832956386654319133886745126416097294`40.", ",", 
     "0.0221159540412582839704219514127491055876842478418571256618`40.", ",", 
     "0.0208731318453971608977231882359484068745293688248673427584`40.", ",", 
     "0.0197622465807350822064329339218774566899348745220129493535`40.", ",", 
     "0.0187633910847955607814466067126623870331141569005668641234`40.", ",", 
     "0.0178604636767401443599613606631561313318929360751905088231`40.", ",", 
     "0.017040301915706022454981024307078165764122173307285652493`40.", ",", 
     "0.0162920422839687397621193775828339783448252604824454353671`40.", ",", 
     "0.0156066400209690761391320603613171984983461050305396921276`40.", ",", 
     "0.0149765043129957537240873920782090593080682748646743587589`40.", ",", 
     "0.0143952177934052375875674881262403873524005690009615383719`40.", ",", 
     "0.0138573184915750077052591786644199034970767698578441123819`40.", ",", 
     "0.013358128608604633165716963371130667525363565779488577195`40.", ",", 
     "0.0128936188051866095880306412646495753497027595511825163036`40.", ",", 
     "0.0124602997042058560276495602305659837936160469964760971554`40.", ",", 
     "0.0120551344526904152541348592503762449846638339133175880882`40.", ",", 
     "0.0116754677276722007716703253095000927930978061963394891361`40.", ",", 
     "0.0113189676905353296708192907184420312792906538354072771413`40.", ",", 
     "0.0109835782179179388467507378173587562745651224997525267206`40.", ",", 
     "0.0106674793488656105604082419394363824881710488664421317225`40.", ",", 
     "0.0103690543465453357467427538677537929601937704754252884432`40.", ",", 
     "0.0100868621197776375204499787202313507994625343710521406676`40."}], 
    "}"}]}],
  SequenceForm[
  "T,U:", {0.285274466437520321029061802822794043390669156424561564904`40., 
    0.1766838802450110751782118990187381894650973165107321985131`40., 
    0.124179810818059467494706200935319566006183123296323777448`40., 
    0.0946078560893175776414485406291985788562695016764870910467`40., 
    0.0760276379359410748632870100364879096963640050586174208953`40., 
    0.0633972947184489755735964193996214899021571921355787939017`40., 
    0.0542994319286032335099564068575123773964031443459225480336`40., 
    0.0474528151809552418935932153824425397885780610649453846568`40., 
    0.0421223982686899930783014304605560034047047138700366924778`40., 
    0.0378589417782787635964062564901295424771782747610682133065`40., 
    0.0343734522904477255719108740920007304814011705522137979599`40., 
    0.0314720319932718908994347218405466840072527072642527825818`40., 
    0.0290199457566389169867261618445959841099370093850357506721`40., 
    0.0269207587125449158345249810627156909557111831519003345093`40., 
    0.025103683856056297420044785366837946219812870812230723433`40., 
    0.0235156164274327915815832956386654319133886745126416097294`40., 
    0.0221159540412582839704219514127491055876842478418571256618`40., 
    0.0208731318453971608977231882359484068745293688248673427584`40., 
    0.0197622465807350822064329339218774566899348745220129493535`40., 
    0.0187633910847955607814466067126623870331141569005668641234`40., 
    0.0178604636767401443599613606631561313318929360751905088231`40., 
    0.017040301915706022454981024307078165764122173307285652493`40., 
    0.0162920422839687397621193775828339783448252604824454353671`40., 
    0.0156066400209690761391320603613171984983461050305396921276`40., 
    0.0149765043129957537240873920782090593080682748646743587589`40., 
    0.0143952177934052375875674881262403873524005690009615383719`40., 
    0.0138573184915750077052591786644199034970767698578441123819`40., 
    0.013358128608604633165716963371130667525363565779488577195`40., 
    0.0128936188051866095880306412646495753497027595511825163036`40., 
    0.0124602997042058560276495602305659837936160469964760971554`40., 
    0.0120551344526904152541348592503762449846638339133175880882`40., 
    0.0116754677276722007716703253095000927930978061963394891361`40., 
    0.0113189676905353296708192907184420312792906538354072771413`40., 
    0.0109835782179179388467507378173587562745651224997525267206`40., 
    0.0106674793488656105604082419394363824881710488664421317225`40., 
    0.0103690543465453357467427538677537929601937704754252884432`40., 
    0.0100868621197776375204499787202313507994625343710521406676`40.}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.917509612971449*^9, {3.917510042462212*^9, 3.91751013051343*^9}, 
   3.9175105360460577`*^9, {3.917510567359405*^9, 3.9175105881155643`*^9}, 
   3.9175106781907263`*^9, 3.917523757633593*^9, 3.917524006025263*^9, 
   3.917524116928237*^9},
 CellLabel->
  "During evaluation of \
In[1970]:=",ExpressionUUID->"c83887b2-4987-42ff-aeb2-9f0df3c8e9f9"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1512, 916},
WindowMargins->{{0, Automatic}, {Automatic, 618}},
FrontEndVersion->"13.0 for Mac OS X ARM (64-bit) (December 2, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"f81ab908-3a6c-414a-a3ac-f38d7134052e"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 156, 3, 67, "Section",ExpressionUUID->"1c26d3f8-d1ac-4a1f-906e-5efac4bee200"],
Cell[CellGroupData[{
Cell[603, 22, 5392, 112, 304, "Input",ExpressionUUID->"ee7f37a3-85f1-43db-9747-eac52a120235"],
Cell[5998, 136, 1444, 28, 39, "Print",ExpressionUUID->"e7651957-f40b-43e4-984f-292ec4dcac25"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7491, 170, 312, 6, 67, "Section",ExpressionUUID->"c24c55e6-e98c-4360-8866-08b05abecf3d"],
Cell[CellGroupData[{
Cell[7828, 180, 158, 3, 54, "Subsection",ExpressionUUID->"0ca13e56-c88e-4c72-8db3-4dacdac83282"],
Cell[7989, 185, 514, 10, 35, "Text",ExpressionUUID->"1d8afba0-24a3-4978-8aa7-b8bf306972e3"],
Cell[CellGroupData[{
Cell[8528, 199, 4293, 92, 115, "Input",ExpressionUUID->"96de454f-1630-43ee-b110-94612399b6a1"],
Cell[12824, 293, 542, 11, 24, "Print",ExpressionUUID->"c03f6469-c662-48bb-8264-7cb61c64e9f9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13415, 310, 178, 3, 54, "Subsection",ExpressionUUID->"f723cb5f-361a-4e4e-afc0-291ebcea0db5"],
Cell[13596, 315, 3207487, 86682, 83394, "Input",ExpressionUUID->"4850b16f-1c9d-422f-846f-d775b843b59a"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3221132, 87003, 207, 4, 67, "Section",ExpressionUUID->"7b1fb80d-9d07-4632-9327-1d84f97ddc75"],
Cell[CellGroupData[{
Cell[3221364, 87011, 259, 4, 54, "Subsection",ExpressionUUID->"32fe1c87-ee80-4124-9946-b0e6f3d7ecdd"],
Cell[3221626, 87017, 19082, 457, 708, "Input",ExpressionUUID->"9e44fe3c-39f7-44f1-b8bb-c35a8eac1dad"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3240745, 87479, 277, 4, 54, "Subsection",ExpressionUUID->"4cd50976-ce15-4592-949d-9b79ee96815a"],
Cell[3241025, 87485, 379, 6, 35, "Text",ExpressionUUID->"ff637b08-7129-465b-9795-b90ad336ddbe"],
Cell[3241407, 87493, 22702, 493, 1333, "Input",ExpressionUUID->"1eec5c14-359b-4b33-b345-0baf9bdacabe"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3264158, 87992, 183, 3, 67, "Section",ExpressionUUID->"c25b4a72-14f5-45fb-ab9a-9bf6abff3ffd"],
Cell[CellGroupData[{
Cell[3264366, 87999, 6557, 183, 241, "Input",ExpressionUUID->"9a81e95f-016f-466e-956a-6569dd2c5e91"],
Cell[CellGroupData[{
Cell[3270948, 88186, 7679, 127, 196, "Print",ExpressionUUID->"5f9e710e-43f4-4213-9245-f8daecdf3511"],
Cell[3278630, 88315, 7767, 127, 215, "Print",ExpressionUUID->"ffd7d418-4d80-4cf1-a132-c623333c33ac"],
Cell[3286400, 88444, 8096, 135, 215, "Print",ExpressionUUID->"fb71d274-195b-4636-b901-ff9b482d3b1c"],
Cell[3294499, 88581, 8100, 135, 215, "Print",ExpressionUUID->"26122da3-bfab-4b81-b7da-45a346a23cd8"],
Cell[3302602, 88718, 8096, 135, 215, "Print",ExpressionUUID->"1175a6a9-1c56-4c5e-a28f-9e769dd0b76e"],
Cell[3310701, 88855, 6085, 89, 196, "Print",ExpressionUUID->"c83887b2-4987-42ff-aeb2-9f0df3c8e9f9"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)
